unit u_ExcelFile;

interface
uses
	Graphics, SysUtils, variants;

const
  versionOffice2007 = 12.0;

type
  TDAOfVariant = array of variant;
  TPaletaColoresExcel = array [1..56] of TColor;

	T_ExcelFile= class
    private
      //La proxima posicin a llenar del buffer
      iBuffer: Integer;
      buffer: TDAOfVariant;
    public
      v: variant; // el workbook
      ha: variant; // hoja activa;
      r: variant; // rango activo;
      international: variant;

      fila, columna: integer; // puntero en la hoja activa
      autocierre: boolean;
      avisoCierre: boolean;

      constructor Create( nombreHoja1: string; visible: boolean; autocierre, avisocierre: boolean );

  //		constructor CreateLoad( nombre: string; visible: boolean );
      procedure Guardar( nombre: string );
      procedure Abrir (nombArchivo: string );
      procedure agregoLibro;
      procedure agregoHoja( nombreHoja: string );
      function Hoja( numeroHoja: integer ): Variant; overload;
      function Hoja( nombreHoja: string ): Variant; overload;
      procedure EscribirCeldaHojaActual(fila:integer; columna:integer; contenido:variant);
      procedure EscribirCelda(nombreHoja:string; fila:integer; columna:integer; contenido:variant);
      procedure EscribirCeldaTexto(nombreHoja:string; fila:integer; columna:integer; contenido:string);
      function ContenidoCelda(nombreHoja:string; var fila:integer; columna:integer; incrementa:boolean): variant;
      procedure Cerrar( conAviso: boolean );
      procedure Free;
      procedure VisibleOn;
      procedure VisibleOff;

  // agregado por comodidad.
      procedure ActivoHoja_nombre( nombreHoja: string ); overload;
      procedure ActivoHoja_numero( numeroHoja: integer ); overload;
      procedure ir( fila, columna : integer );
      procedure irr( dfila, dcolumna: integer);

      function ReadV: variant;
      procedure readln;

  (* estas dos son redundantes pero las agrego por comodidad *)
      procedure Write( contenido: variant );
      procedure go( NombreHoja: string; fila, columna: integer );
  (*.............................................................*)

      //Retorna la letra de la columna nroCol
      function nroColToExcelCol(nroCol: Cardinal): String;

      //cambia el tamanio del buffer
      procedure setTamanioBuffer(nCeldas: Integer);
      //Almacena los datos que se piden escribir en un buffer, los datos no se
      //bajan al excel hasta que se haga un llamado a WriteLnBuffer o el buffer
      //se llena. No usar en combinacion con otros writes. Esto es entre que se
      //hace una llamada WriteBuffereado y su correspondiente llamada a WriteLnBuffer
      //no debe llamarse otro write o se perdera el orden de las columnas
      procedure WriteBuffereado(const contenido: variant );
      procedure WriteLnBuffer;
      function columnaBuffereada: Integer;

      procedure WriteV( contenido: variant );
      //Escribe una fila entera de valores
      procedure WriteFila(const contenido: TDAOfVariant);
      procedure WriteLnFila(const contenido: TDAOfVariant);
      procedure WriteF( contenido: variant; formato: string );
      procedure WriteMAF( contenido: variant; celdas: integer; alineacion: integer; formato: string );
      procedure writeln( contenido: variant ); overload; // fila:=fila+1; columna:= 1
      procedure writeln; overload;

      function ref( fila, columna:integer ): string;
      function ref_rango( f1,c1, f2,c2: integer): string;

      procedure SelRango( fil1, col1, fil2,col2: integer);
      procedure BordeSimple(ancho: integer;
                             Arriba, Derecha, Abajo, Izquierda,
                             InteriorVertical, InteriorHorizontal: boolean);

      procedure CambiarFuente( nuevafuente: string);
      procedure CambiarTamFuente( nuevotam: integer);

  // cambio de color usando ColorIndex
      procedure CambiarColorFuente_ci( nuevoci: integer );
      procedure CambiarColorFondo_ci( nuevoci: integer );

  // cambio de color usuando un TColor
      procedure CambiarColorFuente_cl( nuevoCol: TColor );
      procedure CambiarColorFondo_cl( nuevoCol: TColor );

      procedure CambiarFormato( nuevoFormato: string );
      procedure CambiarAncho( nuevoAncho: integer);
      procedure CambiarAlto( nuevoAlto: integer );
      procedure CambiarFormula( nuevaFormula: string );
      procedure CombinarCeldas;

      procedure AlinearDerecha;
      procedure AlinearIzquierda;
      procedure AlinearCentro;
      procedure WrapTextON;
      procedure WrapTextOFF;
      procedure BoldON;
      procedure BoldOFF;
      procedure InsertarImagen( archi: string; x, y: double );
      procedure Zoom( porciento: integer );

  // acomada para imprimir
      procedure SetPage(  PaginaVertical: boolean );
      //Retorna true si el libro del T_ExcelFile esta abierto.
      //Si se cerro el EXCEL sin liberar el T_ExcelFile retorna false
      function libroAbierto: boolean;

      procedure autoFitCells;

      //Retorna la cantidad de filas k entre la celda actual (x,y) y la primer
      //celda (x + k, y) cuyo contenido est en blanco. El cursor queda en la
      //celda (x, y)
      function contarFilasHastaBlanco: Integer;
      //Retorna la cantidad de columnas k entre la celda actual (x,y) y la primer
      //celda (x, y + k) cuyo contenido est en blanco. El cursor queda en la
      //celda (x, y)
      function contarColumnasHastaBlanco: Integer;

      function getPaletaColores: TPaletaColoresExcel;
      procedure setPaletaColores(nuevaPaleta: TPaletaColoresExcel);

      //12 = office 2007
      function version: Double;


  end;

//agrega los colores en coloresATenerEnLaPaleta si no existen en la paleta
//actual intentando poner los colores nuevos sobre el final
function corregirPaletaColores(const coloresATenerEnLaPaleta: array of TColor; const paletaACorregir: TPaletaColoresExcel): TPaletaColoresExcel;
function getColorIndex(color: TColor; const paleta: TPaletaColoresExcel): Integer;

const
  paletaExcelPorDefecto: TPaletaColoresExcel = (0, 16777215, 255, 65280, 16711680, 65535, 16711935, 16776960, 128, 32768, 8388608, 32896, 8388736, 8421376, 12632256, 8421504, 16751001, 6697881, 13434879, 16777164, 6684774, 8421631, 13395456, 16764108, 8388608, 16711935, 65535, 16776960, 8388736, 128, 8421376, 16711680, 16763904, 16777164, 13434828, 10092543, 16764057, 13408767, 16751052, 10079487, 16737843, 13421619, 52377, 52479, 39423, 26367, 10053222, 9868950, 6697728, 6723891, 13056, 13107, 13209, 6697881, 10040115, 3355443);

	ciCanela  = 40;
//	ciAmarilloClaro =36;
	ciVerdeClaro= 35;
	ciTurquesaClaro= 34;
	ciAzulPalido= 37;
	ciLavanda= 39;
	ciAnil= 55;
	ciBlanco= 2;

	alDerecha= 1;
	alIzquierda=2;
	alCentro= 3;
	alNada= 0;


function rgb( r, g, b: byte ): TColor;
procedure extractRGB(color: TColor; var r, g, b: byte);
function BGRToRGB(colorBGR: TColor): TColor;

implementation
uses
	ComObj, XLConst;

function rgb( r, g, b: byte ): TColor;
begin
	result:= (b * 256 + g) * 256 + r;
end;

procedure extractRGB(color: TColor; var r, g, b: byte);
begin
  r:= Color and $ff;
  g:= (Color and $ff00) shr 8;
  b:= (Color and $ff0000) shr 16;
end;

function BGRToRGB(colorBGR: TColor): TColor;
begin
  result:= (colorBGR and $ff) shl 16 +
           (colorBGR and $ff00) shl 8 +
           (colorBGR and $ff0000);
end;

procedure T_ExcelFile.ir( fila, columna : integer );
begin
	self.Fila:=fila;
	self.columna:= columna;
end;

procedure T_ExcelFile.irr( dfila, dcolumna: integer);
begin
	fila:= fila + dfila;
	columna:= columna+ dcolumna;
end;

function T_ExcelFile.ref( fila, columna:integer ): string;
var
  scol: shortstring;
  kcol, dig: integer;
begin
  scol:= '';
  kcol:= columna -1 ;
  while kcol >= 0 do
  begin
    dig:= kcol mod 26;
    scol:= chr( ord('A')+dig ) + scol;
    kcol:= (kcol div 26 )-1;
  end;

	result:= scol+intToStr(fila);
end;

function T_ExcelFile.ref_rango( f1,c1, f2,c2: integer): string;
begin
	result:= ref(f1,c1)+':'+ref(f2,c2);
end;

procedure T_ExcelFile.SelRango( fil1, col1, fil2,col2: integer);
begin
  {$IFDEF FPC}
  r := ha.Range(ref_rango( fil1, col1, fil2, col2 ));
  {$ELSE}
  r := ha.Range[ref_rango( fil1, col1, fil2, col2 )];
  {$ENDIF}
end;


procedure T_ExcelFile.CambiarFuente( nuevafuente: string);
begin
	r.Font.name:= nuevaFuente;
end;

procedure T_ExcelFile.BordeSimple(ancho: integer;
      Arriba, Derecha, Abajo, Izquierda,
      InteriorVertical, InteriorHorizontal: boolean);
begin

    r.Borders[xlDiagonalDown].LineStyle := xlNone;
    r.Borders[xlDiagonalUp].LineStyle := xlNone;

   if Izquierda then
   begin
    r.Borders[xlEdgeLeft].LineStyle := xlContinuous;
    r.Borders[xlEdgeLeft].Weight := ancho;
    r.Borders[xlEdgeLeft].ColorIndex := xlAutomatic;
   end;
{
   else
    r.Borders[xlEdgeLeft].LineStyle := xlNone;
 }
   if Arriba then
   begin
    r.Borders[xlEdgeTop].LineStyle := xlContinuous;
    r.Borders[xlEdgeTop].Weight := ancho;
    r.Borders[xlEdgeTop].ColorIndex := xlAutomatic;
   end;
{
   else
    r.Borders[xlEdgeTop].LineStyle := xlNone;
 }

   if Abajo then
   begin
    r.Borders[xlEdgeBottom].LineStyle := xlContinuous;
    r.Borders[xlEdgeBottom].Weight := ancho;
    r.Borders[xlEdgeBottom].ColorIndex := xlAutomatic;
   end;
{
   else
    r.Borders[xlEdgeBottom].LineStyle := xlNone;
 }

   if Derecha then
   begin
    r.Borders[xlEdgeRight].LineStyle := xlContinuous;
    r.Borders[xlEdgeRight].Weight := ancho;
    r.Borders[xlEdgeRight].ColorIndex := xlAutomatic;
   end;
{
   else
    r.Borders[xlEdgeRight].LineStyle := xlNone;
 }

   if InteriorHorizontal and (r.Rows.Count > 1 ) then
   begin
    r.Borders[xlInsideHorizontal].LineStyle := xlContinuous;
    r.Borders[xlInsideHorizontal].Weight := ancho;
    r.Borders[xlInsideHorizontal].ColorIndex := xlAutomatic;
   end;
{
   else
    r.Borders[xlInsideHorizontal].LineStyle := xlNone;

 }

   if InteriorVertical and (r.Columns.Count > 1 )then
   begin
    r.Borders[xlInsideVertical].LineStyle := xlContinuous;
    r.Borders[xlInsideVertical].Weight := ancho;
    r.Borders[xlInsideVertical].ColorIndex := xlAutomatic;
   end;
{
   else
    r.Borders[xlInsideVertical].LineStyle := xlNone;
}
end;

procedure T_ExcelFile.CambiarTamFuente( nuevotam: integer);
begin
	r.Font.Size:= nuevoTam;
end;

procedure T_ExcelFile.CambiarColorFuente_ci( nuevoci: integer );
begin
	r.Font.ColorIndex:= nuevoci;
end;

procedure T_ExcelFile.BoldON;
begin
	r.Font.Bold:= True;
end;

procedure T_ExcelFile.BoldOFF;
begin
	r.Font.Bold:= False;
end;

procedure T_ExcelFile.CambiarColorFondo_ci( nuevoci: integer );
begin
  r.Columns.Interior.ColorIndex := nuevoci;
end;

procedure T_ExcelFile.CambiarColorFuente_cl( nuevoCol: TColor );
begin
	r.Font.Color:= nuevoCol;
end;

procedure T_ExcelFile.CambiarColorFondo_cl( nuevoCol: TColor );
begin
  r.Columns.Interior.Color := nuevoCol;
end;

procedure T_ExcelFile.CambiarFormato( nuevoFormato: string );
begin
	r.NumberFormat:= nuevoFormato; // '0.00' por ejemplo, o 'd/m/yy h:mm'
end;

procedure T_ExcelFile.CambiarAncho( nuevoAncho: integer);
begin
	r.Columns.ColumnWidth:= nuevoAncho;
end;

procedure T_ExcelFile.CambiarAlto( nuevoAlto: integer );
begin
	r.Rows.RowHeight:= nuevoAlto;
end;

procedure T_ExcelFile.CambiarFormula( nuevaFormula: string );
begin
	r.Formula := nuevaFormula; // Por Ej.: nuevaFormula:= '=RAND()';
end;

procedure T_ExcelFile.CombinarCeldas;
begin
	r.Merge;
end;


procedure T_ExcelFile.AlinearDerecha;
begin
	r.HorizontalAlignment:= xlRight;
end;

procedure T_ExcelFile.AlinearIzquierda;
begin
	r.HorizontalAlignment:= xlLeft;
end;

procedure T_ExcelFile.AlinearCentro;
begin
	r.HorizontalAlignment:= xlCenter;
end;

procedure T_ExcelFile.WrapTextON;
begin
	r.WrapText:= True;
end;

procedure T_ExcelFile.WrapTextOFF;
begin
	r.WrapText:= False;
end;

procedure T_ExcelFile.Zoom( porciento: integer );
begin
  v.ActiveWindow.Zoom:= porciento;
end;


function T_ExcelFile.ReadV: variant;
begin
	result:= ha.cells[fila, columna];
	inc(columna );
end;

procedure T_ExcelFile.readln;
begin
	fila:= fila+1;
	columna:= 1;
end;

procedure T_ExcelFile.WriteMAF( contenido: variant; celdas: integer; alineacion: integer; formato: string );
begin
	writev( contenido );
  	selRango( fila, columna-1, fila, columna - 1 + celdas -1 );

   if celdas > 0 then
      combinarCeldas;

	case alineacion of
	alDerecha: AlinearDerecha;
	alIzquierda: AlinearIzquierda;
	alCentro: AlinearCentro;
	end;
	if formato <> '' then
		cambiarFormato( formato );
	columna:= columna + celdas -1;
end;

constructor T_ExcelFile.Create( nombreHoja1: string; visible, autocierre,avisocierre: boolean );
{var
h: variant;}
begin
	self.autocierre:= autocierre;
	self.avisocierre:= avisocierre;

	inherited Create;
	v:= CreateOleObject('Excel.Application');
	v.visible := visible;
	if nombreHoja1 <> '' then
	begin
		v.Workbooks.Add(xlWBatWorkSheet);
		v.Workbooks[1].WorkSheets[1].Name:= nombreHoja1;
		ActivoHoja_nombre( nombreHoja1 );
	end;
  SetLength(buffer, 255); //tamao para un libro excel 2003
end;

function T_ExcelFile.Hoja( numeroHoja: integer ): Variant;
begin
  result:= v.Workbooks[1].Sheets[numeroHoja];
end;

function T_ExcelFile.Hoja( nombreHoja: string ): Variant;
begin
  {$IFDEF FPC}
	result:= v.Workbooks[1].Sheets(nombreHoja);
  {$ELSE}
	result:= v.Workbooks[1].Sheets[nombreHoja];
  {$ENDIF}
end;

procedure T_ExcelFile.ActivoHoja_nombre( nombreHoja: string );
begin
  {$IFDEF FPC}
	ha := v.Workbooks[1].Sheets(nombreHoja);
  {$ELSE}
	ha := v.Workbooks[1].Sheets[nombreHoja];
  {$ENDIF}
  ha.Select;
	fila:= 1;
	columna:= 1;
end;

procedure T_ExcelFile.ActivoHoja_numero( numeroHoja: integer );
begin
	ha:=v.Workbooks[1].Sheets[numeroHoja];
  ha.Select;
	fila:= 1;
	columna:= 1;
end;


procedure T_ExcelFile.go( NombreHoja: string; fila, columna: integer );
begin
  ActivoHoja_nombre( NombreHoja );
  ir( fila, columna );

end;

procedure T_ExcelFile.SetPage(  PaginaVertical: boolean );
begin
   ha.PageSetup.LeftHeader := '';
   ha.PageSetup.CenterHeader := '';
   ha.PageSetup.RightHeader := '';
   ha.PageSetup.LeftFooter := '';
   ha.PageSetup.CenterFooter := '';
   ha.PageSetup.RightFooter := '';
   ha.PageSetup.LeftMargin := v.Application.InchesToPoints(0.78740157480315/2);
   ha.PageSetup.RightMargin := v.Application.InchesToPoints(0.78740157480315/2);
   ha.PageSetup.TopMargin := v.Application.InchesToPoints(0.78740157480315);
   ha.PageSetup.BottomMargin := v.Application.InchesToPoints(0.78740157480315);
   ha.PageSetup.HeaderMargin := v.Application.InchesToPoints(0);
   ha.PageSetup.FooterMargin := v.Application.InchesToPoints(0);
   ha.PageSetup.PrintHeadings := False;
   ha.PageSetup.PrintGridlines := False;
   ha.PageSetup.PrintComments := xlPrintNoComments;
//   ha.PageSetup.PrintQuality := 360;
   ha.PageSetup.CenterHorizontally := False;
   ha.PageSetup.CenterVertically := False;
   if PaginaVertical then
     ha.PageSetup.Orientation := xlPortrait
   else
     ha.PageSetup.Orientation := xlLandscape;
{
   ha.PageSetup.Draft := False;
   ha.PageSetup.PaperSize := xlPaperA4;
   ha.PageSetup.FirstPageNumber := xlAutomatic;
   ha.PageSetup.Order := xlDownThenOver;
   ha.PageSetup.BlackAndWhite := False;
}
   ha.PageSetup.Zoom := False;
   ha.PageSetup.FitToPagesWide := 1;
   ha.PageSetup.FitToPagesTall := 7;
//    ActiveWindow.SelectedSheets.PrintOut Copies:=1, Preview:=True
end;

function T_ExcelFile.libroAbierto: boolean;
begin
  result:= v.workbooks.Count > 0;
end;

procedure T_ExcelFile.autoFitCells;
var
  celda: String;
begin
  ha.Cells.Select;
  ha.Cells.EntireColumn.AutoFit;
  celda := nroColToExcelCol(columna) + IntToStr(fila);
  ha.Range[celda, celda].Select;
end;

function T_ExcelFile.contarFilasHastaBlanco: Integer;
var
  filaInicial, columnaInicial, res: Integer;
  contenidoCelda: String;
  celdaEnBlanco: boolean;
begin
  filaInicial := self.fila;
  columnaInicial := self.columna;
  res := 0;
  contenidoCelda := self.ReadV;
  celdaEnBlanco := contenidoCelda = '';
  while not celdaEnBlanco do
  begin
    res := res + 1;
    self.ir(filaInicial + res, columnaInicial);
    contenidoCelda := self.ReadV;
    celdaEnBlanco := contenidoCelda = '';
  end;
  self.ir(filaInicial, columnaInicial);
  Result := res;
end;

function T_ExcelFile.contarColumnasHastaBlanco: Integer;
var
  filaInicial, columnaInicial, res: Integer;
  contenidoCelda: String;
  celdaEnBlanco: boolean;
begin
  filaInicial := self.fila;
  columnaInicial := self.columna;
  res := 0;
  contenidoCelda := self.ReadV;
  celdaEnBlanco := contenidoCelda = '';
  while not celdaEnBlanco do
  begin
    res := res + 1;
    self.ir(filaInicial, columnaInicial + res);
    contenidoCelda := self.ReadV;
    celdaEnBlanco := contenidoCelda = '';
  end;
  self.ir(filaInicial, columnaInicial);
  Result := res;
end;

function T_ExcelFile.getPaletaColores: TPaletaColoresExcel;
var
  i: Integer;
  res: TPaletaColoresExcel;
  paleta: variant;
begin
  paleta:= v.workbooks[1].Colors;
  for i:= low(res) to high(res) do
    res[i]:= paleta[i];
  result:= res;
end;

procedure T_ExcelFile.setPaletaColores(nuevaPaleta: TPaletaColoresExcel);
var
  i: Integer;
//  r, g, b: byte;
begin
  for i:= low(nuevaPaleta) to high(nuevaPaleta) do
    v.workbooks[1].Colors[i]:= nuevaPaleta[i];

{  paleta:= v.workbooks[1].Palette;
  for i:= low(nuevaPaleta) to high(nuevaPaleta) do
  begin
    extractRGB(nuevaPaleta[i], r, g, b);
    paleta.SetColorAt(i, r, g, b);
  end;}
end;

function T_ExcelFile.version: Double;
begin
  result:= v.Version;
end;

procedure T_ExcelFile.setTamanioBuffer(nCeldas: Integer);
var
  nuevoBuffer: TDAOfVariant;
  i: Integer;
begin
  if Length(buffer) <> nCeldas then
  begin
    SetLength(nuevoBuffer, nCeldas);
    for i:= 0 to iBuffer - 1 do
      nuevoBuffer[i]:= buffer[i];
    SetLength(buffer, 0);
    buffer:= nuevoBuffer;
  end;
end;

procedure T_ExcelFile.WriteBuffereado(const contenido: variant );
begin
  if iBuffer < Length(buffer) then
  begin
    buffer[iBuffer]:= contenido;
    iBuffer:= iBuffer + 1;
  end
  else
  begin
    WriteFila(copy(buffer, 0, iBuffer - 1));
    iBuffer:= 0;
  end;
end;

procedure T_ExcelFile.WriteLnBuffer;
begin
  if iBuffer > 0 then
  begin
    WriteLnFila(copy(buffer, 0, iBuffer));
    iBuffer:= 0;
  end;
end;

function T_ExcelFile.columnaBuffereada: Integer;
begin
  result:= columna + iBuffer;
end;

procedure T_ExcelFile.WriteV( contenido: variant );
begin
	ha.cells[fila, columna]:= contenido;
	inc(columna );
end;

procedure T_ExcelFile.WriteFila(const contenido: TDAOfVariant);
var
  celdaDesde, celdaHasta: String;
  filaStr: String;
begin
  if length(contenido) > 0 then
  begin
    filaStr:= IntToStr(fila);
    celdaDesde:= nroColToExcelCol(columna) + filaStr;
    celdaHasta:= nroColToExcelCol(columna + high(contenido)) + filaStr;
    columna:= columna + Length(contenido);

    ha.Range[celdaDesde, celdaHasta].Value:= VarArrayOf(contenido);
  end;
end;

procedure T_ExcelFile.WriteLnFila(const contenido: TDAOfVariant);
var
  celdaDesde, celdaHasta: String;
  filaStr: String;
begin
  if length(contenido) > 0 then
  begin
    filaStr:= IntToStr(fila);
    celdaDesde:= nroColToExcelCol(columna) + filaStr;
    celdaHasta:= nroColToExcelCol(columna + high(contenido)) + filaStr;
    columna:= 1;
    fila:= fila + 1;

    ha.Range[celdaDesde, celdaHasta].Value:= VarArrayOf(contenido);
  end;
end;

function T_ExcelFile.nroColToExcelCol(nroCol: Cardinal) : String;
var
  res: String;
  digitos, offset, limite, c: Cardinal;
begin
  digitos:= 1;
  offset:= 0;
  nroCol:= nroCol - 1;
  limite:= 26;
  while (nroCol >= limite + offset) do
  begin
    offset:= offset + limite;
    limite:= limite * 26;
    digitos:= digitos + 1;
  end;

  res:= '';
  c:= nroCol - offset;
  while digitos > 0 do
  begin
    digitos:= digitos - 1;
    res:= Chr(Ord('A') + c mod 26) + res;
    c:= c div 26;
  end;

  Result:= res;
end;

procedure T_ExcelFile.Write( contenido: variant );
begin
	ha.cells[fila, columna]:= contenido;
	inc(columna);
end;

procedure T_ExcelFile.WriteF( contenido: variant; formato: string );
begin
	ha.cells[fila, columna]:= contenido;
	ha.cells[fila, columna].NumberFormat:= formato;
	inc(columna );
end;

procedure T_ExcelFile.writeln; // fila:=fila+1; columna:= 1
begin
	inc(fila);
	columna:= 1;
end;

procedure T_ExcelFile.writeln( contenido: variant );
begin
  WriteV( contenido );
  writeln;
end;

procedure T_ExcelFile.InsertarImagen( archi: string; x, y: double );
var
	s: variant;
//  n: integer;
begin
  (*
	ha.Pictures.Insert(archi);
  n:= ha.Pictures.Count;
	s:= ha.Pictures[n];
	s.Left:= x; s.Top:= y;
  *)
if ( FileExists( archi ) ) then
begin
  s:= ha.Pictures.Insert(archi);
  s.ShapeRange.IncrementLeft( x - s.ShapeRange.width * 1.2 );
  s.ShapeRange.IncrementTop( y + (s.ShapeRange.height / 3.0 ) );
end;
end;

procedure T_ExcelFile.EscribirCeldaHojaActual(fila:integer; columna:integer; contenido:variant);
begin
  ha.cells[fila, columna]:= contenido;
end;

procedure T_ExcelFile.EscribirCelda(nombreHoja:string; fila:integer; columna:integer; contenido:variant);
var
	h:variant;
begin
	h:= self.Hoja(nombreHoja);
	h.cells[fila, columna]:= contenido;
end;

procedure T_ExcelFile.EscribirCeldaTexto(nombreHoja:string; fila:integer; columna:integer; contenido:string);
var
	h:variant;
begin
	h:= self.Hoja(nombreHoja);
	h.cells[fila, columna]:= contenido;
end;

function T_ExcelFile.ContenidoCelda(nombreHoja:string; var fila:integer; columna:integer; incrementa:boolean):variant;
var
	h:variant;
begin
//	h:= v.Workbooks[1].WorkSheets[1];
	h:= self.Hoja(nombreHoja);
	result:= h.cells[fila, columna];
	if incrementa then
		inc(fila);
end;


procedure T_ExcelFile.Guardar( nombre: string );
begin
	v.Workbooks[1].SaveAs(	nombre, xlNormal, '', '', false, false );
{
	FileName:="C:\Mis documentos\Hoja1.xls",
	FileFormat:= xlNormal,
	Password:="",
	WriteResPassword:="",
	ReadOnlyRecommended:=False,
	CreateBackup:=False );}
end;

procedure T_ExcelFile.Abrir( nombArchivo: string );
begin
	v.Workbooks.Open (nombArchivo);
end;

procedure T_ExcelFile.agregoLibro;
begin
  v.Workbooks.Add(xlWBatWorkSheet);
end;

procedure T_ExcelFile.agregoHoja( nombreHoja: string );
begin
// v.Workbooks[1].Sheets.count
	v.Workbooks[1].Sheets.Add(,,1,xlWorksheet); // el 1 es una hoja
	v.Workbooks[1].WorkSheets[1].name:= nombreHoja;
end;

procedure T_ExcelFile.Free;
begin
	if autocierre and not VarIsEmpty(v) then
	begin
		v.DisplayAlerts := avisocierre;
		v.Quit;
  end;
  SetLength(buffer, 0);
	inherited Free;
end;

procedure T_ExcelFile.Cerrar( conAviso: boolean );
begin
	if not VarIsEmpty(v) then
	begin
	  v.DisplayAlerts := conAviso;
	  v.Quit;
  end;
end;

procedure T_ExcelFile.VisibleOn;
begin
	v.Visible:= true;
end;

procedure T_ExcelFile.VisibleOff;
begin
	v.Visible:= false;
end;

function iColorEnPaleta(color: TColor; const arreglo: TPaletaColoresExcel): Integer;
var
  i, res: Integer;
begin
  res:= -1;
  for i:= Low(arreglo) to High(arreglo) do
    if arreglo[i] = color then
    begin
      res:= i;
      break;
    end;
  result:= res;
end;

function corregirPaletaColores(const coloresATenerEnLaPaleta: array of TColor; const paletaACorregir: TPaletaColoresExcel): TPaletaColoresExcel;
var
  res: TPaletaColoresExcel;
  i, j: Integer;
  iColoresATenerEnLaPaleta: Integer;
  //Cual es la posicin en paletaACorregir que contiene al color coloresATenerEnLaPaleta[i]
  matchColor: array of Integer;
  matcheaConOtro: Boolean;
begin
  if Length(coloresATenerEnLaPaleta) > high(paletaACorregir) then
    raise Exception.Create('uExcelFile.corregirPaletaColores: esta intentando agregar mas de ' + IntToStr(High(paletaACorregir)) + ' a la paleta de colores de Excel, pero su versin no lo soporta.' +
                           'Intente utilizar mas colores en comn entre los distintos grficos y vuelva a intentarlo.');

  SetLength(matchColor, length(coloresATenerEnLaPaleta));
  for i:= 0 to High(coloresATenerEnLaPaleta) do
    matchColor[i]:= iColorEnPaleta(coloresATenerEnLaPaleta[i], paletaACorregir);

  res:= paletaACorregir;
  i:= high(res);
  for iColoresATenerEnLaPaleta:= High(coloresATenerEnLaPaleta) downto 0 do
  begin
    if matchColor[iColoresATenerEnLaPaleta] = -1 then
    begin
      //busco el primer i que no matchee ningun color
      repeat
        matcheaConOtro:= false;
        for j:= 0 to High(matchColor) do
          if matchColor[j] = i then
          begin
            matcheaConOtro:= true;
            i:= i - 1;
            break;
          end;
      until not matcheaConOtro;

      res[i]:= coloresATenerEnLaPaleta[iColoresATenerEnLaPaleta];
      i:= i - 1;
    end;
  end;

  result:= res;
end;

function getColorIndex(color: TColor; const paleta: TPaletaColoresExcel): Integer;
var
  i, res: Integer;
begin
  res:= -1;
  for i:= Low(paleta) to High(paleta) do
    if color = paleta[i] then
    begin
      res:= i;
      break;
    end;
  result:= res;
end;



end.
