{xDEFINE PSO_ENZO}
{xDEFINE PERTURBADO}
{xDEFINE CHEQUEOMEM}
{xDEFINE ESTABILIZAR_FRAMEINICIAL}
{$DEFINE SPXMEJORCAMINO}
{$IFNDEF SUPRIMIR_DUMP_TEXT}
 {$DEFINE DUMP_TEXT_SIMRES}
 {$DEFINE DUMP_TEXT_OPTRES}
{$ENDIF}

{xDEFINE OPT_VE_VERBOSA}
{xDEFINE DEBUG_OPTIMIZACION}
{$DEFINE CALC_CF_INICIO_PASO}

unit usalasdejuego;

{$MODE Delphi}

interface


uses
{$IFDEF CHEQUEOMEM}
  udbgutil,
{$ENDIF}
  Classes, SysUtils,
  Math,
  uglobs,
  uconstantesSimSEE,
  xmatdefs,
{$IFDEF WINDOWS}
{$IFNDEF APLICACION_CONSOLA}
  uExcelFile,
{$ENDIF}
{$ENDIF}

{$IFDEF MIPSimplex}
{$IFDEF SPXMEJORCAMINO}
  umipsimplex_mejorcamino,
{$ELSE}
  umipsimplex,
{$ENDIF}
{$ELSE}
  usimplex,
{$ENDIF}
  uActores, ucosa, uCosaConNombre,
  ucosaparticipedemercado,
  ufechas,
  uNodos,
  uArcos,
  uGeneradores,
  uDemandas,
  uComercioInternacional,
  uMercadoSpot,
  uGTer,
  uEstados,
  uFuentesAleatorias,
  uCombustible,
  uSuministroCombustible,
  uGNLSumIntermedio,
  uGNLSuministroMultiCliente,
  uGNLSuministroCombustibleSimple,
  uGNLSumConector,
  uGNLSumComb_TakeOrPay_Spot,
  uGNLProveedor,
  uGNLPlanta,
  uGNLManejadorCuentas,
  uGNLListaContratoSuministro,
  uGNLItemCuenta,
  uGNLGasoducto,
  uGNLCuentas,
  uGNLContratoSuministro,
  uGNLConceptos,
  uGNLBOG,
  uGNLBalance,
  uSuministroCombustible_TakeOrPay,
  uUsoGestionable_postizado,
  ulistaplantillassr3,
  uescenarios,
{$IFNDEF FPC}
  shellapi,
{$ELSE}
  //  FileUtil,
{$ENDIF}
  uEsclavizador,
  uEsclavizadorSobreMuestreado,
{$IFDEF WINDOWS}
  {$IFDEF FPCLCL}
  LCLIntf, lcltype,
  {$ELSE}
  Windows,
  {$ENDIF}
{$ELSE}
{$ENDIF}
  uEsclavizadorSubMuestreado,
  uAuxiliares,
  uHidroConEmbalse,
  uHidroConBombeo,
  uActorNodal,
{$IFDEF ITERADOR_FLUCAR}
  uiteradoressimsee,
{$ENDIF}
  ucontroladordeterminista,
{$IFDEF PSO_ENZO}
  uniform, particulas,
{$ELSE}
  fddp,
{$ENDIF}
  uacumuladores_sim,

{$IFDEF SMART_VAR_DUMP}
  uLectorSimRes3Defs,
  uHistoVarsOps,
  uVarDefs,
{$ENDIF}

  uversiones;


(*
const // OJO no poner estos string como resourcestrings pues son constantes.
  csGlobs = 'Globs';
  csGeneradores = 'Generadores';
  csDemandas = 'Demandas';
  csNodos = 'Nodos';
  csArcos = 'Arcos';
  csComercioInternacional = 'Comercio Internacional';
  csListaActores = 'Lista de Actores';
  csFuentesAleatorias = 'Fuentes Aleatorias';
  csEnganchesContinuos = 'EnganchesContinuos';
  csEnganchesDiscretos = 'EnganchesDiscretos';
  csFuentesReemplazadas = 'FuentesReemplazadas';
  csCombustibles = 'Combustibles';
*)
type
  TDAOfTextFile = array of TextFile;


  // record para servir de respuesta de la funcin locate de la sala.
  TRec_Lst_CosaConNombre = record
    lst: TListaDeCosasConNombre;
    cosa: TCosaConNombre;
  end;



  { TSalaDeJuego }

  TSalaDeJuego = class(TCosaParticipeDeMercado)
  private
    //Variables publicadas en la simulacin
    costoDirectoDelpaso: NReal;
    utilidadDirectaDelPaso: NReal;

    // tiene el acumulado de los actores. Se carga en LeerSolucion de la Sala
    costoDelPaso_spx, CF_AlInicioDelPaso, CFaux_AlInicioDelPaso: NReal;
    procedure InicializarSimulacion_subproc01(print: boolean);

  public
    idHilo: integer;
    {$IFDEF DEBUG_MULTI_HILO}
    fdebug_mh: textfile;
    {$ENDIF}

    globs: TGlobs;

    // listas de todos los actores en la Sala.
    listaActores: TListaDeCosasConNombre; {of TActor}
    // lista de todas las fuentes en la Sala.
    listaFuentes: TListaDeCosasConNombre; {of IFuenteAleatoria}
    // lista todos los tipos de combustibles en la Sala

    listaCombustibles: TListaDeCosasConNombre; {of TCombustible}

    // lista de Escenarios.
    Escenarios: TListaEscenarios;


    // lista de plantillas SimRes3 asociadas a esta sala.
    listaPlantillasSimRes3: TListaPlantillasSimRes3;
    //Contiene las fuentes que hayan sido reemplazadas por algn esclavizador
    listaFuentesReemplazadas: TListaDeCosasConNombre;

    // Escenario Activo
    EscenarioActivo: TEscenario_rec;

    // Listas para soporte clasificado de los actores
    Nods_: TListaDeCosasConNombre;
    Arcs_: TListaDeCosasConNombre;
    Gens_: TListaDeCosasConNombre;
    Dems_: TListaDeCosasConNombre;

    Sums: TListaDeCosasConNombre {of Suministros de combustible};

    ComercioInternacional_: TListaDeCosasConNombre;
    UsosGestionables: TLIstaDeCosasConNombre;

    // listas auxiliares para acelerar los barridos
    lst_barridoFijarEstadoDeActoresToEstrella: TList;
    lst_barridoFijarEstadoDeFuentesToEstrella: TList;
    lst_SorteosDelPaso_Actores: array of TActor;
    lst_opt_PrintResultados: TList;
    lst_Sim_cronicaIdInicio: TList;

    lst_actores_evolucionarEstado: TList;
    lst_fuentes_evolucionarEstado: TList;

    //      lst_actores_costoDirectoDelPaso: TList;
    lst_fuentes_costoDirectoDelPaso: TList;

    lst_Sim_Paso_Fin: TList;
    lst_CalcularGradienteDeInviersion: TList;


{$IFDEF ITERAR}
    lst_NecesitoIterar: TList;
{$IFDEF ITERADOR_FLUCAR}
    IteradorFlucar: TIteradorDePasoSimsee;
{$ENDIF}
{$ENDIF}
    termicos: array of TGter;
    actores: array of TActor;
    fuentes_: array of TFuenteAleatoria;


//    combustibles: array of TCombustible;

    //Se arman en optx_nvxs. Si la fuente original es sub_muestreada el arreglo
    //contiene el esclavizador
    fuentesConBCSinEstadoEnCF: array of TFuenteAleatoria;
    //subConjunto del arreglo fuentes de las fuentes que no registran estado en CF y tienen bornes calculados. Pueden tener variables de estado internas
    fuentesConBCConEstadoEnCF: array of TFuenteAleatoria;
    //subConjunto del arreglo fuentes de las fuentes que registran su estado en CF y tienen bornes calculados
    hidraulicos: array of TGeneradorHidraulico;

    // contadores de variables para el registro de variables por los actores
    // conjunto de variables asociadas con el planteo del Simplex.
    ivar: integer; // Contador de variables de optimizacin
    ires: integer; // Contador de restricciones
    ivae: integer; // Contador de variables Enteras en el problema de optimizacin

    // contadores de variables para el registro de variables por los actores
    // conjunto de variables asociadas con el espacio de estados.
    ivar_xr: integer; // Contador de variables de estado continuas
    ivar_xd: integer; // Contador de varialbes de estado discretas
    ivar_auxNReal: integer; // Contador de variables auxiliares de estado contnuas
    ivar_auxInt: integer; // Contador de variables auxiliares de estado discretas

{$IFDEF MIPSimplex}
    spx: TMIPSimplex;
{$ELSE}
    spx: TSimplex;
{$ENDIF}

    descripcion: string;
    archiSala: string; //El archivo de la sala de juego
    dirSala: string; // directorio del archiSala

    dirResultadosCorrida: string;
    //El directorio donde se van a salvar los resultados de
    //la corrida. Por defecto es uconstantes.getDir_bin+'/nombresala'

    estabilizarInicio: boolean;
    usarArchivoParaInicializarFrameInicial: boolean;

    usarIteradorFlucar: boolean;
    GenerarRaws: boolean;

    //El archivo desde el que se va cargar los datos para inicializar el frame inicial
    archivoCF_ParaEnganches: TArchiRef;
    archivoSala_ParaEnganches: TArchiRef;
    engancharConSala: boolean; //Si es true, el radio button seleccionado es el de sala
    engancharConSala_escenario: string; // En caso de enganachar con una sala
    // hay que indicar el escenario dentro de la sala.

    // si est definido es que queremos ir mirando durante la simulacin por
    // donde vamos en esta funcin de Costo Futuro Auxiliar.
    archivoCFAux: TArchiRef;

    escribirOptActores: boolean;

    //Los valores en los que se quiere inicializar las variables del CF archivoCF
    //que no esten en el CF de esta sala
    enganchesContinuos, enganchesDiscretos: TListaDeCosas;
    enganchar_promediando_desaparecidas: boolean;
    uniformizar_promediando: string;
    // lista de variables que luego de hacer el enganche se debe uniformizar la informacin pomediando.

    HayQueIterar_: boolean; // Variable auxiliar que determina si es necesario iterar
    // para una mejor resolucin del paso de tiempo.

    //      modoImprimirPotenciasFirmes: boolean;
    RandSeed_SincronizarAlInicioDeCadaCronica: boolean;


    fsal: TextFile;

    {$IFDEF DUMP_TEXT_OPTRES}
    fsalopen: boolean;
    fsal_opt: TDAOfTextFile;
    {$ENDIF}



    macro_ordenes: TStringList;
    macro_errMsg: WideString;
    macro_Sel: TListaDeCosasConNombre; // objetos seleccionados

    constructor Create(capa: integer; nombre: string;
      fechaIniSim, fechaFinSim, fechaGuardaSim, fechaIniOpt, fechaFinOpt: TFecha;
      DurPos: TDAOfNReal);
      reintroduce;
    constructor Create_ReadFromText(f: TArchiTexto); override;

    constructor cargarSala(archiSala, nombre_escenario_activar: string;
      abortarEnError: boolean; rama: string = ''; capas: string = '');
    { Carga la sala "archiSala" y activa el escenario "nombre_escenario_activar"
    eliminando todas las cosas de las capas no activas. Si el parmetro
    "nombre_escenario_activar" = '' no se eliminan las cosas de las capas inactivas }

    procedure WriteToText(f: TArchiTexto); override;
    procedure Free; override;

    procedure PubliVars; override;

    procedure setDirCorrida(archivoSala: string);

    procedure ActivarEscenario(nombreEscenario: string);

    //Crea los arreglos de actores  NO PUBLICA VARIABLES
    procedure Prepararse(TiempoHaciaAdelante: boolean);

    //Se publicaran solo las variables seleccionadas en las plantillas activas de SimRes3
    //En caso de error publica todas
    {$IFDEF SMART_VAR_DUMP}
    procedure publicarSoloVariablesUsadasEnSimRes3;
    {$ENDIF}

    procedure publicarTodasLasVariables;

    // prepara los Actores y Fuentes de la Lista.
    //NO PUBLICA VARIABLES
    procedure lista_Prepararse(lista: TListaDeCosasConNombre);

    // Arma una lista con la Sala, Globs, los Actores y las Fuentes y
    // llama al procedimiento lista_PrepararseYPubliVars;
    //NO PUBLICA LAS VARIABLES
    procedure Prepararse_;

    // Determina la dimensin del espacio de estado y los frames
    // de variables auxiliares que sea necesario crear.
    // retorna la suma de las dimensiones continuas y discretas
    function optx_nvxs: integer;

    // retorna la suma de variables de estado primero llama a optx_nvxs
    function ContarVariablesDeEstado: integer;
    function generarResumenTermicoPrimerasFichas: string;

    // retorna el valor esperado del CostoFuturo
    // si print = true imprime archivos sino no.
    function Simular(id_hilo: integer; print: boolean): NReal;



    // LLamada por umh_distribuidor_optsim
    procedure inicializarSimulacion(const SalaMadre: TSalaDeJuego;
      const costoFuturo, costoFuturoAuxiliar: TMatOfNReal);

    // retorna el valor esperado del CostoFutruo en el rango de crnicas simulado
    function SimularRangoCronicas(kCronicaIni, kCronicaFin: integer;
      print: boolean): NReal;

    procedure Sim_Cronica_Inicio;

    procedure Actores_AcumularAuxs1;
    procedure Actores_SetAuxs1;

    procedure SorteosDelPasoOpt(sortear: boolean);
    procedure SorteosDelPasoSim(sortear: boolean);

    // este mtodo sellama luego de los sorteos del  paso
    // y antes de preparar los actores.
    procedure Fuentes_PrepararPaso_ps;

    // este mtodo se llama luego de los sorteos del  paso y luego
    // de que las fuentes se prepararon.
    // Si hay iteraciones puede ocurrir que ese mtodo se llame reiteradas veces.
    procedure Actores_PrepararPaso_ps;

    procedure PrepararPaso_as;

    function ResolverPaso: NReal; // retorna el costo en USD

    procedure EvolucionarEstado;
    procedure Sim_Paso_Fin;
    procedure CalcularGradientesDeInversion;

    procedure CapturarResultadosDelPaso;
    procedure Sim_Cronica_Fin;
    procedure FinSimulacion;

    {$IFDEF PDE_RIESGO}
    // llena los histogramas de un rango de estrellas
    procedure LlenarHistograma_CostoDelPaso_masCF_llegada(var HistoCF: TDAOfNReal;
    // Producto Cartesiano ce(kCron) x HistoCF1( jCronF )
      jBase: integer);
    {$ENDIF}

    function CostoDelPaso_masCF_llegada_: NReal;

    procedure Optimizar(llenarConFrameFinal: boolean);
    procedure OptimizarDeterministica;

    procedure CrearYGuardarControladorDeterministicoInicial;

    procedure inicializarArchisOptRes(var fsal: TextFile;
      var fsal_opt: TDAOfTextFile; var fsalopen: boolean);
    procedure escribirPasoOptRes(var fsal: TextFile; var fsal_opt: TDAOfTextFile);
    procedure cerrarArchisOptRes(var fsal: TextFile; var fsal_opt: TDAOfTextFile;
      var fsalopen: boolean);

    procedure printEncabezadoSimRes(var f: TextFile);
    procedure printFinalSimRes(var f: TextFile);

{$IFDEF ESTABILIZAR_FRAMEINICIAL}
    procedure EstabilizarFrameInicial;
{$ENDIF}

    procedure FinOptimizacion;

    //Reordena la lista de fuentes para que si una fuente usa un valor de otra
    //entonces el valor de la otra se calcule antes
    procedure ordenarFuentes;

    procedure Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
    procedure Armar_lst_SorteosDelPaso_Actores;

    procedure Armar_lst_opt_PrintResultados;
    procedure Armar_lst_Sim_cronicaIdInicio;

    procedure Armar_lst_Sim_Paso_Fin;
    procedure Armar_lst_CalcularGradienteDeInversion;

    procedure Armar_lst_EvolucionarEstado;
    procedure Armar_lst_costoDirectoDelPaso;

{$IFDEF ITERAR}
    procedure Armar_lst_necesitoIterar;
    function NecesitoIterar: boolean;
{$ENDIF}
    //      procedure Armar_lst_Encadenamientos;
    procedure PosicionarseEnEstrellita;
    // actualiza el estado Global en el costo futuro.
    // si flg_Xs = TRUE los actores deben usar su proyeccin del estado para actualizar
    // si flg_Xs = FALSE los actores deben usar su estado actual.
    procedure ActualizarEstadoGlobal( flg_Xs: boolean );
    function getNombreVar(ivar: integer): string;
    function getNombreRes(ires: integer): string;
    procedure dump_Variables; overload;
    procedure dump_Variables(archi: string); overload;
    procedure ImprimirPotenciasFirmes;
{$IFDEF WINDOWS}
{$IFNDEF APLICACION_CONSOLA}
    procedure ImprimirUnidadesDisponibles;
{$ENDIF}
{$ENDIF}

    //Para debug
    function genStrPasoCronEstrIter: string;//Optimizacion
    function genStrCronPasoIter: string;//Simulacion


    //Funciones para facilitar el calculo por partes de la Optimizacion..
    procedure inicializarOptimizacion_subproc01;

    // Crea prepara los Actores para la Optimizacin, crea CF y
    // registra los Actores en CF. (no crea la matriz solo lo necesario
    // para el registro de las variables.).
    function Preparar_CrearCF_y_regsitrar_variables_de_estado: integer;

    function inicializarOptimizacion_subproc02(const salaMadre: TSalaDeJuego;
      const costoFuturo: TMatOfNReal): integer;

    function inicializarOptimizacion(const SalaMadre: TSalaDeJuego;
      const costoFuturo: TMatOfNReal): integer;

    procedure OptimizacionCronizada_UnPaso_RangoDeEstrellas(
      estrellaIni, estrellaFin: integer; notificar: boolean;
      printActores_OptRes: boolean);

    procedure OptimizacionValorEsperado_UnPaso_RangoDeEstrellas(
      estrellaIni, estrellaFin: integer; notificar: boolean;
      printActores_OptRes: boolean);

    procedure calcularRangoEstrellas(estrellaIni, estrellaFin: integer;
      notificar, printActoresOptRes: boolean);

{$IFDEF DUMP_TEXT_OPTRES}
    procedure OptRes_Actores_WriteFecha;
    procedure OptRes_Actores_WriteEstrella;
    procedure OptRes_Actores_WritelnFrame;
    procedure OptRes_CF_WritelnFrame;
{$ENDIF}

    //Funciones para obtener o completar un rango del Frame, CF y Auxs
    function getRangoEstrellasCF(estrellaIni, estrellaFin, paso: integer): TDAOfNReal;
    function getRangoEstrellasAux_r1(estrellaIni, estrellaFin: integer): TDAOfDAofNReal;
    function getRangoEstrellasAux_i1(estrellaIni, estrellaFin: integer): TDAOfDAOfNInt;

    procedure setRangoEstrellasCF(estrellaIni: integer;
      tramoCostosFuturo: TDAOfNReal; kpaso: integer);
    procedure setRangoEstrellasAux_r1(estrellaIni: integer; tramoAux_r1: TDAOfDAofNReal);
    procedure setRangoEstrellasAux_i1(estrellaIni: integer; tramoAux_i1: TDAOfDAOfNInt);


    function irAPaso(nuevoPaso: integer): integer;

    function llenarRangoDeEstrellasYDarPaso(estrellasIni: TDAofNInt;
      costosFuturos: TDAOfDAOfNReal; kpaso: integer): integer;

    procedure darPaso;


{$IFDEF PDE_RIESGO}
    // Si estamos en un entrono MultiHilo, hay una sala que es "La Sala Madre"
    procedure Crear_HistogramasCF(SalaMadre: TSalaDeJuego);
    procedure Liberar_HistogramasCF(SalaMadre: TSalaDeJuego);

    // resume los histogramas de un rango de estrellas.
    procedure Resumir_HistogramaCF0aCF1(kEstrellaIni, kEstrellaFin: integer);

    {$IFDEF DEBUG_HistoCF0CF1}
    // para debug
    procedure Dump_HistogramasCF0CF1(caso: string; kpaso, kEstrella: integer);
    {$ENDIF}
{$ENDIF}


    // busca en los objetos de la sala.
    function BuscarPorNombre(const nombre: string;
      var res: TListaDeCosasConNombre): TCosaConNombre;
    function EjecutarMacro(const macro: WideString): integer;

    procedure RecalibrarPronosticos;

    procedure FinSim_workers;
    function FinSim_Master(Print: boolean): NReal;

  private
    // Acumuladores con resumen de todas las cronicas.
    // La sala Madre tiene la instancia y el resto debe
    // apuntar a esta.
    Acumuladores: TAcumuladores_sim;


    // variables de simulacion
    qAct: NReal;
    idCronicaInicioFuenteK: string;
    tmpCF, CFAux: TAdminEstados;
    utilidadAcumCronica: NReal;

    CF_AlFinalDeLaCronica: NReal;
    Calculador_CO2: pointer;
  end;

procedure AlInicio;
procedure AlFinal;




implementation

uses
  ucalculador_emisionesco2,
  {$IFDEF ITERADOR_FLUCAR}
  uiteradorflucar,
  {$ENDIF}
  uFuenteSintetizador;

procedure TSalaDeJuego.RecalibrarPronosticos;
var
  k: integer;
  p: TFuenteAleatoria;
begin
  for k := 0 to ListaFuentes.Count - 1 do
  begin
    p := TFuenteAleatoria(ListaFuentes.items[k]);
    if p is TFuenteSintetizadorCEGH then
      TFuenteSintetizadorCEGH(p).recalibrarPronosticos(globs.FechaIniSim);
  end;

end;

(*  busca entre los actores, las fuentes y globs  *)
function TSalaDeJuego.BuscarPorNombre(const nombre: string;
  var res: TListaDeCosasConNombre): TCosaConNombre;
var
  cosa: TCosaConNombre;
begin
  Result := nil;
  if nombre = 'globs' then
  begin
    res := nil;
    Result := globs;
    exit;
  end;

  cosa := listaActores.find(nombre);
  if cosa <> nil then
  begin
    Result := cosa;
    res := listaActores;
    exit;
  end;

  cosa := listaFuentes.find(nombre);
  if cosa <> nil then
  begin
    Result := cosa;
    res := listaFuentes;
    exit;
  end;

  cosa := listaFuentesReemplazadas.find(nombre);
  if cosa <> nil then
  begin
    Result := cosa;
    res := listaFuentesReemplazadas;
    exit;
  end;

  cosa := listaCombustibles.find(nombre);
  if cosa <> nil then
  begin
    Result := cosa;
    res := listaCombustibles;
    exit;
  end;

  Result := nil;
end;



function ParametrosToLst(const spars: WideString): TStringList;
var
  i: integer;
  res: TStringList;
  s: WideString;
  r: WideString;
begin
  res := TStringList.Create;
  s := trim(spars);
  i := pos(',', s);

  while (s <> '') and (i > 0) do
  begin
    r := trim(copy(s, 1, i - 1));
    Delete(s, 1, i + 1);
    s := trim(s);
    i := pos(',', s);
    res.Add(r);
  end;
  res.Add(s);
  Result := res;
end;

function TSalaDeJuego.EjecutarMacro(const macro: WideString): integer;
var
  i, k: integer;
  s, st: WideString;
  r: WideString;
  res: integer;
  resOrden: TStringList;
  sentencia_str: string;
  cosa_str: string;
  orden_str: string;
  parametros_str: string;
  iopen_parametros: integer;
  icierre_parametros: integer;
  ipunto: integer;
  cosa: TCosaConNombre;
  lst: TListaDeCosasConNombre;
  lst_parametros: TStringList;
begin

  macro_ordenes.Clear;
  macro_Sel.Clear;

  resOrden := TStringList.Create;

  // Parseamos la macro separando las rdenes
  // y quitando los comentarios.
  s := trim(macro);
  i := pos('#$', s);

  while (s <> '') and (i > 0) do
  begin
    r := trim(copy(s, 1, i - 1));
    Delete(s, 1, i + 1);
    s := trim(s);
    i := pos('#$', s);
    k := pos('//', r);
    if k > 0 then
      r := trim(copy(r, 1, k - 1));

    if r <> '' then
      macro_ordenes.Add(r);
  end;

  if s <> '' then
  begin
    r := s;
    k := pos('//', r);
    if k > 0 then
      r := trim(copy(r, 1, k - 1));

    if r <> '' then
      macro_ordenes.Add(r);
  end;

  macro_errMsg := '';

  res := 0;
  for k := 0 to macro_ordenes.Count - 1 do
  begin
    sentencia_str := macro_ordenes[k];
    cosa_str := '';
    parametros_str := '';
    // parsiamos la rden.   cosa.orden( parametros )
    iopen_parametros := pos('(', sentencia_str);
    if (iopen_parametros > 0) then
    begin
      cosa_str := trim(copy(sentencia_str, 1, iopen_parametros - 1));

      ipunto := pos('.', cosa_str);
      if (ipunto > 0) then
      begin
        orden_str := trim(copy(cosa_str, 1, ipunto - 1));
        Delete(cosa_str, 1, ipunto);
        cosa_str := trim(cosa_str);
      end
      else
      begin
        orden_str := cosa_str;
        cosa_str := '';
      end;

      icierre_parametros := pos(')', sentencia_str);
      if (icierre_parametros > iopen_parametros) then
      begin
        parametros_str := trim(copy(sentencia_str, iopen_parametros +
          1, (icierre_parametros - iopen_parametros - 1)));
      end
      else
      begin
        macro_errMsg := 'Error, orden mal formada! (k)' + IntToStr(
          k) + #10#13 + sentencia_str;
        Result := -1;
        exit;
      end;
    end;

    lst_parametros := ParametrosToLst(parametros_str);
    if cosa_str = '' then
      resOrden := EjecutarSentencia(orden_str, lst_parametros)
    else
    begin
      cosa := BuscarPorNombre(cosa_str, lst);
      if cosa <> nil then
        resOrden := cosa.EjecutarSentencia(orden_str, lst_parametros);
    end;

    st := resOrden[0];
    if pos('+ERROR', st) > 0 then
    begin
      macro_errMsg := macro_errMsg + 'Error al ejecutar oden: (' + IntToStr(k) + ') ';
      for i := 0 to resOrden.Count - 1 do
        macro_errMsg := macro_errMsg + #13#10 + resOrden[i];
      break; // paramos en la primer orden que falle
    end;
  end;
  Result := res;
end;



constructor TSalaDeJuego.Create(capa: integer; nombre: string;
  fechaIniSim, fechaFinSim, fechaGuardaSim, fechaIniOpt, fechaFinOpt: TFecha;
  DurPos: TDAOfNReal);
begin
  inherited Create(capa, nombre);
  Globs := TGlobs.Create('globs', fechaIniSim, fechaFinSim, fechaGuardaSim,
    fechaIniOpt, fechaFinOpt, DurPos);
  Gens_ := TListaDeCosasConNombre.Create(capa, 'gens');
  Dems_ := TListaDeCosasConNombre.Create(capa, 'dems');
  Sums := TListaDeCosasConNombre.Create(capa, 'Suministros Combustible');
  Nods_ := TListaDeCosasConNombre.Create(capa, 'nods');
  Arcs_ := TListaDeCosasConNombre.Create(capa, 'arcs');
  ComercioInternacional_ := TListaDeCosasConNombre.Create(capa, 'ComercioInternacional');
  UsosGestionables := TListaDeCosasConNombre.Create(capa, 'usos_gestionables');

  listaActores := TListaDeCosasConNombre.Create(capa, 'Lista de Actores');
  listaFuentes := TListaDeCosasConNombre.Create(capa, 'listaFuentes');
  listaFuentesReemplazadas := TListaDeCosasConNombre.Create(capa, 'FuentesReemplazadas');
  listaCombustibles := TListaDeCosasConNombre.Create(capa, 'Combustibles');

  enganchesContinuos := TListaDeCosas.Create(capa, 'enganchesContinuos');
  enganchesDiscretos := TListaDeCosas.Create(capa, 'enganchesDiscretos');
  enganchar_promediando_desaparecidas := False;
  uniformizar_promediando := '';

  spx := nil;
  dirResultadosCorrida := getDir_Run;
  estabilizarInicio := False;
  usarArchivoParaInicializarFrameInicial := False;
  GenerarRaws := False;
  usarIteradorFlucar := False;

  archivoCFAux := TArchiRef.Create('');
  archivoCF_ParaEnganches := TArchiRef.Create('');
  archivoSala_ParaEnganches := TArchiRef.Create('');

  listaPlantillasSimRes3 := TListaPlantillasSimRes3.Create(capa, 'PlantillasSimRes3');
  Escenarios := TListaEscenarios.Create('Escenarios');
  EscenarioActivo := Escenarios.items[0] as TEscenario_rec;

  self.escribirOptActores := False;

  RandSeed_SincronizarAlInicioDeCadaCronica := True;
  idHilo := 0; // por defecto. Si Est en ambiento MultiHilo se encargan de ponerle el id.

  macro_ordenes := TStringList.Create;
  macro_errMsg := '';
  macro_Sel := TListaDeCosasConNombre.Create(capa, 'macro_Sel');

end;

constructor TSalaDeJuego.Create_ReadFromText(f: TArchiTexto);
var
  i: integer;
  durPosAux: TDAofNReal;
  funcsBasura: TListaDeCosasConNombre;
  pal: string;
  nombre_EscenarioActivo: string;

begin
  inherited Create_ReadFromText(f);
  idHilo := 0;

  UsosGestionables := nil;

  RandSeed_SincronizarAlInicioDeCadaCronica := True;
  estabilizarInicio := False;
  usarArchivoParaInicializarFrameInicial := False;

  spx := nil;
  archivoCF_ParaEnganches := TArchiRef.Create('');
  usarIteradorFlucar := False;
  GenerarRaws := False;
  if f.Version < 33 then
    archivoCFAux := TArchiRef.Create('');


  self.escribirOptActores := False;
  self.archiSala := f.nombreArchivo;
  pal := SysUtils.ExtractFileName(archiSala);
  i := pos('.', pal);
  if i > 0 then
    Delete(pal, i, length(pal) - i + 1);
  if uConstantesSimSEE.tmp_rundir = '' then
    dirResultadosCorrida := getDir_Run + pal + barraDir
  else
    dirResultadosCorrida := tmp_rundir;


  if f.Version < 4 then
  begin
    f.IniciarLecturaRetrasada;
    f.rd('descripcion', descripcion);
    f.rd('globs', TCosa(globs));
    f.rd('gens', TCosa(gens_));
    f.rd('dems', TCosa(dems_));
    Sums := TListaDeCosasConNombre.Create(capa, 'Suministros Combustible');
    f.rd('nods', TCosa(nods_));
    f.rd('arcs', TCosa(arcs_));
    f.rd('spots', TCosa(ComercioInternacional_));
    f.rd('listaFuentes', TCosa(listaFuentes));
    f.rd('funcs', TCosa(funcsBasura));
    f.rd('estabilizarInicio', estabilizarInicio);

    f.rd('usarArchivoParaInicializarFrameInicial',
      usarArchivoParaInicializarFrameInicial);
    f.rdArchRef('archivoCF', archivoCF_ParaEnganches);
    f.rd('enganchesContinuos', TCosa(enganchesContinuos));
    f.rd('enganchesDiscretos', TCosa(enganchesDiscretos));

    f.EjecutarLectura;
    spx := nil;

    if globs = nil then
    begin
      SetLength(durPosAux, 1);
      globs := TGlobs.Create('globs', TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), TFecha.Create_Dt(0), TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), durPosAux);
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudieron leer las variables globales. Asignando valores por defecto.');
    end;
    if gens_ = nil then
    begin
      gens_ := TListaDeCosasConNombre.Create(capa, 'gens');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de generadores. Asignando la lista vaca.');
    end;
    if nods_ = nil then
    begin
      nods_ := TListaDeCosasConNombre.Create(capa, 'nods');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de nodos. Asignando la lista vaca.');
    end;
    if dems_ = nil then
    begin
      dems_ := TListaDeCosasConNombre.Create(capa, 'dems');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de demandas. Asignando la lista vaca.');
    end;

    if sums = nil then
    begin
      Sums := TListaDeCosasConNombre.Create(capa, 'Suministros Combustible');
    end;

    if Arcs_ = nil then
    begin
      Arcs_ := TListaDeCosasConNombre.Create(capa, 'arcs');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de arcos. Asignando la lista vaca.');
    end;

    if ComercioInternacional_ = nil then
    begin
      ComercioInternacional_ :=
        TListaDeCosasConNombre.Create(capa, 'Comercio Internacional');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de spots de mercado. Asignando la lista vaca.');
    end;


    if listaFuentes = nil then
    begin
      listaFuentes := TListaDeCosasConNombre.Create(capa, 'fuentes');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de fuentes. Asignando la lista vaca.');
    end;
    if enganchesContinuos = nil then
    begin
      enganchesContinuos := TListaDeCosas.Create(capa, 'EnganchesContinuos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Continuos. Asignando la lista vaca.');
    end;
    if enganchesDiscretos = nil then
    begin
      enganchesDiscretos := TListaDeCosas.Create(capa, 'EnganchesDiscretos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Discretos. Asignando la lista vaca.');
    end;

    listaActores := TListaDeCosasConNombre.Create(capa, 'Lista de Actores');
    listaActores.Capacity := gens_.Count + dems_.Count + sums.Count +
      nods_.Count + arcs_.Count;

    for i := 0 to nods_.Count - 1 do
      listaActores.Add(nods_[i] as TNodo);

    for i := 0 to dems_.Count - 1 do
      listaActores.Add(dems_[i] as TDemanda);

    // atencin los suministros estn agregados antes de lso generadores
    for i := 0 to sums.Count - 1 do
      listaActores.Add(TCosaConNombre(sums[i]));

    for i := 0 to gens_.Count - 1 do
      listaActores.Add(gens_[i] as TGenerador);
    for i := 0 to arcs_.Count - 1 do
      listaActores.Add(arcs_[i] as TArco);

    for i := 0 to ComercioInternacional_.Count - 1 do
      listaActores.Add(ComercioInternacional_[i] as TComercioInternacional);
    if funcsBasura <> nil then
      funcsBasura.Free;
    listaFuentesReemplazadas :=
      TListaDeCosasConNombre.Create(capa, 'FuentesReemplazadas');
  end
  else if f.Version < 9 then
  begin
    f.IniciarLecturaRetrasada;
    f.rd('descripcion', descripcion);
    f.rd('globs', TCosa(globs));
    f.rd('gens', TCosa(gens_));
    f.rd('dems', TCosa(dems_));
    Sums := TListaDeCosasConNombre.Create(capa, 'Suministros Combustible');
    f.rd('nods', TCosa(nods_));
    f.rd('arcs', TCosa(arcs_));
    f.rd('ComercioInternacional', TCosa(ComercioInternacional_));
    f.rd('listaFuentes', TCosa(listaFuentes));
    f.rd('funcs', TCosa(funcsBasura));
    f.rd('estabilizarInicio', estabilizarInicio);
    f.rd('usarArchivoParaInicializarFrameInicial',
      usarArchivoParaInicializarFrameInicial);
    f.rdArchRef('archivoCF', archivoCF_ParaEnganches);
    f.rd('enganchesContinuos', TCosa(enganchesContinuos));
    f.rd('enganchesDiscretos', TCosa(enganchesDiscretos));

    f.EjecutarLectura;
    spx := nil;

    if globs = nil then
    begin
      SetLength(durPosAux, 1);
      globs := TGlobs.Create('globs', TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), TFecha.Create_Dt(0), TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), durPosAux);
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudieron leer las variables globales. Asignando valores por defecto.');
    end;
    if gens_ = nil then
    begin
      gens_ := TListaDeCosasConNombre.Create(capa, 'gens');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de generadores. Asignando la lista vaca.');
    end;
    if nods_ = nil then
    begin
      nods_ := TListaDeCosasConNombre.Create(capa, 'nods');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de nodos. Asignando la lista vaca.');
    end;
    if dems_ = nil then
    begin
      dems_ := TListaDeCosasConNombre.Create(capa, 'dems');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de demandas. Asignando la lista vaca.');
    end;
    if Arcs_ = nil then
    begin
      Arcs_ := TListaDeCosasConNombre.Create(capa, 'arcs');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de arcos. Asignando la lista vaca.');
    end;
    if ComercioInternacional_ = nil then
    begin
      ComercioInternacional_ :=
        TListaDeCosasConNombre.Create(capa, 'Comercio Internacional');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de spots de mercado. Asignando la lista vaca.');
    end;
    if listaFuentes = nil then
    begin
      listaFuentes := TListaDeCosasConNombre.Create(capa, 'fuentes');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de fuentes. Asignando la lista vaca.');
    end;

    if enganchesContinuos = nil then
    begin
      enganchesContinuos := TListaDeCosas.Create(capa, 'EnganchesContinuos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Continuos. Asignando la lista vaca.');
    end;
    if enganchesDiscretos = nil then
    begin
      enganchesDiscretos := TListaDeCosas.Create(capa, 'EnganchesDiscretos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Discretos. Asignando la lista vaca.');
    end;

    listaActores := TListaDeCosasConNombre.Create(capa, 'Lista de Actores');
    listaActores.Capacity := gens_.Count + dems_.Count + nods_.Count +
      arcs_.Count + ComercioInternacional_.Count;

    for i := 0 to nods_.Count - 1 do
      listaActores.Add(nods_[i] as TNodo);
    for i := 0 to dems_.Count - 1 do
      listaActores.Add(dems_[i] as TDemanda);
    for i := 0 to gens_.Count - 1 do
      listaActores.Add(gens_[i] as TGenerador);
    for i := 0 to arcs_.Count - 1 do
      listaActores.Add(arcs_[i] as TArco);
    for i := 0 to ComercioInternacional_.Count - 1 do
      listaActores.Add(ComercioInternacional_[i] as TComercioInternacional);

    if funcsBasura <> nil then
      funcsBasura.Free;
    listaFuentesReemplazadas :=
      TListaDeCosasConNombre.Create(capa, 'FuentesReemplazadas');
  end
  else
  begin
    f.IniciarLecturaRetrasada;
    f.rd('descripcion', descripcion);
    f.rd('globs', TCosa(globs));
    f.rd('gens', TCosa(gens_));
    f.rd('dems', TCosa(dems_));


    if f.Version >= 73 then
      f.rd('sums', TCosa(sums))
    else
      Sums := TListaDeCosasConNombre.Create(capa, 'sums');

    f.rd('nods', TCosa(nods_));
    f.rd('arcs', TCosa(arcs_));
    f.rd('ComercioInternacional', TCosa(ComercioInternacional_));

    if f.Version >= 79 then
      f.rd('UsosGestionables', TCosa(UsosGestionables))
    else
      UsosGestionables := TListaDeCosasConNombre.Create(capa, 'UsosGestionables');

    f.EjecutarLectura;
    f.rd('listaFuentes', TCosa(listaFuentes));
    f.EjecutarLectura;

    f.rd('estabilizarInicio', estabilizarInicio);
    if f.Version >= 99 then
      f.rd('RandSeed_SincronizarAlInicioDeCadaCronica',
        RandSeed_SincronizarAlInicioDeCadaCronica)
    else
      RandSeed_SincronizarAlInicioDeCadaCronica := True;


    f.rd('usarArchivoParaInicializarFrameInicial',
      usarArchivoParaInicializarFrameInicial);


    if f.Version < 46 then
      f.rdArchRef('archivoCF', archivoCF_ParaEnganches);

    if f.Version >= 46 then
    begin
      f.rdArchRef('archivoCF_ParaEnganches', archivoCF_ParaEnganches);
      f.rdArchRef('archivoSala_ParaEnganches', archivoSala_ParaEnganches);
      f.rd('engancharConSala', engancharConSala);
    end;
    if f.Version >= 95 then
      f.rd('engancharConSala_escenario', engancharConSala_escenario)
    else
      engancharConSala_escenario := '';


    if f.Version >= 33 then
      f.rdArchRef('archivoCFaux', archivoCFaux);


    f.rd('enganchesContinuos', TCosa(enganchesContinuos));
    f.rd('enganchesDiscretos', TCosa(enganchesDiscretos));

    if f.Version >= 64 then
      f.rd('enganchar_promediando_desaparecidas', enganchar_promediando_desaparecidas)
    else
      enganchar_promediando_desaparecidas := False;

    if f.version >= 65 then
      f.rd('uniformizar_promediando', uniformizar_promediando)
    else
      uniformizar_promediando := '';


    if (f.version < 54) then
      listaCombustibles := TListaDeCosasConNombre.Create(capa, 'Combusitbles')
    else
      f.rd('Combustibles', TCosa(listaCombustibles));


    if f.Version >= 79 then
      f.rd('usarIteradorFlucar', usarITeradorFlucar)
    else
      usarIteradorFlucar := False;

    if f.Version >= 81 then
      f.rd('GenerarRaws', GenerarRaws)
    else
      GenerarRaws := False;

    if (f.version < 75) then
      listaPlantillasSimRes3 := TListaPlantillasSimRes3.Create(capa, 'PlantillasSimRes3')
    else
      f.rd('PlantillasSimRes3', TCosa(listaPlantillasSimRes3));


    if (f.version < 92) then
      Escenarios := TListaEscenarios.Create('Escenarios')
    else
      f.rd('Escenarios', TCosa(Escenarios));

    if (f.version < 93) then
      nombre_EscenarioActivo := '??'
    else
      f.rd('EscenarioActivo', nombre_EscenarioActivo);

    f.EjecutarLectura;
    if nombre_EscenarioActivo = '??' then
      EscenarioActivo := Escenarios[0] as TEscenario_rec
    else
      EscenarioActivo := Escenarios.find(nombre_EscenarioActivo) as TEscenario_rec;

    spx := nil;
    if listaPlantillasSimRes3 = nil then
      listaPlantillasSimRes3 :=
        TListaPlantillasSimRes3.Create(capa, 'PlantillasSimRes3');

    if Escenarios = nil then
    begin
      Escenarios := TListaEscenarios.Create('Escenarios');
      EscenarioActivo := Escenarios[0] as TEscenario_rec;
    end;

    if globs = nil then
    begin
      SetLength(durPosAux, 1);
      globs := TGlobs.Create('globs', TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), TFecha.Create_Dt(0), TFecha.Create_Dt(0),
        TFecha.Create_Dt(0), durPosAux);
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudieron leer las variables globales. Asignando valores por defecto.');
    end;
    if gens_ = nil then
    begin
      gens_ := TListaDeCosasConNombre.Create(capa, 'gens');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de generadores. Asignando la lista vaca.');
    end;

    if nods_ = nil then
    begin
      nods_ := TListaDeCosasConNombre.Create(capa, 'nods');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de nodos. Asignando la lista vaca.');
    end;
    if dems_ = nil then
    begin
      dems_ := TListaDeCosasConNombre.Create(capa, 'dems');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de demandas. Asignando la lista vaca.');
    end;


    if sums = nil then
    begin
      sums := TListaDeCosasConNombre.Create(capa, 'sums');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de suministros de combustible. Asignando la lista vaca.');
    end;

    if Arcs_ = nil then
    begin
      Arcs_ := TListaDeCosasConNombre.Create(capa, 'arcs');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de arcos. Asignando la lista vaca.');
    end;

    if ComercioInternacional_ = nil then
    begin
      ComercioInternacional_ :=
        TListaDeCosasConNombre.Create(capa, 'Comercio Internacional');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de spots de mercado. Asignando la lista vaca.');
    end;

    if UsosGestionables = nil then
    begin
      UsosGestionables := TListaDeCosasConNombre.Create(capa, 'UsosGestionables');
      //      ucosa.procMsgErrorLectura( ' Advertencia: no se leyo lista de usos gestionables. Asignando la lista vaca.' );
    end;
    if listaFuentes = nil then
    begin
      listaFuentes := TListaDeCosasConNombre.Create(capa, 'fuentes');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de fuentes. Asignando la lista vaca.');
    end;

    if enganchesContinuos = nil then
    begin
      enganchesContinuos := TListaDeCosas.Create(capa, 'EnganchesContinuos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Continuos. Asignando la lista vaca.');
    end;
    if enganchesDiscretos = nil then
    begin
      enganchesDiscretos := TListaDeCosas.Create(capa, 'EnganchesDiscretos');
      ucosa.procMsgErrorLectura(
        'Advertencia: no se pudo leer la lista de Enganches Discretos. Asignando la lista vaca.');
    end;



    listaActores := TListaDeCosasConNombre.Create(capa, 'Lista de Actores');
    listaActores.Capacity := gens_.Count + dems_.Count + nods_.Count +
      arcs_.Count + ComercioInternacional_.Count;

    {$IFDEF VERBOSO}
    writeln('Agregando NODOS');
    for i := 0 to nods_.Count - 1 do
    begin
      writeln('i: ', i, ', Nodo: ', nods_[i].Apodo);
      listaActores.Add(nods_[i] as TNodo);
    end;

    writeln('Agregando DEMANDAS');
    for i := 0 to dems_.Count - 1 do
    begin
      writeln('i: ', i, ', Dems: ', dems_[i].Apodo);
      listaActores.Add(dems_[i] as TDemanda);
    end;

    writeln('Agregando SUMINISTROS_COMBUSTIBLES');
    for i := 0 to sums.Count - 1 do
    begin
      writeln('i: ', i, ', SumComb: ', sums[i].Apodo);
      listaActores.Add(TCosaConNombre(sums[i]));
    end;

    writeln('Agregando GENERADORES');
    for i := 0 to gens_.Count - 1 do
    begin
      writeln('i: ', i, ', gens: ', gens_[i].Apodo);
      listaActores.Add(gens_[i] as TGenerador);
    end;

    writeln('Agregando ARCOS');
    for i := 0 to arcs_.Count - 1 do
    begin
      writeln('i: ', i, ', Arcs: ', arcs_[i].Apodo);
      listaActores.Add(arcs_[i] as TArco);
    end;

    writeln('Agregando COMERCIO INTERNACIONAL');
    for i := 0 to ComercioInternacional_.Count - 1 do
    begin
      writeln('i: ', i, ', ComInt: ', ComercioInternacional_[i].Apodo);
      listaActores.Add(ComercioInternacional_[i] as TComercioInternacional);
    end;

    writeln('Agregando Usos Gestionables');
    for i := 0 to UsosGestionables.Count - 1 do
    begin
      writeln('i: ', i, ', Uso Gest.: ', UsosGestionables[i].Apodo);
      listaActores.Add(UsosGestionables[i] as TUsoGestionable_postizado);
    end;

    {$ELSE}
    for i := 0 to nods_.Count - 1 do
      listaActores.Add(nods_[i] as TNodo);

    for i := 0 to dems_.Count - 1 do
      listaActores.Add(dems_[i] as TDemanda);

    for i := 0 to sums.Count - 1 do
      listaActores.Add(sums[i] as TActor);


    for i := 0 to gens_.Count - 1 do
      listaActores.Add(gens_[i] as TGenerador);

    for i := 0 to arcs_.Count - 1 do
      listaActores.Add(arcs_[i] as TArco);

    for i := 0 to ComercioInternacional_.Count - 1 do
      listaActores.Add(ComercioInternacional_[i] as TComercioInternacional);

    for i := 0 to UsosGestionables.Count - 1 do
      listaActores.Add(UsosGestionables[i] as TUsoGestionable_postizado);
    {$ENDIF}

    listaFuentesReemplazadas :=
      TListaDeCosasConNombre.Create(capa, 'FuentesReemplazadas');

  end;


  macro_ordenes := TStringList.Create;
  macro_errMsg := '';
  macro_Sel := TListaDeCosasConNombre.Create(capa, 'macro_Sel');

end;

constructor TSalaDeJuego.cargarSala(archiSala, nombre_escenario_activar: string;
  abortarEnError: boolean; rama: string = ''; capas: string = '');
var
  f: TArchiTexto;
  aux: TListaDeCosasConNombre;
  old_dir: string;
  dir_sala: string;
begin
  old_dir := '';
  if FileExists(archiSala) then
  begin
    f := TArchiTexto.CreateForRead(archiSala, abortarEnError);
    aux := TListaDeCosasConNombre.Create(0, 'aux');
    dir_sala := ExtractFileDir(archiSala);
    getdir(0, old_dir);
    chdir(dir_sala);
    try
      f.rd('sala', TCosa(self));
      f.Free;
      f := nil;
      chdir(old_dir);
      //Resolver referencias
      if uCosaConNombre.referenciasSinResolver > 0 then
      begin
        aux.Add(globs);
        uCosaConNombre.resolver_referencias(aux);
        uCosaConNombre.resolver_referencias(listaActores);
        uCosaConNombre.resolver_referencias(listaFuentes);
        uCosaConNombre.resolver_referencias(listaCombustibles);
        aux.FreeSinElemenentos;
        aux := nil;
      end;
      if uCosaConNombre.referenciasSinResolver > 0 then
      begin
        uCosaConNombre.DumpReferencias('errRefs.txt');
        raise Exception.Create(
          'TSalaDeJuego.cargarSala: Quedaron Referencias Sin Resolver Cargando la Sala. Puede Ver Que Referencias No Se Resolvieron En: '
          + 'errRefs.txt');
      end;
      self.setDirCorrida(archiSala);

      if nombre_escenario_activar <> '' then
      begin
        if nombre_escenario_activar = '__principal__' then
          nombre_escenario_activar := EscenarioActivo.nombre;
        ActivarEscenario(nombre_escenario_activar);
      end;

    except
      if old_dir <> '' then
        chdir(old_dir);
      if aux <> nil then
        aux.Free;
      if f <> nil then
        f.Free;
      raise;
    end;
  end
  else
    raise Exception.Create('TSalaDeJuego.cargarSala: no se encuentra el archivo ' +
      archiSala);
end;

procedure TSalaDeJuego.WriteToText(f: TArchiTexto);
begin
  inherited WriteToText(f);
  f.wr('descripcion', descripcion);
  f.writeline('');
  f.wr('globs', globs);
  f.writeline('');
  f.wr('gens', gens_);
  f.writeline('');
  f.wr('dems', dems_);
  f.writeline('');
  f.wr('sums', sums);
  f.writeline('');
  f.wr('nods', nods_);
  f.writeline('');
  f.wr('arcs', arcs_);
  f.writeline('');
  f.wr('ComercioInternacional', ComercioInternacional_);
  f.writeline('');
  f.wr('UsosGestionables', UsosGestionables);
  f.writeline('');
  f.wr('listaFuentes', listaFuentes);
  f.wr('estabilizarInicio', estabilizarInicio);
  f.wr('RandSeed_SincronizarAlInicioDeCadaCronica',
    RandSeed_SincronizarAlInicioDeCadaCronica);
  f.wr('usarArchivoParaInicializarFrameInicial',
    usarArchivoParaInicializarFrameInicial);

  f.wrArchRef('archivoCF_ParaEnganches', archivoCF_ParaEnganches);
  f.wrArchRef('archivoSala_ParaEnganches', archivoSala_ParaEnganches);
  f.wr('engancharConSala', engancharConSala);
  f.wr('engancharConSala_escenario', engancharConSala_escenario);

  f.wrArchRef('archivoCFaux', archivoCFaux);

  f.wr('enganchesContinuos', TCosa(enganchesContinuos));
  f.wr('enganchesDiscretos', TCosa(enganchesDiscretos));
  f.wr('enganchar_promediando_desaparecidas', enganchar_promediando_desaparecidas);
  f.wr('uniformizar_promediando', uniformizar_promediando);

  f.wr('Combustibles', listaCombustibles);

  f.wr('usarIteradorFlucar', usarITeradorFlucar);
  f.wr('GenerarRaws', GenerarRaws);
  f.wr('PlantillasSimRes3', listaPlantillasSimRes3);
  f.wr('Escenarios', Escenarios);
  f.wr('EscenarioActivo', EscenarioActivo.nombre);

  self.archiSala := f.nombreArchivo;
end;

procedure TSalaDeJuego.Free;
begin

  {$IFDEF DEBUG_MULTI_HILO}
  writeln(fdebug_mh, 'Free: ' + DateTimeToStr(now()));
  closefile(fdebug_mh);
  {$ENDIF}

  Gens_.Free;
  Dems_.Free;
  Sums.Free;
  Nods_.Free;
  Arcs_.Free;

  ComercioInternacional_.Free;
  listaActores.FreeSinElemenentos;
  listaFuentes.Free;
  listaFuentesReemplazadas.FreeSinElemenentos;

  if listaCombustibles <> nil then
    listaCombustibles.Free;
  if listaPlantillasSimRes3 <> nil then
    listaPlantillasSimRes3.Free;

  if lst_barridoFijarEstadoDeActoresToEstrella <> nil then
    lst_barridoFijarEstadoDeActoresToEstrella.Free;
  if lst_barridoFijarEstadoDeFuentesToEstrella <> nil then
    lst_barridoFijarEstadoDeFuentesToEstrella.Free;
  if lst_opt_PrintResultados <> nil then
    lst_opt_PrintResultados.Free;
  if lst_Sim_cronicaIdInicio <> nil then
    lst_Sim_cronicaIdInicio.Free;

  if lst_actores_evolucionarEstado <> nil then
    lst_actores_evolucionarEstado.Free;

  if lst_fuentes_evolucionarEstado <> nil then
    lst_fuentes_evolucionarEstado.Free;

{$IFDEF ITERAR}
  if lst_NecesitoIterar <> nil then
    lst_NecesitoIterar.Free;

{$IFDEF ITERADOR_FLUCAR}
  if lst_NecesitoIterar <> nil then
    IteradorFlucar.Free;
{$ENDIF}
{$ENDIF}

(*
  if lst_actores_costoDirectoDelPaso <> NIL then
    lst_actores_costoDirectoDelPaso.Free;
  *)
  if lst_fuentes_costoDirectoDelPaso <> nil then
    lst_fuentes_costoDirectoDelPaso.Free;

  if lst_Sim_Paso_Fin <> nil then
    lst_Sim_Paso_Fin.Free;

  if lst_CalcularGradienteDeInviersion <> nil then
    lst_CalcularGradienteDeInviersion.Free;
  if spx <> nil then
{$IFDEF MIPSimplex}
    spx.Free;
{$ELSE}
  spx.Free(True);
{$ENDIF}
  Globs.Free;
  SetLength(actores, 0);
  SetLength(fuentes_, 0);
  SetLength(hidraulicos, 0);
  SetLength(termicos, 0);
//  SetLength(combustibles, 0);

  if enganchesContinuos <> nil then
    enganchesContinuos.Free;
  if enganchesDiscretos <> nil then
    enganchesDiscretos.Free;

  if archivoCFAux <> nil then
    archivoCFAux.Free;
  if archivoCF_ParaEnganches <> nil then
    archivoCF_ParaEnganches.Free;
  if archivoSala_ParaEnganches <> nil then
    archivoSala_ParaEnganches.Free;
  inherited Free;
end;

procedure TSalaDeJuego.PubliVars;
begin
  inherited PubliVars;
  PublicarVariableNR('CF_AlInicioDelPaso', '[USD]', 12, 1, CF_AlInicioDelPaso, True);
  PublicarVariableNR('CPSimplex', '[USD]', 12, 1, costoDelPaso_spx, True);
  PublicarVariableNR('CPDirecto', '[USD]', 12, 1, costoDirectoDelPaso, True);
  PublicarVariableNR('UPDirectA', '[USD]', 12, 1, utilidadDirectaDelPaso, True);
  //Es de globs, pero se imprime en la sala por separado
  //PublicarVariableNR('cntIterPaso', '-', 12, 1, cntIterPaso, true);
  PublicarVariableNR('CFaux', '[USD]', 12, 1, CFaux_AlInicioDelPaso,
    ArchivoCFAux.archi <> '');
end;

procedure TSalaDeJuego.setDirCorrida(archivoSala: string);
var
  i, j: integer;
  nombreArchivo: string;
  buscando: boolean;

begin
  j := length(archivoSala);
  i := j + 1;

  buscando := True;
  while buscando and (j > 0) do
  begin
    if archivoSala[j] = barraDir then
      buscando := False
    else
    begin
      // si encontramos un punto antes de la primer barra de directorio
      // anotamos su posicin en i
      if (archivoSala[j] = '.') then
        i := j;
      Dec(j);
    end;
  end;

  if buscando then
  begin
    // archivoSala est en la raiz del disco.
    dirSala := '';
    j := 0;
  end
  else
  begin
    dirSala := copy(archivoSala, 1, j - 1) + barraDir;
  end;
  nombreArchivo := copy(archivoSala, j + 1, i - j - 1);
  //El LowerCase es para linux
  if tmp_rundir = '' then
    dirResultadosCorrida := getDir_Run + LowerCase(nombreArchivo) + barraDir
  else
    dirResultadosCorrida := tmp_rundir;
end;


procedure TSalaDeJuego.ActivarEscenario(nombreEscenario: string);
var
  ea: TEscenario_rec;
  k: integer;
  af: TFuenteAleatoria;
  aa: TActor;

begin
  ea := Escenarios.find(nombreEscenario) as TEscenario_rec;
  if ea = nil then
    raise Exception.Create('ActivarEscenario. ERROR: no se encuentra el escenario: ' +
      nombreEscenario);

  EscenarioActivo := ea;
  globs.EscenarioActivo := ea;
  // Ahora recorremos las fuentes y los actores, las filtramos y si
  // pasan el filtro les pedimos que filtren sus fichas de parmetros
  // para el escenario activo.
  listaFuentes.ActivarCapas(ea.capasActivas);
  listaActores.ActivarCapas(ea.CapasActivas);
  listaCombustibles.ActivarCapas(ea.CapasActivas);
end;

procedure TSalaDeJuego.Prepararse(TiempoHaciaAdelante: boolean);
var
  acumr: NReal;
  k, j: integer;
  cntHidraulicos, cntTermicos: integer;
  fuente: TFuenteAleatoria;
begin


  {$IFDEF DEBUG_MULTI_HILO}
  assignfile(fdebug_mh, 'debug_mh' + IntToStr(idHilo) + '_' +
    EscenarioActivo.nombre + '.xlt');
  rewrite(fdebug_mh);
  writeln(fdebug_mh, 'Prepararse: '#9 + DateTimeToStr(now()));
  {$ENDIF}


  // Atencin si la sala es minutal obligo un solo poste
  // de duracin en horas igual a los minutos especificados.
  if globs.SalaMinutal then
  begin
    globs.NPostes := 1;
    setlength(globs.DurPos, 1);
    globs.DurPos[0] := globs.DurPaso_minutos / 60.0;
  end;

  //Preparar valores de las variables globales de la sala
  acumr := xmatdefs.vsum(globs.DurPos);

  globs.HorasDelPaso := acumr;

  if globs.EstadoDeLaSala = CES_OPTIMIZANDO then
    globs.nPasos := globs.calcNPasosOpt
  else
    globs.nPasos := globs.calcNPasosSim;
  globs.fActPaso := 1.0 + globs.TasaDeActualizacion;
  globs.fActPaso := Math.power(1 / globs.fActPaso, acumr / (365 * 24));

  //Armar el listado de actores
  j := 0;
  SetLength(actores, listaActores.Count);
  // Es importante que PRIMERO estn los NODOS para que en leer solucin
  // la lean antes que los dems por si los dems precisan disponer del costo marginal
  for k := 0 to nods_.Count - 1 do
  begin
    actores[j] := nods_[k] as TActor;
    Inc(j);
  end;

  for k := 0 to dems_.Count - 1 do
  begin
    actores[j] := dems_[k] as TDemanda;
    Inc(j);
  end;

  for k := 0 to sums.Count - 1 do
  begin
    actores[j] := TActor(sums[k]);
    Inc(j);
  end;

  for k := 0 to arcs_.Count - 1 do
  begin
    actores[j] := arcs_[k] as TArco;
    Inc(j);
  end;
  cntHidraulicos := 0;
  cntTermicos := 0;

  for k := 0 to gens_.Count - 1 do
  begin
    actores[j] := gens_[k] as TGenerador;
    if actores[j] is TGeneradorHidraulico then
      Inc(cntHidraulicos)
    else if actores[j] is TGTer then
      Inc(cntTermicos);

    Inc(j);
  end;

  for k := 0 to ComercioInternacional_.Count - 1 do
  begin
    actores[j] := ComercioInternacional_[k] as TComercioInternacional;
    Inc(j);
  end;

  for k := 0 to UsosGestionables.Count - 1 do
  begin
    actores[j] := UsosGestionables[k] as TUsoGestionable_postizado;
    Inc(j);
  end;

  //Armar el listado de generadores hidrulicos
  setlength(Hidraulicos, cntHidraulicos);
  cntHidraulicos := 0;

  for k := 0 to gens_.Count - 1 do
  begin
    if gens_[k] is TGeneradorHidraulico then
    begin
      hidraulicos[cntHidraulicos] := gens_[k] as TGeneradorHidraulico;
      Inc(cntHidraulicos);
    end;
  end;

  //Armar el listado de generadores trmicos
  setlength(termicos, cntTermicos);
  cntTermicos := 0;

  for k := 0 to gens_.Count - 1 do
  begin
    if gens_[k] is TGTer then
    begin
      termicos[cntTermicos] := gens_[k] as TGTer;
      Inc(cntTermicos);
    end;
  end;

{$IFDEF COMBUSTIBLES_TUTEE}
  //Armar el listado de commbustibles
  setlength(combustibles, listaCombustibles.Count);

  for k := 0 to listaCombustibles.Count - 1 do
    combustibles[k] := TCombustible(listaCombustibles[k]);
{$ENDIF}

  //Armar el listado de fuentes
  ordenarFuentes;
  SetLength(fuentes_, listaFuentes.Count);

  // ATENCION aqu controlamos si es necesario esclavizar fuentes.
  for k := 0 to listaFuentes.Count - 1 do
  begin
    fuente := TFuenteAleatoria(listaFuentes[k]);
    if (fuente.durPasoDeSorteoEnHoras = 0) or
      (fuente.durPasoDeSorteoEnHoras = globs.HorasDelPaso) then
      fuentes_[k] := fuente
    else
    begin
      if globs.HorasDelPaso < fuente.durPasoDeSorteoEnHoras then
      begin
        listaFuentesReemplazadas.Add(fuente);
        fuentes_[k] := TEsclavizadorSobreMuestreado.Create(
          capa, 'SobreMuestreada_' + fuente.nombre, fuente);
        listaFuentes[k] := fuentes_[k];
      end
      else
      begin
        listaFuentesReemplazadas.Add(fuente);
        fuentes_[k] := TEsclavizadorSubMuestreado.Create(
          capa, 'SubMuestreada_' + fuente.nombre, fuente, fuente.ResumirPromediando);
        listaFuentes[k] := fuentes_[k];
      end;
    end;
  end;

  Armar_lst_SorteosDelPaso_Actores;

  globs.ActualizadorLPD.limpiar;

(**** ATENCION *******************************************************
Primero preparan memoria los ACTORES y luego las FUENTES
Esto es as pues los actores pueden registrar funciones en las fuentes
y las fuentes precisan esa informacin para prepararse
*********************************************************************)
  {$IFDEF CALC_DEMANDA_NETA}
  globs.InicializarNeteadorDeDemanda;
  {$ENDIF}

  // Que los actores preparen su memoria
  for k := 0 to high(actores) do
    actores[k].PrepararMemoria(globs);

  //Preparar las fuentes
  for k := 0 to high(fuentes_) do
  begin
    fuentes_[k].prepararMemoria(globs);
    fuentes_[k].RegistrarParametrosDinamicos;
  end;

  //Preparar los combustibles
  for k := 0 to listaCombustibles.count-1 do
  begin
    TCombustible(listaCombustibles.items[k]).prepararMemoria( globs );
    TCombustible(listaCombustibles.items[k]).RegistrarParametrosDinamicos;
  end;

  // Que los actores registren sus parmetros dinmicos
  for k := 0 to high(actores) do
    actores[k].RegistrarParametrosDinamicos;

  uCosaConNombre.resolver_referencias(self.listaActores);
  uCosaConNombre.resolver_referencias(self.listaFuentes);
  uCosaConNombre.resolver_referencias(listaFuentesReemplazadas);



  // Preparamos el actualizador de fichas.
  if globs.EstadoDeLaSala = CES_OPTIMIZANDO then
  begin
    globs.ActualizadorLPD.ChequeoFechas(globs.fechaIniOpt, globs.fechaFinOpt);
    globs.ActualizadorLPD.Preparse(TiempoHaciaAdelante, globs.fechaIniOpt,
      globs.fechaFinOpt);
    globs.ActualizadorLPD.PrepararOptSim(globs.fechaIniOpt, globs.fechaFinOpt);
  end
  else
  begin
    globs.ActualizadorLPD.ChequeoFechas(globs.fechaIniSim, globs.fechaFinSim);
    globs.ActualizadorLPD.Preparse(TiempoHaciaAdelante, globs.fechaIniSim,
      globs.fechaFinSim);
    globs.ActualizadorLPD.PrepararOptSim(globs.fechaIniSim, globs.fechaFinSim);
  end;
end;


{$IFDEF SMART_VAR_DUMP}
procedure TSalaDeJuego.publicarSoloVariablesUsadasEnSimRes3;
var
  planillasActivasSimRes3: TStrings;
  nPlanillasSimRes3Activas: integer;
  k: integer;
  lector: TLectorSimRes3Defs;
  res: TListaDeCosasConNombre;
  cosa: TCosaConNombre;
  varDef: TVarDef;
  i: integer;

  imprimirTodas: boolean;

begin

  imprimirTodas := True;
  planillasActivasSimRes3 := listaPlantillasSimRes3.lista_activas;
  nPlanillasSimRes3Activas := listaPlantillasSimRes3.lista_activas.Count;

  lector := TLectorSimRes3Defs.Create;
  for k := 0 to nPlanillasSimRes3Activas - 1 do
  begin
    writeln(planillasActivasSimRes3[k]);
    lector.LeerDefiniciones(planillasActivasSimRes3[k], False);
    for i := 0 to lector.lstIdxs.Count - 1 do
    begin
      cosa := BuscarPorNombre(TVarIdxs(lector.lstIdxs[i]).nombreActor, res);
      if cosa <> nil then
        if cosa.pubvarlst = nil then
          cosa.PubliVars;
    end;
  end;
  lector.Free;

  if imprimirTodas then
  begin

  end;

end;
{$ENDIF}

procedure TSalaDeJuego.publicarTodasLasVariables;
var
  k: integer;
begin

  self.PubliVars;
  globs.PubliVars;
  // Que los actores publiquen las variables
  for k := 0 to listaActores.Count - 1 do
    listaActores[k].PubliVars;

  // Que las fuentes publiquen las variables
  for k := 0 to listaFuentesReemplazadas.Count - 1 do
    TCosaConNombre(listaFuentesReemplazadas[k]).PubliVars;
  for k := 0 to listaFuentes.Count - 1 do
    listaFuentes[k].PubliVars;

end;



procedure TSalaDeJuego.lista_Prepararse(lista: TListaDeCosasConNombre);
var
  i: integer;
begin

  // primer barrido Preparo Actores.
  for i := 0 to lista.Count - 1 do
  begin
    if TObject(lista[i]) is TActor then
      TActor(lista[i]).PrepararMemoria(globs);
  end;

  // segundo barrido Preparo Las Fuentes Aleatorias.
  // tiene que hacerce luego de preparar los Actores pues
  // aquellos puede agregar bornes sobre las fuentes
  for i := 0 to lista.Count - 1 do
  begin
    if TObject(lista[i]) is TFuenteAleatoria then
      TFuenteAleatoria(lista[i]).PrepararMemoria(globs);
  end;

  //// tercer barrido para publicar las variables.
  //for i := 0 to lista.Count - 1 do
  //begin
  //  TCosaConNombre(lista[i]).PubliVars;
  //end;
end;



procedure TSalaDeJuego.Prepararse_;
var
  i: integer;
  cosasEnLaSala: TListaDeCosasConNombre;
begin
  cosasEnLaSala := TListaDeCosasConNombre.Create(0, 'aux_PrepararseYPubliVars');
  cosasEnLaSala.Capacity := 2 + listaActores.Count + listaFuentes.Count;
  cosasEnLaSala.Add(self);
  cosasEnLaSala.Add(globs);
  for i := 0 to listaActores.Count - 1 do
    cosasEnLaSala.Add(TCosaConNombre(listaActores[i]));
  for i := 0 to listaFuentes.Count - 1 do
    cosasEnLaSala.Add(TCosaConNombre(listaFuentes[i]));
  lista_Prepararse(cosasEnLaSala);
  cosasEnLaSala.FreeSinElemenentos;
end;

procedure TSalaDeJuego.Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
var
  k: integer;
  p1, p2: procedure of object;
  actor1, actor: TActor;
  fuente1, fuente: TFuenteAleatoria;
begin
  // FijarEstadoEstrellita
  if lst_barridoFijarEstadoDeActoresToEstrella <> nil then
    lst_barridoFijarEstadoDeActoresToEstrella.Clear
  else
    lst_barridoFijarEstadoDeActoresToEstrella := TList.Create;

  actor1 := TActor.Create(capa, '', TFecha.Create_DT(now()),
    TFecha.Create_DT(Now()), TActor.CreateDefaultLPDUnidades_(1));
  p1 := Actor1.PosicionarseEnEstrellita;
  for k := 0 to high(actores) do
  begin
    actor := actores[k];
    p2 := actor.PosicionarseEnEstrellita;
    if @p1 <> @p2 then
      lst_barridoFijarEstadoDeActoresToEstrella.Add(actor);
  end;
  actor1.Free;

  if lst_barridoFijarEstadoDeFuentesToEstrella <> nil then
    lst_barridoFijarEstadoDeFuentesToEstrella.Clear
  else
    lst_barridoFijarEstadoDeFuentesToEstrella := TList.Create;

  fuente1 := TFuenteAleatoria.Create(capa, '', -1, False);
  p1 := fuente1.PosicionarseEnEstrellita;
  for k := 0 to listaFuentes.Count - 1 do
  begin
    fuente := fuentes_[k];

    if fuente is TEsclavizador then
      p2 := TEsclavizador(fuente).esclava.PosicionarseEnEstrellita
    else
      p2 := fuente.PosicionarseEnEstrellita;

    if @p1 <> @p2 then
      lst_barridoFijarEstadoDeFuentesToEstrella.Add(fuente);
  end;
  fuente1.Free;
end;

procedure TSalaDeJuego.Armar_lst_SorteosDelPaso_Actores;
var
  k, cantRedefiniciones: integer;
  p1, p2: procedure(sortear: boolean) of object;
  actor1, actor: TActor;
begin
  SetLength(lst_SorteosDelPaso_Actores, length(actores));

  actor1 := TActor.Create(capa, '', TFecha.Create_DT(now()),
    TFecha.Create_DT(now()), TActor.CreateDefaultLPDUnidades_(1));
  p1 := Actor1.SorteosDelPaso;
  cantRedefiniciones := 0;
  for k := 0 to high(actores) do
  begin
    actor := actores[k];
    p2 := actor.SorteosDelPaso;
    if @p1 <> @p2 then
    begin
      lst_SorteosDelPaso_Actores[cantRedefiniciones] := actor;
      cantRedefiniciones := cantRedefiniciones + 1;
    end;
  end;
  actor1.Free;
  if cantRedefiniciones <> Length(lst_SorteosDelPaso_Actores) then
    if cantRedefiniciones <> 0 then
      lst_SorteosDelPaso_Actores :=
        copy(lst_SorteosDelPaso_Actores, 0, cantRedefiniciones)
    else
      lst_SorteosDelPaso_Actores := nil;
end;

procedure TSalaDeJuego.Armar_lst_opt_PrintResultados;
var
  k: integer;
  p1, p2: procedure(var fsal: textfile) of object;
  actor1: TActor;
begin
  actor1 := TActor.Create(capa, '', TFecha.Create_DT(now()),
    TFecha.Create_DT(now()), TActor.CreateDefaultLPDUnidades_(1));

  // lst_opt_PrintResultados
  if lst_opt_PrintResultados <> nil then
    lst_opt_PrintResultados.Clear
  else
    lst_opt_PrintResultados := TList.Create;

  p1 := Actor1.opt_PrintResultados;
  for k := 0 to high(actores) do
  begin
    p2 := actores[k].opt_PrintResultados;
    if @p1 <> @p2 then
      lst_opt_PrintResultados.add(actores[k]);
  end;

  actor1.Free;
end;

procedure TSalaDeJuego.Armar_lst_Sim_cronicaIdInicio;
var
  k: integer;
  p1, p2: function: string of object;
  fuente1, fuente: TFuenteAleatoria;
begin
  // FijarEstadoEstrellita
  if lst_Sim_cronicaIdInicio <> nil then
    lst_Sim_cronicaIdInicio.Clear
  else
    lst_Sim_cronicaIdInicio := TList.Create;

  fuente1 := TFuenteAleatoria.Create(capa, '', 0, False);
  p1 := fuente1.cronicaIdInicio;
  for k := 0 to high(fuentes_) do
  begin
    fuente := fuentes_[k];
    if fuente is TEsclavizador then
      p2 := TEsclavizador(fuente).esclava.cronicaIdInicio
    else
      p2 := fuente.cronicaIdInicio;

    if @p1 <> @p2 then
      lst_Sim_cronicaIdInicio.Add(fuente);
  end;
  fuente1.Free;
end;


procedure TSalaDeJuego.armar_lst_Sim_Paso_Fin;
var
  k: integer;
  p1, p2: procedure of object;
  actor1: TActor;
begin
  actor1 := TActor.Create(capa, '', TFecha.Create_DT(now()),
    TFecha.Create_DT(now()), TActor.CreateDefaultLPDUnidades_(1));

  // lst_opt_PrintResultados
  if lst_Sim_Paso_Fin <> nil then
    lst_Sim_Paso_Fin.Clear
  else
    lst_Sim_Paso_Fin := TList.Create;

  p1 := Actor1.Sim_Paso_Fin;
  for k := 0 to high(actores) do
  begin
    p2 := actores[k].Sim_Paso_Fin;
    if @p1 <> @p2 then
      lst_Sim_Paso_Fin.add(actores[k]);
  end;
  actor1.Free;
end;

procedure TSalaDeJuego.Armar_lst_CalcularGradienteDeInversion;
var
  k: integer;
  Actor: TActor;
begin

  if lst_CalcularGradienteDeInviersion <> nil then
    lst_CalcularGradienteDeInviersion.Clear
  else
    lst_CalcularGradienteDeInviersion := TList.Create;

  for k := 0 to high(actores) do
  begin
    Actor:= actores[k];
    if Actor is TGenerador then
      if TGenerador( Actor ).flg_CalcularGradienteDeInversion then
        lst_CalcularGradienteDeInviersion.add( Actor );
  end;
end;


procedure TSalaDeJuego.Armar_lst_costoDirectoDelPaso;
var
  k: integer;
  p1, p2: function: NReal of object;
  //  actor1: TActor;
  fuente1: TFuenteAleatoria;
begin
(*  actor1:= TActor.Create('', TFecha.Create_DT(now()), TFecha.Create_DT(now()), TActor.CreateDefaultLPDUnidades);


// lst_opt_PrintResultados
  if lst_actores_costoDirectoDelPaso <> nil then
    lst_actores_costoDirectoDelPaso.Clear
  else
    lst_actores_costoDirectoDelPaso:= TList.Create;
  p1:= Actor1.costoDirectoDelPaso;

  for k:= 0 to high( actores ) do
  begin
    p2:= actores[k].costoDirectoDelpaso;
    if @p1<>@p2 then
      lst_actores_costoDirectoDelPaso.add( actores[k] );
  end;
  actor1.Free;
    *)

  fuente1 := TFuenteAleatoria.Create(capa, '', 0, False);
  if lst_fuentes_costoDirectoDelPaso <> nil then
    lst_fuentes_costoDirectoDelPaso.Clear
  else
    lst_fuentes_costoDirectoDelPaso := TList.Create;

  p1 := fuente1.costoDirectoDelPaso;
  for k := 0 to high(fuentes_) do
  begin
    if fuentes_[k] is TEsclavizador then
      p2 := TEsclavizador(fuentes_[k]).esclava.costoDirectoDelPaso
    else
      p2 := fuentes_[k].costoDirectoDelPaso;

    if @p1 <> @p2 then
      lst_fuentes_costoDirectoDelPaso.add(fuentes_[k]);
  end;
  fuente1.Free;
end;


procedure TSalaDeJuego.Armar_lst_EvolucionarEstado;
var
  k: integer;
  p1, p2: procedure of object;
  actor1: TActor;
  fuente1: TFuenteAleatoria;
begin
  actor1 := TActor.Create(capa, '', TFecha.Create_DT(now()),
    TFecha.Create_DT(now()), TActor.CreateDefaultLPDUnidades_(1));

  // lst_opt_PrintResultados
  if lst_actores_EvolucionarEstado <> nil then
    lst_actores_evolucionarEstado.Clear
  else
    lst_actores_evolucionarEstado := TList.Create;

  p1 := Actor1.EvolucionarEstado;

  for k := 0 to high(actores) do
  begin
    p2 := actores[k].EvolucionarEstado;
    if @p1 <> @p2 then
      lst_actores_evolucionarEstado.add(actores[k]);
  end;
  actor1.Free;

  fuente1 := TFuenteAleatoria.Create(capa, '', 0, False);
  if lst_fuentes_EvolucionarEstado <> nil then
    lst_fuentes_EvolucionarEstado.Clear
  else
    lst_fuentes_EvolucionarEstado := TList.Create;

  p1 := fuente1.evolucionarEstado;
  for k := 0 to high(fuentes_) do
  begin
    p2 := fuentes_[k].evolucionarEstado;
    if @p1 <> @p2 then
      lst_fuentes_EvolucionarEstado.add(fuentes_[k]);
  end;
  fuente1.Free;
end;

{$IFDEF ITERAR}
procedure TSalaDeJuego.Armar_lst_necesitoIterar;
var
  k: integer;
  p1, p2: function(kIteracion: integer; var errRelativo: NReal): boolean of object;
  actor1: TActor;
begin
  actor1 := TActor.Create(capa, '', TFecha.Create_DT(now()),
    TFecha.Create_DT(now()), TActor.CreateDefaultLPDUnidades_(1));

  // lst_opt_PrintResultados
  if lst_necesitoIterar <> nil then
    lst_necesitoIterar.Clear
  else
    lst_necesitoIterar := TList.Create;

  p1 := Actor1.opt_NecesitoIterar;
  for k := 0 to high(actores) do
  begin
    p2 := actores[k].opt_NecesitoIterar;
    if @p1 <> @p2 then
      lst_NecesitoIterar.add(actores[k]);
  end;
  actor1.Free;
  {$IFDEF ITERADOR_FLUCAR}
  if usarIteradorFlucar then
  begin
    IteradorFlucar := TIteradorFlucar.Create(self);
  end
  else
    IteradorFlucar := nil;
  {$ENDIF}
end;

{$ENDIF}

(****** por ahora no va esto. Puede ser que vuelva a ponerse para
aumentar la eficiencia

procedure TSalaDeJuego.Armar_lst_Encadenamientos;
var
  iHidraulicos, iAux, nHidraulicos: Integer;
  temp: TGeneradorHidraulico;
function todasResueltas(centralesAguasArriba : TListaCentralesAguasArriba ; var noResuelta : TGeneradorHidraulico) : boolean;
var
  iCentralesEncadenadas, iter: Integer;
  res, buscando: boolean;
begin
  res:= true;
  iCentralesEncadenadas:= 0;
  //Recorro las centrales aguas arriba de la ma, si las encuentro entre las
  //que ya estan ordenadas entonces estan todas resueltas y puedo dejar la central
  //en ese lugar en la lista
  while iCentralesEncadenadas < Length(centralesAguasArriba.lst) do
  begin
    noResuelta:= centralesAguasArriba.lst[iCentralesEncadenadas];
    buscando:= true;
    for iter:= 0 to iHidraulicos -1 do
    begin
      if hidraulicos[iter] = noResuelta then
      begin
        buscando:= false;
        break;
      end;
    end;
    if not buscando then
      inc(iCentralesEncadenadas)
    else
    begin
      res:= false;
      break;
    end;
  end;
  result:= res;
end;

begin
  if length(hidraulicos) = 0 then
  begin
    nHidraulicos:= 0;
    for iAux:= 0 to Gens.lst.Count -1 do
    begin
      if (TGenerador(gens.lst[iAux]) is TGeneradorHidraulico) then
        inc(nHidraulicos);
    end;
    SetLength(hidraulicos, nHidraulicos);
    iHidraulicos:= 0;
    for iAux:= 0 to Gens.lst.Count -1 do
    begin
      if (TGenerador(gens.lst[iAux]) is TGeneradorHidraulico) then
      begin
        hidraulicos[iHidraulicos]:= gens.lst[iAux];
        inc(iHidraulicos);
        if iHidraulicos >= nHidraulicos then
          break;
      end;
    end;
  end
  else
    nHidraulicos:= Length(hidraulicos);

  iHidraulicos:= 0;
  while iHidraulicos < nHidraulicos do
  begin
    if todasResueltas(hidraulicos[iHidraulicos].centralesAguasArriba, temp) then
      inc(iHidraulicos)
    else
    begin
      for iAux:= iHidraulicos +1 to nHidraulicos -1 do
        if hidraulicos[iAux] = temp then
          break;
      hidraulicos[iAux]:= hidraulicos[iHidraulicos];
      hidraulicos[iHidraulicos]:= temp;
    end;
  end;
end;
**********)

{$IFDEF ITERAR}
function TSalaDeJuego.NecesitoIterar: boolean;
var
  k: integer;
  xerr: NReal;
  cnt: integer;
begin
  cnt := 0;

  // Atencin: Es a propsito que le preguntamos a todos los actores.
  // No paramos en el primero que precise iterar dado que ya que vamos a iterar
  // le permitimos a los dems mejorar sus valores para lo que hay que llamar
  // a su correspondiente NecesitoIterar.
  for k := 0 to lst_NecesitoIterar.Count - 1 do
    if TActor(lst_NecesitoIterar.Items[k]).opt_NecesitoIterar(
      globs.cntIteracionesDelPaso, xerr) then
      Inc(cnt);

  {$IFDEF ITERADOR_FLUCAR}
  //   llamar a verificador de FLUCAR
  if usarIteradorFlucar then
    if IteradorFlucar.NecesitoIterar then
      Inc(cnt);
  {$ENDIF}

  Result := cnt > 0;
end;

{$ENDIF}

function TSalaDeJuego.getNombreVar(ivar: integer): string;
var
  i: integer;
  nombre: string;
begin
  nombre := '';
  for i := 0 to high(actores) do
    if actores[i].getNombreVar(ivar, nombre) then
      break;
  if nombre = '' then
    nombre := '??_x' + IntToStr(ivar);
  Result := nombre;
end;

function TSalaDeJuego.getNombreRes(ires: integer): string;
var
  i: integer;
  nombre: string;
begin
  nombre := '';
  for i := 0 to high(actores) do
  begin
    if actores[i].getNombreRes(ires, nombre) then
      break;
  end;
  if nombre = '' then
    nombre := '??_y' + IntToStr(ires);
  Result := nombre;
end;

procedure TSalaDeJuego.dump_Variables;
var
  archi: string;
begin
  archi := DateTimeToStr(now()) + '_dump_Variables.txt';
  while pos('/', archi) > 0 do
    archi[pos('/', archi)] := '-';
  while pos(':', archi) > 0 do
    archi[pos(':', archi)] := '-';
  archi := getDir_Dbg + archi;
  dump_Variables(archi);
end;

procedure TSalaDeJuego.dump_Variables(archi: string);
const
  indentador = #9;
var
  f: TextFile;
  k: integer;
begin
  if pos(getDir_Dbg, archi) <> 1 then
    archi := getDir_Dbg + archi;
  try
    AssignFile(f, archi);
    rewrite(f);
    writeln(f, 'Estado de la Sala= ', estadoSalaToString(globs.EstadoDeLaSala));
    writeln(f, 'globs.kpaso_= ', globs.kpaso_);
    if globs.EstadoDeLaSala = CES_OPTIMIZANDO then
      writeln(f, 'globs.CF.ordinalEstrellaActual= ', globs.CF.ordinalEstrellaActual);

    writeln(f, 'globs.kcronica= ', globs.kcronica);
{$IFDEF ITERAR}
    writeln(f, 'globs.cntIteracionesDelPaso= ', globs.cntIteracionesDelPaso);
{$ENDIF}
    writeln(f);
    for k := 0 to Nods_.Count - 1 do
      (Nods_[k] as TNodo).dump_Variables(f, indentador);
    for k := 0 to Dems_.Count - 1 do
      (Dems_[k] as TDemanda).dump_Variables(f, indentador);

    for k := 0 to Sums.Count - 1 do
      TSuministroCombustible(Sums[k]).dump_Variables(f, indentador);

    for k := 0 to Gens_.Count - 1 do
      (Gens_[k] as TGenerador).dump_Variables(f, indentador);
    for k := 0 to ComercioInternacional_.Count - 1 do
      (ComercioInternacional_[k] as TComercioInternacional).dump_Variables(f,
        indentador);
    for k := 0 to Arcs_.Count - 1 do
      (Arcs_[k] as TArco).dump_Variables(f, indentador);
    for k := 0 to high(fuentes_) do
      fuentes_[k].dump_Variables(f, indentador);
  finally
    CloseFile(f);
  end;
end;

procedure TSalaDeJuego.Sim_Cronica_Inicio;
var
  k: integer;
begin
  // 8/11/2011 con esto intentamos que las cronicas sean reproducibles sin importar
  // su largo. O sea que si acortamos el horizonte de simulacin los tramos iniciales
  // de las crnicas sean los mismos.
  if (RandSeed_SincronizarAlInicioDeCadaCronica) then
    globs.fijarSemillaAleatoria_(Self.globs.semilla_inicial_sim + globs.kCronica);

  globs.Fijar_kPaso(1);
  globs.ActualizadorLPD.PrepararOptSim(globs.fechaIniSim, globs.fechaFinSim);

  for k := 0 to high(fuentes_) do
  begin
    fuentes_[k].Sim_Cronica_Inicio;
  end;

  for k := 0 to high(actores) do
  begin
    actores[k].Sim_Cronica_Inicio;
  end;
  globs.procNot(globs.procNot_InicioCronica);
end;

{procedure TSalaDeJuego.prepararSalaParaPaso;
begin
  globs.ActualizadorLPD.ActualizarFichasHasta( globs.FechaInicioDelpaso );
end;}

procedure TSalaDeJuego.PosicionarseEnEstrellita;
var
  k: integer;
begin
  for k := 0 to high(fuentes_) do
    fuentes_[k].PosicionarseEnEstrellita;
  for k := 0 to High(fuentesConBCConEstadoEnCF) do
    fuentesConBCConEstadoEnCF[k].calcular_BC;

  for k := 0 to lst_barridoFijarEstadoDeActoresToEstrella.Count - 1 do
    TActor(lst_barridoFijarEstadoDeActoresToEstrella.items[k]).PosicionarseEnEstrellita;
end;

procedure TSalaDeJuego.ActualizarEstadoGlobal( flg_Xs: boolean );
var
  k: integer;
begin
  for k := 0 to lst_barridoFijarEstadoDeActoresToEstrella.Count - 1 do
    TActor(lst_barridoFijarEstadoDeActoresToEstrella.items[k]).ActualizarEstadoGlobal( flg_Xs );
  for k := 0 to lst_barridoFijarEstadoDeFuentesToEstrella.Count - 1 do
    TFuenteAleatoria(lst_barridoFijarEstadoDeFuentesToEstrella[k]).
      ActualizarEstadoGlobal( flg_Xs );
end;

procedure TSalaDeJuego.Actores_AcumularAuxs1;
var
  k: integer;
begin
  for k := 0 to high(actores) do
    actores[k].AcumAux1(globs.invNCronicasOpt);
end;

procedure TSalaDeJuego.Actores_SetAuxs1;
var
  k: integer;
begin
  for k := 0 to high(actores) do
    actores[k].SetAux1;
end;

procedure TSalaDeJuego.SorteosDelPasoOpt(sortear: boolean);
var
  k: integer;
begin

  // generamos los nmeros aleatorios en las borneras de entrada.
  for k := 0 to high(fuentes_) do
    fuentes_[k].sorteosDelPaso(sortear);

  // para las fuentes que no tienen estado en CF, podemos fijar su estado
  // interno (no depende del estado del sistema) y adems ya podemos calcular
  // sus Bornes Calculados.
  for k := 0 to high(fuentesConBCSinEstadoEnCF) do
  begin
    fuentesConBCSinEstadoEnCF[k].fijarEstadoInterno;
    fuentesConBCSinEstadoEnCF[k].calcular_BC;
  end;

  for k := 0 to high(lst_SorteosDelPaso_Actores) do
    lst_SorteosDelPaso_Actores[k].SorteosDelPaso(sortear);
end;

procedure TSalaDeJuego.SorteosDelPasoSim(sortear: boolean);
var
  k: integer;
begin
  for k := 0 to high(fuentes_) do
  begin
    fuentes_[k].sorteosDelPaso(sortear);
    fuentes_[k].calcular_BC;
  end;
  for k := 0 to high(lst_SorteosDelPaso_Actores) do
    lst_SorteosDelPaso_Actores[k].SorteosDelPaso(sortear);
end;

procedure TSalaDeJuego.PrepararPaso_as;
var
  k: integer;
begin
  for k := 0 to high(actores) do
  begin
    actores[k].PrepararPaso_as;
  end;
  {$IFDEF ITERADOR_FLUCAR}
  //   afectar rendimiento y capacidades de los arcos segn resultados del FLUCAR
  if IteradorFlucar <> nil then
    IteradorFlucar.preparar_paso_as;
  {$ENDIF}
end;

procedure TSalaDeJuego.Fuentes_PrepararPaso_ps;
var
  k: integer;
begin
  for k := 0 to high(Fuentes_) do
    Fuentes_[k].PrepararPaso_ps;
end;

procedure TSalaDeJuego.Actores_PrepararPaso_ps;
var
  k: integer;
{$IFDEF CHEQUEOMEM}
  tam: cardinal;
{$ENDIF}

begin
{$IFDEF CHEQUEOMEM}
  tam := udbgutil.tam;
{$ENDIF}

{$IFDEF CALC_DEMANDA_NETA}
  globs.borrarSumaPHorarias;
  for k := 0 to high(actores) do
    actores[k].PrepararPaso_ps_pre;
  globs.postizarPHoraria;
{$ENDIF}

  for k := 0 to high(actores) do
  begin
    actores[k].PrepararPaso_ps;
{$IFDEF CHEQUEOMEM}
    if tam <> udbgutil.tam then
      raise Exception.Create('OJO; el Actor: ' + actores[k].nombre +
        ' pierde memoria en PrepararPaso_ps');
{$ENDIF}
  end;

{$IFDEF ITERADOR_FLUCAR}
  //   afectar rendimiento y capacidades de los arcos segn resultados del FLUCAR
  if IteradorFlucar <> nil then
    IteradorFlucar.preparar_paso_ps;
{$ENDIF}

end;

function TSalaDeJuego.ResolverPaso: NReal;
var
  k: integer;
  ispxres: integer;
begin

  ivar := 1;
  ires := 1;
  ivae := 1;

  // barrido para determinar dimensin del problema.
  for k := 0 to high(actores) do
    actores[k].opt_nvers(ivar, ivae, ires);


{$IFDEF MIPSimplex}
  if ((ires = spx.nf) and (ivar = spx.nc)) and (ivae - 1 = spx.nvents) then
    spx.limpiar
  else
  begin
    spx.Free;
    spx := TMIPSimplex.Create_init(ires, ivar, ivae - 1, self.getNombreVar,
      self.getNombreRes);
  end;
{$ELSE}
  if ((ires = spx.nf) and (ivar = spx.nc)) then
    spx.limpiar
  else
  begin
    spx.Free(True);
    spx := TSimplex.Create_init(ires, ivar, self.getNombreVar, self.getNombreRes);
  end;
{$ENDIF}

  for k := 0 to high(actores) do
    actores[k].opt_cargue(spx);

  // !!!! OJO, los encadenamientos hay que resolverlos antes de
  // fijar las restricciones de caja, pera que los cambios de variables
  // tengan efecto en todas las filas.
  for k := 0 to high(hidraulicos) do
    hidraulicos[k].ResolverEncadenamientos(spx);

  // le damos la oportunidad a las fuentes con estado de cargar
  for k := 0 to high(fuentes_) do
    fuentes_[k].opt_cargue(spx);



  // fijar las restricciones es lo ltimo que hacemos pues cambia
  // la columna de los trminos independientes
  for k := 0 to high(actores) do
    actores[k].opt_fijarRestriccionesDeCaja(spx);

  try



(* Fallo con mejor camino Test20140727
 if ( globs.kPaso_ = 198) and ( globs.kCronica = 1 )
      and ( globs.CF.ordinalEstrellaActual = 31) then
      spx.DumpSistemaToXLT_('Problema_planteado_kPaso_' + IntToStr(
        globs.kPaso_)+'_kEstrellita_'+ IntToStr( globs.CF.ordinalEstrellaActual )+'_' + EscenarioActivo.nombre+ '.XLT', '..para debug..');
                                      *)

    if ( globs.kPaso_ = 1) and ( globs.kCronica = 1 )
         and ( globs.EstadoDeLaSala =   CES_SIMULANDO ) then
         spx.DumpSistemaToXLT_('Problema_planteado_kPaso_' + IntToStr(
           globs.kPaso_)+'_' + EscenarioActivo.nombre+ '.XLT', '..para debug..');


// writeln( 'kPaso: ', globs.kPaso_, ', kCron: ', globs.kCronica, ', kEstrella: ', globs.CF.ordinalEstrellaActual, ', kIter: ', globs.cntIteracionesDelPaso );

    ispxres := spx.resolver;

    if ispxres < 0 then
    begin
      raise Exception.Create('ERROR DE DATOS, NO ENCONTRE DESPACHO FACTIBLE!!! ispxres:'
        + IntToStr(ispxres) + ' kpaso:' + IntToStr(globs.kPaso_) +
        ', kCronica: ' + IntToStr(globs.kCronica) + ', nIterDelPaso:'
        {$IFDEF ITERAR}
        + IntToStr(globs.cntIteracionesDelPaso)
        {$ENDIF}
        );
    end;

    (***
  if ( globs.kPaso_ = 364 ) and ( globs.CF.ordinalEstrellaActual = 1 ) then
      spx.DumpSistemaToXLT_('Problema_resuelto_kPaso_' + IntToStr(
        globs.kPaso_)+'_kEstrellita_'+ IntToStr( globs.CF.ordinalEstrellaActual )+'_' + EscenarioActivo.nombre+ '.XLT', '..para debug..');
***)
  except
    On E: Exception do
    begin
      spx.DumpSistemaToXLT_('DESPACHOINFACTIBLE.XLT', e.Message);
      dump_Variables;
      raise;
    end;
  end;


  globs.costodelpaso := -spx.fval;

  // spx.DumpSistemaToXLT('_rch_2' + genStrPasoCronEstrIter + '.xlt', '');

  // spx.DumpSistemaToXLT('spx-despuesderesolver.xlt', 'debug');

  self.costoDirectoDelPaso := 0.0;
  self.utilidadDirectaDelPaso := 0.0;
  for k := 0 to high(actores) do
  begin
    actores[k].opt_leerSolucion(spx);
    costoDirectoDelPaso := costoDirectoDelPaso + actores[k].costoDirectoDelPaso;
    utilidadDirectaDelPaso := utilidadDirectaDelPaso + actores[k].utilidadDirectaDelPaso;
  end;

  Result := -spx.fval;
end;

procedure TSalaDeJuego.Sim_Paso_Fin;
var
  k: integer;
begin
  for k := 0 to lst_Sim_Paso_Fin.Count - 1 do
    TActor(lst_Sim_Paso_Fin[k]).Sim_Paso_Fin;
  globs.procNot(globs.procNot_FinPaso);
end;


procedure TSalaDeJuego.CalcularGradientesDeInversion;
var
  k: integer;
begin
  for k := 0 to lst_CalcularGradienteDeInviersion.Count - 1 do
    TGenerador(lst_CalcularGradienteDeInviersion[k]).CalcularGradienteDeInversion;
end;




procedure TSalaDeJuego.CapturarResultadosDelPaso;
begin
end;

procedure TSalaDeJuego.Sim_Cronica_Fin;
var
  k: integer;
  {$IFDEF DUMP_TEXT_SIMRES}
  fsal: textfile;
  {$ENDIF}
begin
  for k := 0 to high(actores) do
    actores[k].Sim_Cronica_Fin;


  {$IFDEF DUMP_TEXT_SIMRES}
  assignfile(fsal, dirResultadosCorrida + 'estado_fin_cron_' +
    IntToStr(globs.semilla_inicial_sim) + 'x' + IntToStr(Globs.kCronica) +
    '_' + EscenarioActivo.nombre + '.xlt');
  rewrite(fsal);

  for k := 0 to high(fuentes_) do
    fuentes_[k].sim_FinCronicaPrintEstadoFinal(fsal);
  for k := 0 to high(actores) do
    actores[k].sim_FinCronicaPrintEstadoFinal(fsal);
  closefile(fsal);
  {$ENDIF}


  globs.procNot(globs.procNot_FinCronica);
  Inc(globs.kCronica);
end;

procedure TSalaDeJuego.FinSimulacion;
begin
  globs.procNot(globs.procNot_FinSimulacion);
end;

procedure TSalaDeJuego.FinOptimizacion;
begin
  globs.procNot(globs.procNot_opt_FinOptimizacion);
end;

function TSalaDeJuego.optx_nvxs: integer;
var
  oldIvar_xr, oldIvar_xd: integer;
  nFuentesConEstado, nFuentesSinEstado: integer;
  k: integer;
begin
  // ahora determinamos la dimensin del espacio de estado y los frames
  // de variables auxiliares que sea necesario crear.
  ivar_xr := 0;
  ivar_xd := 0;
  ivar_auxNReal := 0;
  ivar_auxInt := 0;
  for k := 0 to high(actores) do
    actores[k].optx_nvxs(ivar_xr, ivar_xd, ivar_auxNReal, ivar_auxInt);

  SetLength(fuentesConBCSinEstadoEnCF, length(fuentes_));
  SetLength(fuentesConBCConEstadoEnCF, length(fuentes_));

  oldIvar_xr := ivar_xr;
  oldIvar_xd := ivar_xd;
  nFuentesConEstado := 0;
  nFuentesSinEstado := 0;
  for k := 0 to high(fuentes_) do
  begin
    fuentes_[k].optx_nvxs(ivar_xr, ivar_xd, ivar_auxNReal, ivar_auxInt);
    if fuentes_[k].dim_BC > 0 then
    begin
      if (oldIvar_xr = ivar_xr) and (oldIvar_xd = ivar_xd) then //No registro estado
      begin
        fuentesConBCSinEstadoEnCF[nFuentesSinEstado] := fuentes_[k];
        nFuentesSinEstado := nFuentesSinEstado + 1;
      end
      else
      begin
        fuentesConBCConEstadoEnCF[nFuentesConEstado] := fuentes_[k];
        nFuentesConEstado := nFuentesConEstado + 1;
      end;
    end;
    oldIvar_xr := ivar_xr;
    oldIvar_xd := ivar_xd;
  end;
  if nFuentesSinEstado <> 0 then
    fuentesConBCSinEstadoEnCF := copy(fuentesConBCSinEstadoEnCF, 0, nFuentesSinEstado)
  else
    fuentesConBCSinEstadoEnCF := nil;
  if nFuentesConEstado <> 0 then
    fuentesConBCConEstadoEnCF := copy(fuentesConBCConEstadoEnCF, 0, nFuentesConEstado)
  else
    fuentesConBCConEstadoEnCF := nil;
  Result := ivar_xr + ivar_xd;
end;

function TSalaDeJuego.ContarVariablesDeEstado: integer;
begin
  optx_nvxs;
  Result := ivar_xr + ivar_xd;
end;

function TSalaDeJuego.generarResumenTermicoPrimerasFichas: string;
var
  archi: TextFile;
  i: integer;
  res: string;
begin
  if not DirectoryExists(dirResultadosCorrida) then
    MkDir(dirResultadosCorrida);
  res := dirResultadosCorrida + 'resumen_termico_' +
    nombreArchSinExtension(archiSala) + '_' + EscenarioActivo.nombre + '.xlt';
  AssignFile(archi, res);
  try
    Rewrite(archi);
    TGTer.generarLineaEncabezadosResumen(archi);
    for i := 0 to Gens_.Count - 1 do
      if Gens_[i] is TGTer then
        (Gens_[i] as TGter).generarLineaResumenPrimerFicha(archi);
    Result := res;
  finally
    CloseFile(archi);
  end;
end;



procedure TSalaDeJuego.EvolucionarEstado;
var
  k: integer;
begin
  for k := 0 to lst_actores_evolucionarEstado.Count - 1 do
    TActor(lst_actores_evolucionarEstado[k]).EvolucionarEstado;
  for k := 0 to lst_fuentes_evolucionarEstado.Count - 1 do
    TFuenteAleatoria(lst_fuentes_evolucionarEstado[k]).EvolucionarEstado;
end;




procedure TSalaDeJuego.inicializarSimulacion(const SalaMadre: TSalaDeJuego;
  const costoFuturo, costoFuturoAuxiliar: TMatOfNReal);
begin
  InicializarSimulacion_subproc01(True);
  if CostoFuturo <> nil then
  begin
    globs.CF.CrearElEspacioTiempo(globs.fechaIniOpt, globs.fechaFinOpt,
      globs.HorasDelPaso, costoFuturo, globs.Deterministico);
  end;
end;



procedure TSalaDeJuego.InicializarSimulacion_subproc01(print: boolean);
begin
  globs.EstadoDeLaSala := CES_SIMULANDO;

  //Para sacar los warnings
  CFAux := nil;
  CFaux_AlInicioDelPaso := 0;

{$IFDEF DUMP_TEXT_SIMRES}
  if print then
  begin
    //Creo el archivo de simres
    if not DirectoryExists(dirResultadosCorrida) then
      MkDir(dirResultadosCorrida);
    if globs.Calcular_EmisionesCO2 then
      Calculador_CO2 := TCalculadorEmisionesCO2.Create(self);
  end;
{$ENDIF}

  {$IFDEF MIPSimplex}
  spx := TMipSimplex.Create_init(1, 1, 1, self.getNombreVar, self.getNombreRes);
  // solo para que est definido.
  {$ELSE}
  spx := TSimplex.Create_init(1, 1, self.getNombreVar, self.getNombreRes);
  // solo para que est definido.
  {$ENDIF}

  // Preparamos la sala y los actores.
  Prepararse(True);

  //Publica todas las variables de la sala
  publicarTodasLasVariables;

  // Determinamos la dimesin del espacio de estados y si es necesario
  // crear frames auxiliares del estado para clculos iterativos.
  optx_nvxs;

  Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
  Armar_lst_Sim_Paso_Fin;
  Armar_lst_CalcularGradienteDeInversion;

  Armar_lst_EvolucionarEstado;
  {$IFDEF ITERAR}
  Armar_lst_necesitoIterar;
  {$ENDIF}
  Armar_lst_Sim_cronicaIdInicio;
end;

function TSalaDeJuego.SimularRangoCronicas(kCronicaIni, kCronicaFin: integer;
  print: boolean): NReal;

var
  jCronica: integer;
{$IFDEF DUMP_TEXT_SIMRES}
  kactorres, kfuenterres: integer;
{$ENDIF}
  costoAcumCronica: NReal;
  utilidadAcumCronica: NReal;
  nCronicasRango: integer;
  fsal: textfile;
  flg_EnGuardaSim: boolean;

begin
  nCronicasRango := kCronicaFin - kCronicaIni + 1;
  if ArchivoCFAux.archi <> '' then
    CFAux := TAdminEstados.CreateLoadFromArchi(ArchivoCFAux.archi);

 {$IFDEF DUMP_TEXT_SIMRES}
  if print then
  begin
    assignfile(fsal, dirResultadosCorrida + 'simres_' + IntToStr(
      globs.semilla_inicial_sim) + 'x' + IntToStr(nCronicasRango) +
      '_' + EscenarioActivo.nombre + '_' + IntToStr(kCronicaIni) +
      '_' + IntToStr(kCronicaFin) + '.xlt');
    rewrite(fsal);
    printEncabezadoSimRes(fsal);
  end;
    {$ENDIF}
  globs.procNot(globs.procNot_InicioSimulacion);
  globs.kCronica := kCronicaIni;
  while (globs.kCronica <= kCronicaFin) and (not globs.abortarSim) do
  begin
    Sim_Cronica_Inicio;


    flg_EnGuardaSim := globs.fechaGuardaSim.EsMayorQue(globs.fechaIniSim) = 1;

    // inicializamos los acumuladore de costo y utilidad de la crnica
    costoAcumCronica := 0;
    utilidadAcumCronica := 0;
    qAct := 1;
      {$IFDEF DUMP_TEXT_SIMRES}
    if print then
    begin
      writeln(fsal);
      Write(fsal, 'CRONICA:', #9, globs.kCronica, #9, 'SemillaAleatoria:', #9,
        globs.MadresUniformes.get_UltimaSemilla);
      for kfuenterres := 0 to lst_Sim_cronicaIdInicio.Count - 1 do
      begin
        idCronicaInicioFuenteK :=
          TFuenteAleatoria(lst_Sim_cronicaIdInicio[kfuenterres]).cronicaIdInicio;
        if idCronicaInicioFuenteK <> '' then
          Write(fsal, #9, idCronicaInicioFuenteK);
      end;
      writeln(fsal);

      // PRINT kencab= 0
      Write(fsal, '-', #9, '-');
      for kactorres := 0 to high(actores) do
        actores[kactorres].sim_PrintResultados_Encab(fsal, 0);
      for kfuenterres := 0 to high(fuentes_) do
        fuentes_[kfuenterres].sim_PrintResultados_Encab(fsal, 0);
      Write(fsal, #9, '-');
      if CFaux <> nil then
        Write(fsal, #9, '-');
      Write(fsal, #9, '-');
      Write(fsal, #9, '-');
      writeln(fsal, #9, '-');

      // PRINT kencab= 1
      Write(fsal, '-', #9, '-');
      for kactorres := 0 to high(actores) do
        actores[kactorres].sim_PrintResultados_Encab(fsal, 1);
      for kfuenterres := 0 to high(fuentes_) do
        fuentes_[kfuenterres].sim_PrintResultados_Encab(fsal, 1);
      Write(fsal, #9, '[USD]');
      if CFaux <> nil then
        Write(fsal, #9, '[USD]');
      Write(fsal, #9, '[USD]');
      Write(fsal, #9, '[USD]');
      Write(fsal, #9, '[USD]');
      writeln(fsal, #9, '[u]');

      // PRINT kencab= 2
      Write(fsal, '-', #9, '-');
      for kactorres := 0 to high(actores) do
        actores[kactorres].sim_PrintResultados_Encab(fsal, 2);
      for kfuenterres := 0 to high(fuentes_) do
        fuentes_[kfuenterres].sim_PrintResultados_Encab(fsal, 2);
      Write(fsal, #9, 'CF_AlInicioDelPaso');
      if CFaux <> nil then
        Write(fsal, #9, 'CFaux');
      Write(fsal, #9, 'CPDirecto');
      Write(fsal, #9, 'UPDirecta');
      Write(fsal, #9, 'CPSimplex');
      writeln(fsal, #9, 'cntIterPaso');

      // PRINT kencab= 3
      Write(fsal, 'Paso', #9, 'FechaInicioDelPaso');
      for kactorres := 0 to high(actores) do
        actores[kactorres].sim_PrintResultados_Encab(fsal, 3);
      for kfuenterres := 0 to high(fuentes_) do
        fuentes_[kfuenterres].sim_PrintResultados_Encab(fsal, 3);
      Write(fsal, #9, '0');
      if CFaux <> nil then
        Write(fsal, #9, '0');
      Write(fsal, #9, '0');
      Write(fsal, #9, '0');
      writeln(fsal, #9, '0');


      if globs.Calcular_EmisionesCO2 then
        TCalculadorEmisionesCO2(Calculador_CO2).InicioDeCronica;
    end;
      {$ENDIF}


    while (globs.kPaso_ <= globs.nPasos) and (not globs.abortarSim) do
    begin
      globs.procNot(globs.procNot_InicioPaso);

      // si est activada la GuardaSim, nos fijamos si corresponde desactivarla
      if flg_EnGuardaSim then
        flg_EnGuardaSim := globs.fechaGuardaSim.EsMayorQue(
          globs.FechaInicioDelpaso) = 1;

      //prepararSalaParaPaso;
      globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);

      PrepararPaso_as;
      SorteosDelPasoSim(True);

      {$IFDEF CALC_CF_INICIO_PASO}
      if globs.CF <> nil then
      begin
        ActualizarEstadoGlobal(False);
        CF_AlInicioDelPaso := globs.CF.costoContinuo(globs.kPaso_);
      end
      else
        CF_AlInicioDelPaso := 0;

      if CFaux <> nil then
      begin
        tmpCF := globs.CF;
        globs.CF := CFaux;
        globs.CFAuxActivo := True;
        ActualizarEstadoGlobal(False);
        globs.CFAuxActivo := False;
        globs.CF := tmpCF;
        CFaux_AlInicioDelPaso := CFaux.costoContinuo(globs.kPaso_);
      end;
      {$ENDIF}

      {$IFNDEF DEV_CF_ESTRELLA}
   // rch@201408261123 agrego que Actulizo de nuevo el estado pero en la proyeccin
   // para que las derivadas tengan en cuenta la proyeccin "central" de Xs.
      ActualizarEstadoGlobal(true);
      {$ENDIF}

      Fuentes_PrepararPaso_ps;
{$IFDEF ITERAR}
      globs.cntIteracionesDelPaso := 0;
      repeat
        Inc(globs.cntIteracionesDelPaso);
        Actores_PrepararPaso_ps;
        CostoDelPaso_spx := ResolverPaso;
      until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_SIM) or
        (not NecesitoIterar);
{$ELSE}
      Actores_PrepararPaso_ps;
      costoDelPaso_spx := ResolverPaso;
{$ENDIF}
      Sim_Paso_Fin;
      CalcularGradientesDeInversion;

        {$IFDEF DUMP_TEXT_SIMRES}
      if print and not flg_EnGuardaSim then
      begin
        Write(fsal, IntToStr(globs.kPaso_), #9, globs.FechaInicioDelPaso.AsISOStr);
        for kactorres := 0 to high(actores) do
          actores[kactorres].sim_PrintResultados(fsal);
        for kfuenterres := 0 to high(fuentes_) do
          fuentes_[kfuenterres].sim_PrintResultados(fsal);

        Write(fsal, #9, FloatToStrF(CF_AlInicioDelPaso, formatoReales, 12, 1));
        if CFAux <> nil then
          Write(fsal, #9, FloatToStrF(CFAux_AlInicioDelPaso, formatoReales, 12, 1));

        Write(fsal, #9, FloatToStrF(costoDirectoDelPaso, formatoReales, 12, 1));
        Write(fsal, #9, FloatToStrF(utilidadDirectaDelPaso, formatoReales, 12, 1));

        Write(fsal, #9, FloatToStrF(costoDelPaso_spx, formatoReales, 12, 1));
{$IFDEF ITERAR}
        writeln(fsal, #9, globs.cntIteracionesDelPaso);
{$ELSE}
        writeln(fsal, #9, -1);
{$ENDIF}


        if globs.Calcular_EmisionesCO2 then
          TCalculadorEmisionesCO2(Calculador_CO2).FinDelPaso;
      end;
{$ENDIF}

      EvolucionarEstado;
      globs.Fijar_kPaso(globs.kPaso_ + 1);

      if not flg_EnGuardaSim then
      begin
        costoAcumCronica := costoAcumCronica + costoDirectoDelPaso * qAct;
        utilidadAcumCronica := utilidadAcumCronica + utilidadDirectaDelPaso * qAct;
        qAct := qAct * globs.fActPaso;
      end;
    end;

    (*** ahora guardo el resultado de la crnica y le sumo el CF_AlFinal de la misma **)
    if globs.CF <> nil then
    begin
      ActualizarEstadoGlobal(false);
      CF_AlFinalDeLaCronica := globs.CF.costoContinuo(globs.kPaso_);
    end
    else
      CF_AlFinalDeLaCronica := 0;

    Acumuladores.cdpAcum[globs.kcronica] := costoAcumCronica;
    Acumuladores.udpAcum[globs.kcronica] := utilidadAcumCronica;

    Acumuladores.CF_final[globs.kcronica] := qAct * CF_AlFinalDeLaCronica;

    Acumuladores.costosAcum[globs.kcronica] :=
      costoAcumCronica + Acumuladores.CF_final[globs.kcronica];

    if CFaux <> nil then
    begin
      tmpCF := globs.CF;
      globs.CF := CFaux;
      globs.CFAuxActivo := True;
      ActualizarEstadoGlobal(false);
      globs.CFAuxActivo := False;
      globs.CF := tmpCF;
      CF_AlFinalDeLaCronica := CFaux.costoContinuo(globs.kPaso_);
      Acumuladores.CFaux_final[globs.kcronica] := qAct * CF_AlFinalDeLaCronica;
      Acumuladores.costosAcum_aux[globs.kcronica] :=
        costoAcumCronica + Acumuladores.CFaux_final[globs.kcronica];
    end;

    {$IFDEF DUMP_TEXT_SIMRES}
    if print then
      if globs.Calcular_EmisionesCO2 then
        TCalculadorEmisionesCO2(Calculador_CO2).FinCronica;
    {$ENDIF}


    Sim_Cronica_Fin; // entre otras cosas incrementa globs.kCronica
  end;
end;


procedure TSalaDeJuego.FinSim_workers;
begin
  FinSimulacion;
  globs.EstadoDeLaSala := CES_SIMULACION_TERMINADA;
end;

function TSalaDeJuego.FinSim_Master(Print: boolean): NReal;
var
  res: NReal;

begin
  if print then
  begin
    {$IFDEF DUMP_TEXT_SIMRES}
    printFinalSimRes(fsal);
    Close(fsal);
    if globs.Calcular_EmisionesCO2 then
      TCalculadorEmisionesCO2(Calculador_CO2).Free;
    {$ENDIF}
    res := Acumuladores.PrinArchi(dirResultadosCorrida + 'simcosto_' +
      IntToStr(globs.semilla_inicial_sim) + 'x' + IntToStr(
      globs.NCronicasSim) + '_' + EscenarioActivo.nombre + '.xlt');
  end;

  if globs.EstadoDeLaSala <> CES_SIMULACION_TERMINADA then
    globs.EstadoDeLaSala := CES_SIMULACION_ABORTADA;

  if CFAux <> nil then
    CFAux.Free;

  Result := res;
end;

function TSalaDeJuego.Simular(id_hilo: integer; print: boolean): NReal;
var
  costoAcumCronica: NReal;
  utilidadAcumCronica: NReal;

  qAct: NReal;
  idCronicaInicioFuenteK: string;
  tmpCF, CFAux: TAdminEstados;

{$IFDEF DUMP_TEXT_SIMRES}
  fsal: TextFile;
  kactorres, kfuenterres: integer;
{$ENDIF}
  CostoAcumVaR95: NReal;
  jCronica: integer;
  CF_AlFinalDeLaCronica: NReal;

  Calculador_CO2: TCalculadorEmisionesCO2;

  VE_CF: NReal;

  flg_EnGuardaSim: boolean;

begin

  globs.EstadoDeLaSala := CES_SIMULANDO;

  //Para sacar los warnings
  CFAux := nil;
  CFaux_AlInicioDelPaso := 0;

{$IFDEF DUMP_TEXT_SIMRES}
  if print then
  begin
    //Creo el archivo de simres
    if not DirectoryExists(dirResultadosCorrida) then
      MkDir(dirResultadosCorrida);

    assignfile(fsal, dirResultadosCorrida + 'simres_' + IntToStr(
      globs.semilla_inicial_sim + id_hilo) + 'x' + IntToStr(Globs.NCronicasSim) +
      '_' + EscenarioActivo.nombre + '.xlt');
    rewrite(fsal);

    if globs.Calcular_EmisionesCO2 then
      Calculador_CO2 := TCalculadorEmisionesCO2.Create(self);
  end;
{$ENDIF}


  try
    {$IFDEF MIPSimplex}

    spx := TMipSimplex.Create_init(1, 1, 1, self.getNombreVar, self.getNombreRes);
    // solo para que est definido.
    {$ELSE}
    spx := TSimplex.Create_init(1, 1, self.getNombreVar, self.getNombreRes);
    // solo para que est definido.
    {$ENDIF}

    // Preparamos la sala y los actores.
    Prepararse(True);

    {$IFDEF SMART_VAR_DUMP}
    //Publicamos las variables
    if globs.publicarSoloVariablesUsadasEnSimRes3 then
      publicarSoloVariablesUsadasEnSimRes3
    else
      publicarTodasLasVariables;
    {$ELSE}
    publicarTodasLasVariables;
    {$ENDIF}


    // Determinamos la dimesin del espacio de estados y si es necesario
    // crear frames auxiliares del estado para clculos iterativos.
    optx_nvxs;


    Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
    Armar_lst_Sim_Paso_Fin;
    Armar_lst_CalcularGradienteDeInversion;

    Armar_lst_EvolucionarEstado;
    {$IFDEF ITERAR}
    Armar_lst_necesitoIterar;
    {$ENDIF}

    Armar_lst_Sim_cronicaIdInicio;


    if ArchivoCFAux.archi <> '' then
    begin
      CFAux := TAdminEstados.CreateLoadFromArchi(ArchivoCFAux.archi);
      globs.CF.ChequearCompatibilidad_CFAux(CFAux);
    end;

    {$IFDEF DUMP_TEXT_SIMRES}
    if print then
      printEncabezadoSimRes(fsal);
    {$ENDIF}

    globs.procNot(globs.procNot_InicioSimulacion);

    globs.kCronica := 1;


    Acumuladores := TAcumuladores_Sim.Create(globs, globs.NCronicasSim);

    while (globs.kCronica <= globs.NCronicasSim) and (not globs.abortarSim) do
    begin


      Sim_Cronica_Inicio;
      // inicializamos los acumuladore de costo y utilidad de la crnica
      costoAcumCronica := 0;
      utilidadAcumCronica := 0;
      qAct := 1;

      // Si corresponde activamos la Guarda de Simulacin
      flg_EnGuardaSim := globs.fechaGuardaSim.EsMayorQue(globs.fechaIniSim) = 1;


      {$IFDEF DUMP_TEXT_SIMRES}
      if print then
      begin
        writeln(fsal);
        Write(fsal, 'CRONICA:', #9, globs.kCronica, #9, 'SemillaAleatoria:', #9,
          globs.MadresUniformes.get_UltimaSemilla);
        for kfuenterres := 0 to lst_Sim_cronicaIdInicio.Count - 1 do
        begin
          idCronicaInicioFuenteK :=
            TFuenteAleatoria(lst_Sim_cronicaIdInicio[kfuenterres]).cronicaIdInicio;
          if idCronicaInicioFuenteK <> '' then
            Write(fsal, #9, idCronicaInicioFuenteK);
        end;
        writeln(fsal);

        // PRINT kencab= 0
        Write(fsal, '-', #9, '-');
        for kactorres := 0 to high(actores) do
          actores[kactorres].sim_PrintResultados_Encab(fsal, 0);
        for kfuenterres := 0 to high(fuentes_) do
          fuentes_[kfuenterres].sim_PrintResultados_Encab(fsal, 0);
        Write(fsal, #9, '-');
        if CFaux <> nil then
          Write(fsal, #9, '-');
        Write(fsal, #9, '-');
        Write(fsal, #9, '-');
        writeln(fsal, #9, '-');

        // PRINT kencab= 1
        Write(fsal, '-', #9, '-');
        for kactorres := 0 to high(actores) do
          actores[kactorres].sim_PrintResultados_Encab(fsal, 1);
        for kfuenterres := 0 to high(fuentes_) do
          fuentes_[kfuenterres].sim_PrintResultados_Encab(fsal, 1);
        Write(fsal, #9, '[USD]');
        if CFaux <> nil then
          Write(fsal, #9, '[USD]');
        Write(fsal, #9, '[USD]');
        Write(fsal, #9, '[USD]');
        Write(fsal, #9, '[USD]');
        writeln(fsal, #9, '[u]');

        // PRINT kencab= 2
        Write(fsal, '-', #9, '-');
        for kactorres := 0 to high(actores) do
          actores[kactorres].sim_PrintResultados_Encab(fsal, 2);
        for kfuenterres := 0 to high(fuentes_) do
          fuentes_[kfuenterres].sim_PrintResultados_Encab(fsal, 2);
        Write(fsal, #9, 'CF_AlInicioDelPaso');
        if CFaux <> nil then
          Write(fsal, #9, 'CFaux');
        Write(fsal, #9, 'CPDirecto');
        Write(fsal, #9, 'UPDirecta');
        Write(fsal, #9, 'CPSimplex');
        writeln(fsal, #9, 'cntIterPaso');

        // PRINT kencab= 3
        Write(fsal, 'Paso', #9, 'FechaInicioDelPaso');
        for kactorres := 0 to high(actores) do
          actores[kactorres].sim_PrintResultados_Encab(fsal, 3);
        for kfuenterres := 0 to high(fuentes_) do
          fuentes_[kfuenterres].sim_PrintResultados_Encab(fsal, 3);
        Write(fsal, #9, '0');
        if CFaux <> nil then
          Write(fsal, #9, '0');
        Write(fsal, #9, '0');
        Write(fsal, #9, '0');
        writeln(fsal, #9, '0');


        if globs.Calcular_EmisionesCO2 then
          Calculador_CO2.InicioDeCronica;
      end;
      {$ENDIF}


      while (globs.kPaso_ <= globs.nPasos) and (not globs.abortarSim) do
      begin
        // writeln( 'globs.kCronica: ', globs.kCronica , ', globs.kPaso_: ', globs.kPaso_ );
        globs.procNot(globs.procNot_InicioPaso);

        // si est activada la GuardaSim, nos fijamos si corresponde desactivarla
        if flg_EnGuardaSim then
          flg_EnGuardaSim := globs.fechaGuardaSim.EsMayorQue(
            globs.FechaInicioDelpaso) = 1;

        //prepararSalaParaPaso;
        globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);

        PrepararPaso_as;
        SorteosDelPasoSim(True);

        {$IFDEF CALC_CF_INICIO_PASO}
        if globs.CF <> nil then
        begin
          ActualizarEstadoGlobal(false);
          CF_AlInicioDelPaso := globs.CF.costoContinuo(globs.kPaso_);
        end
        else
          CF_AlInicioDelPaso := 0;

        if CFaux <> nil then
        begin
          tmpCF := globs.CF;
          globs.CF := CFaux;
          globs.CFAuxActivo := True;
          ActualizarEstadoGlobal(false);
          globs.CFAuxActivo := False;
          globs.CF := tmpCF;
          CFaux_AlInicioDelPaso := CFaux.costoContinuo(globs.kPaso_);
        end;
        {$ENDIF}

       {$IFNDEF DEV_CF_ESTRELLA}
// rch@201408261144 Agrego que POYECTEN el Xs (lo de CF_AlInicioDelPaso est dems).
// no lo borro ahora para no jorobar las plantillas SimRes3 que estn funcioando.
// pero se puede ganar eficiencia haciendo
        ActualizarEstadoGlobal(true);
        {$ENDIF}

        Fuentes_PrepararPaso_ps;


{$IFDEF ITERAR}
        globs.cntIteracionesDelPaso := 0;
        repeat
          Inc(globs.cntIteracionesDelPaso);
          Actores_PrepararPaso_ps;
          CostoDelPaso_spx := ResolverPaso;
        until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_SIM) or
          (not NecesitoIterar);
{$ELSE}
        Actores_PrepararPaso_ps;
        costoDelPaso_spx := ResolverPaso;
{$ENDIF}
        Sim_Paso_Fin;
        CalcularGradientesDeInversion;

        {$IFDEF DUMP_TEXT_SIMRES}
        if print and not flg_EnGuardaSim then
        begin
          Write(fsal, IntToStr(globs.kPaso_), #9, globs.FechaInicioDelPaso.AsISOStr);
          for kactorres := 0 to high(actores) do
            actores[kactorres].sim_PrintResultados(fsal);
          for kfuenterres := 0 to high(fuentes_) do
            fuentes_[kfuenterres].sim_PrintResultados(fsal);

          Write(fsal, #9, FloatToStrF(CF_AlInicioDelPaso, formatoReales, 12, 1));
          if CFAux <> nil then
            Write(fsal, #9, FloatToStrF(CFAux_AlInicioDelPaso, formatoReales, 12, 1));

          Write(fsal, #9, FloatToStrF(costoDirectoDelPaso, formatoReales, 12, 1));
          Write(fsal, #9, FloatToStrF(utilidadDirectaDelPaso, formatoReales, 12, 1));

          Write(fsal, #9, FloatToStrF(costoDelPaso_spx, formatoReales, 12, 1));
{$IFDEF ITERAR}
          writeln(fsal, #9, globs.cntIteracionesDelPaso);
{$ELSE}
          writeln(fsal, #9, -1);
{$ENDIF}


          if globs.Calcular_EmisionesCO2 then
            Calculador_CO2.FinDelPaso;
        end;
{$ENDIF}


        EvolucionarEstado;

        globs.Fijar_kPaso(globs.kPaso_ + 1);

        if not flg_EnGuardaSim then
        begin
          costoAcumCronica := costoAcumCronica + costoDirectoDelPaso * qAct;
          utilidadAcumCronica := utilidadAcumCronica + utilidadDirectaDelPaso * qAct;
          qAct := qAct * globs.fActPaso;
        end;
      end;

      (*** ahora guardo el resultado de la crnica y le sumo el CF_AlFinal de la misma **)
      if globs.CF <> nil then
      begin
        ActualizarEstadoGlobal(false);
        CF_AlFinalDeLaCronica := globs.CF.costoContinuo(globs.kPaso_);
      end
      else
        CF_AlFinalDeLaCronica := 0;

      Acumuladores.cdpAcum[globs.kcronica - 1] := costoAcumCronica;
      Acumuladores.udpAcum[globs.kcronica - 1] := utilidadAcumCronica;

      Acumuladores.CF_final[globs.kcronica - 1] := qAct * CF_AlFinalDeLaCronica;

      Acumuladores.costosAcum[globs.kcronica - 1] :=
        costoAcumCronica + Acumuladores.CF_final[globs.kcronica - 1];

      if CFaux <> nil then
      begin
        tmpCF := globs.CF;
        globs.CF := CFaux;
        globs.CFAuxActivo := True;
        ActualizarEstadoGlobal(false);
        globs.CFAuxActivo := False;
        globs.CF := tmpCF;
        CF_AlFinalDeLaCronica := CFaux.costoContinuo(globs.kPaso_);
        Acumuladores.CFaux_final[globs.kcronica - 1] := qAct * CF_AlFinalDeLaCronica;
        Acumuladores.costosAcum_aux[globs.kcronica - 1] :=
          costoAcumCronica + Acumuladores.CFaux_final[globs.kcronica - 1];
      end;

    {$IFDEF DUMP_TEXT_SIMRES}
      if print then
        if globs.Calcular_EmisionesCO2 then
          Calculador_CO2.FinCronica;
    {$ENDIF}

      Sim_Cronica_Fin; // entre otras cosas incrementa globs.kCronica

    end;
    FinSimulacion;
    globs.EstadoDeLaSala := CES_SIMULACION_TERMINADA;

    if print then
    begin
    {$IFDEF DUMP_TEXT_SIMRES}
      printFinalSimRes(fsal);
      Close(fsal);
      if globs.Calcular_EmisionesCO2 then
        Calculador_CO2.Free;
    {$ENDIF}

      VE_CF := Acumuladores.PrinArchi(dirResultadosCorrida + 'simcosto_' +
        IntToStr(globs.semilla_inicial_sim) + 'x' +
        IntToStr(Globs.NCronicasSim) + '_' + EscenarioActivo.nombre + '.xlt');
    end
    else
      VE_CF := Acumuladores.VE_CF_MUSD;

    Acumuladores.Free;


  finally

    if globs.EstadoDeLaSala <> CES_SIMULACION_TERMINADA then
      globs.EstadoDeLaSala := CES_SIMULACION_ABORTADA;

    if CFAux <> nil then
      CFAux.Free;
  end;
  Result := VE_CF;
end;



procedure TSalaDeJuego.ImprimirPotenciasFirmes;

  procedure PrintEncabezado(var fPotsFirmes: TextFile);
  var
    iposteres, kactor: integer;
  begin
    system.Writeln(fPotsFirmes, 'Versin del simulador:'#9, vSimSEESimulador);
    system.writeln(fPotsFirmes, 'Inicio simulacin: '#9, DateTimeToIsoStr(now()));
    system.Writeln(fPotsFirmes, 'FechaIniSim: '#9, globs.fechaIniSim.AsISOStr,
      #9, 'FechaFinSim: ', #9, globs.fechaFinSim.AsISOStr);
    system.writeln(fPotsFirmes, 'NCronicas:'#9, 1);
    system.writeln(fPotsFirmes, 'NPasos:'#9, globs.nPasos);
    system.writeln(fPotsFirmes, 'NPostes:'#9, length(globs.Durpos));
    system.Write(fPotsFirmes, 'DurPos[h]:');
    for iposteres := 0 to high(globs.DurPos) do
      Write(fPotsFirmes, #9, globs.DurPos[iposteres]: 6: 0);
    system.writeln(fPotsFirmes);
    system.writeln(fPotsFirmes, 'NActores:'#9, length(actores));
    TActor.printEncabezadoResumenSim(fPotsFirmes);
    for kactor := 0 to high(actores) do
      actores[kactor].printResumenSim(fPotsFirmes);

    writeln(fPotsFirmes);
    writeln(fPotsFirmes, 'CRONICA:'#9, globs.kCronica, #9, 'SemillaAleatoria:'#9,
      globs.MadresUniformes.get_UltimaSemilla);

    // PRINT kencab= 0
    Write(fPotsFirmes, '-'#9'-');
    for kactor := 0 to high(termicos) do
      termicos[kactor].sim_PrintResultados_Encab_PotFirme(fPotsFirmes, 0);
    writeln(fPotsFirmes);

    // PRINT kencab= 1
    Write(fPotsFirmes, '-'#9'-');
    for kactor := 0 to high(termicos) do
      termicos[kactor].sim_PrintResultados_Encab_PotFirme(fPotsFirmes, 1);
    writeln(fPotsFirmes);

    // PRINT kencab= 2
    Write(fPotsFirmes, 'Paso'#9'FechaInicioDelPaso');
    for kactor := 0 to high(termicos) do
      termicos[kactor].sim_PrintResultados_Encab_PotFirme(fPotsFirmes, 2);
    writeln(fPotsFirmes);
  end;

var
  ipaso, kactor: integer;
  fPotsFirmes_porpaso: TextFile;
  fPotsFirmes_Mensuales: TextFile;
  potFirme: array of TDAOfNReal;
  mes, anio: array of word;
  iActor: integer;
  //  I: Integer;
  cnt, jpaso: integer;
  a: NReal;

begin

  globs.EstadoDeLaSala := CES_SIMULANDO;
  try
    // Preparamos la sala y los actores.
    globs.kCronica := 1;
    Prepararse(True);

    {$IFDEF SMART_VAR_DUMP}
    //Publicamos las variables
    if globs.publicarSoloVariablesUsadasEnSimRes3 then
      publicarSoloVariablesUsadasEnSimRes3
    else
    {$ENDIF}
      publicarTodasLasVariables;

    Sim_Cronica_Inicio;

    setLength(potFirme, length(termicos));
    for iActor := 0 to high(termicos) do
      setLength(potFirme[iActor], globs.NPasos);
    setLength(mes, globs.npasos);
    setlength(anio, globs.NPasos);

    //Creo el archivo de simres
    if not DirectoryExists(dirResultadosCorrida)
    { *Converted from DirectoryExists*  } then
      MkDir(dirResultadosCorrida);

    assignfile(fPotsFirmes_porpaso, dirResultadosCorrida +
      'potencias_Termicas_Firmes_porpaso' + '_' + EscenarioActivo.nombre + '.xlt');
    rewrite(fPotsFirmes_porpaso);
    PrintEncabezado(fPotsFirmes_porpaso);

    assignfile(fPotsFirmes_mensuales, dirResultadosCorrida +
      'potencias_Termicas_Firmes_mensuales' + '_' + EscenarioActivo.nombre + '.xlt');
    rewrite(fPotsFirmes_mensuales);
    PrintEncabezado(fPotsFirmes_mensuales);

    while (globs.kPaso_ <= globs.nPasos) do
    begin
      globs.procNot(globs.procNot_InicioPaso);
      globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);
      mes[globs.kPaso_ - 1] := globs.MesInicioDelPaso;
      anio[globs.kPaso_ - 1] := globs.AnioInicioDelPaso;
      Write(fPotsFirmes_porpaso, IntToStr(globs.kPaso_), #9,
        globs.FechaInicioDelPaso.AsISOStr);
      for kactor := 0 to high(termicos) do
      begin
        potFirme[kActor][globs.kPaso_ - 1] := termicos[kactor].PotenciaFirme;
        termicos[kactor].sim_PrintResultados_PotFirme(fPotsFirmes_porpaso);
      end;
      writeln(fPotsFirmes_porpaso);
      globs.Fijar_kPaso(globs.kPaso_ + 1);
    end;
    globs.EstadoDeLaSala := CES_SIMULACION_TERMINADA;


    ipaso := 0;
    jpaso := 1;
    while ipaso < globs.npasos do
    begin
      Write(fPotsFirmes_mensuales, anio[ipaso], #9, mes[ipaso]);

      for kactor := 0 to high(termicos) do
      begin
        jpaso := ipaso + 1;
        a := potFirme[kactor][ipaso];
        cnt := 1;
        while (jpaso < globs.npasos) and (mes[jpaso] = mes[ipaso]) do
        begin
          Inc(cnt);
          a := a + potFirme[kactor][jpaso];
          Inc(jpaso);
        end;
        a := a / cnt;
        Write(fPotsFirmes_mensuales, #9, a);
      end;
      ipaso := jpaso;
      writeln(fPotsFirmes_mensuales);
    end;

  finally
    system.writeln(fPotsFirmes_porpaso, 'Fin simulacin: ', #9, DateTimeToStr(now()));
    closefile(fPotsFirmes_porpaso);
    closefile(fpotsFirmes_mensuales);
  end;
end;


{$IFDEF WINDOWS}
{$IFNDEF APLICACION_CONSOLA}

procedure PrintEncabezado_xls_Unidades(var xls: TExcelFile; sala: TSalaDeJuego;
  Generadores: array of TGenerador);
var
  kgen, kunid: integer;
  gen: TGenerador;

begin
  xls.Write('Versin del simulador:');
  xls.writeln(vSimSEESimulador);
  xls.Write('Inicio simulacin: ');
  xls.writeln(DateTimeToIsoStr(now()));
  xls.Write('FechaIniSim: ');
  xls.Write(sala.globs.fechaIniSim.AsISOStr);
  xls.Write('FechaFinSim: ');
  xls.writeln(sala.globs.fechaFinSim.AsISOStr);
  xls.Write('NGeneradores:');
  xls.writeln(length(generadores));
  xls.writeln;

  xls.Write('-');
  xls.Write('-');
  for kgen := 0 to high(generadores) do
  begin
    gen := generadores[kgen];
    for kunid := 0 to high(gen.paUnidades.nUnidades) do
      xls.Write(gen.nombre);
  end;
  xls.writeln;
end;




procedure Print_xls_UnidadesDisponibles(archiSalida: string;
  etiquetas: TDAOfString; fechas: TDAOfDateTime; unidades: TMatOfNInt);

var
  xls: TExcelFile;
  kPaso: integer;
  NPasos: integer;
  iserie: integer;
begin
  xls := TExcelFile.Create('x', False, False, True);
  xls.Write(' ');
  xls.Write(' ');
  for iserie := 0 to high(etiquetas) do
    xls.Write(etiquetas[iserie]);
  xls.writeln;

  NPasos := length(unidades[0]);
  for kPaso := 1 to NPasos do
  begin
    xls.Write(kPaso);
    xls.Write(DateTimeToIsoStr(fechas[kPaso - 1]));
    for iserie := 0 to high(unidades) do
      xls.Write(unidades[iserie][kPaso - 1]);
    xls.writeln;
  end;
  xls.Write('Fin simulacin: ');
  xls.writeln(DateTimeToStr(now()));
  xls.Guardar(archiSalida);
  xls.Free;
end;



procedure TSalaDeJuego.ImprimirUnidadesDisponibles;
var
  ipaso, kactor: integer;
  etiquetas: TDAOfString;
  fechas: TDAOfDateTime;
  unidadesDisp: TMatOfNInt;
  iActor: integer;
  cnt, jpaso: integer;
  a: NReal;
  ngeneradores: integer;
  Generadores: TDAOfGenerador;
  i, k, j: integer;
  nombre: string;
  cnt_unidades: integer;
  kGen: integer;
  gen: TGenerador;
  iUnidad, kUnidad: integer;
  archiSalida: string;

begin

  globs.EstadoDeLaSala := CES_SIMULANDO;

  // Preparamos la sala y los actores.
  globs.kCronica := 1;
  Prepararse(True);
  Sim_Cronica_Inicio;

  // Creamos array con puneros a los GENERADORES
  // y de paso contabilizamos el total de unidades (por los CCs u otros que pudieran
  // tener ms de un tipo de unidad por actor.
  setLength(Generadores, length(actores));
  cnt_unidades := 0;
  ngeneradores := 0;
  for iActor := 0 to high(actores) do
    if actores[iActor] is TGenerador then
    begin
      gen := actores[iActor] as TGenerador;
      Generadores[ngeneradores] := gen;
      Inc(ngeneradores);
      cnt_unidades := cnt_unidades + length(gen.paUnidades.nUnidades);
    end;
  setLength(Generadores, ngeneradores);

  setlength(etiquetas, cnt_unidades);
  iUnidad := 0;
  for kGen := 0 to high(generadores) do
  begin
    gen := Generadores[kGen];

    for kUnidad := 0 to length(gen.paUnidades.nUnidades) do
    begin
      etiquetas[iunidad] := gen.nombre + '_' + IntToStr(kUnidad);
      Inc(iunidad);
    end;
  end;

  setLength(unidadesDisp, cnt_unidades);
  for i := 0 to high(unidadesDisp) do
    setLength(unidadesDisp[i], globs.NPasos);


  while (globs.kPaso_ <= globs.nPasos) do
  begin
    globs.procNot(globs.procNot_InicioPaso);
    globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);

    iUnidad := 0;
    for kGen := 0 to high(generadores) do
    begin
      gen := generadores[kGen];
      for kUnidad := 0 to high(gen.paUnidades.nUnidades) do
      begin
        unidadesDisp[iUnidad][globs.kPaso_ - 1] := gen.paUnidades.nUnidades[kUnidad];
        Inc(iUnidad);
      end;
    end;
    globs.Fijar_kPaso(globs.kPaso_ + 1);
  end;
  globs.EstadoDeLaSala := CES_SIMULACION_TERMINADA;


  archiSalida := self.dirsala + nombreArchSinExtension(self.archiSala) +
    '_unidades_disponibles_' + self.EscenarioActivo.nombre + '.xls"';


  Print_xls_UnidadesDisponibles(
    archiSalida,
    etiquetas,
    fechas,
    unidadesDisp);

  setlength(generadores, 0);
  for iUnidad := 0 to high(unidadesDisp) do
    setlength(unidadesDisp[iUnidad], 0);
  setlength(unidadesDisp, 0);
  setlength(fechas, 0);
  setlength(etiquetas, 0);

end;

{$ENDIF}
{$ENDIF}

procedure TSalaDeJuego.ordenarFuentes;
var
  auxSwap, fuenteI: TFuenteAleatoria;
  huboReferencia: boolean;
  i, j: integer;
begin
  i := 0;
  //El -1 esta bien porque la ultima fuente no tiene despues de ella nadie,
  //particularmente nadie que la referencie
  while i < listaFuentes.Count - 1 do
  begin
    fuenteI := TFuenteAleatoria(listaFuentes[i]);
    huboReferencia := False;
    for j := i + 1 to listaFuentes.Count - 1 do
    begin
      if fuenteI.referenciaFuente(TFuenteAleatoria(listaFuentes[j])) then
      begin
        assert(not TFuenteAleatoria(listaFuentes[j]).referenciaFuente(fuenteI),
          'TSalaDeJuego.ordenarFuentes: hay un ciclo entre las fuentes.' +
          'Las fuentes ' + fuenteI.nombre + ' y ' +
          TFuenteAleatoria(listaFuentes[j]).nombre + ' se referencian mutuamente.');
        auxSwap := TFuenteAleatoria(listaFuentes[j]);
        listaFuentes[j] := fuenteI;
        listaFuentes[i] := auxSwap;
        huboReferencia := True;
        break;
      end;
    end;
    if not huboReferencia then
      Inc(i);
  end;
end;


{$IFDEF PDE_RIESGO}
procedure TSalaDeJuego.LlenarHistograma_CostoDelPaso_masCF_llegada(
  var HistoCF: TDAOfNReal; // Producto Cartesiano ce(kCron) x HistoCF1( jCronF )
  jBase: integer);
var
  costoDirectoDelPaso_Actores, costoDirectoDelPaso_Fuentes: NReal;
  utilidadDirectaDelPaso_Actores: NReal;
  CF_llegada: NReal;
  k: integer;
  cdp: NReal;
begin
  costoDirectoDelPaso_Actores := 0;
  for k := 0 to high(Actores) do
    costoDirectoDelPaso_Actores :=
      costoDirectoDelPaso_Actores + Actores[k].costoDirectoDelPaso;

  // no me imagino fuentes con costo pero por las dudas ponemos
  costoDirectoDelPaso_Fuentes := 0;
  for k := 0 to lst_fuentes_costoDirectoDelPaso.Count - 1 do
    costoDirectoDelPaso_Fuentes :=
      costoDirectoDelPaso_Fuentes + TFuenteAleatoria(
      lst_fuentes_costoDirectoDelPaso[k]).costoDirectoDelPaso;

  utilidadDirectaDelPaso_Actores := 0.0;
  if globs.restar_UtilidadesDelCostoFuturo then
  begin
    for k := 0 to high(Actores) do
      utilidadDirectaDelPaso_Actores :=
        utilidadDirectaDelPaso_Actores + Actores[k].utilidadDirectaDelPaso;
  end;

  {$IFNDEF DEV_CF_ESTRELLA}
  ActualizarEstadoGlobal(true);
  {$ELSE}
  ActualizarEstadoGlobal(false);
  {$ENDIF}
  // posicionamos la estrella de acuerdo al estado de los actores

  // Carga el histograma correspondiente al punto de llegada.
  globs.CF.mantoContinuo(HistoCF, jBase, globs.HistoCF1_);

  // completamos agregando el costo directo del paso y aplicando factor de actualizacin.
  cdp := costoDirectoDelPaso_Actores + costoDirectoDelPaso_Fuentes -
    utilidadDirectaDelPaso_Actores;
  for k := 0 to globs.NDiscHistoCF - 1 do
  begin
    {$IFDEF DEBUG_MULTI_HILO}
    writeln(fdebug_mh, 'estrella:'#9, globs.CF.ordinalEstrellaActual
      , #9'CActs:'#9, costoDirectoDelPaso_Actores, #9'CFuns: '#9,
      costoDirectoDelPaso_Fuentes, #9'CFLL'#9, HistoCF[jBase + k], #9'XLL',
      globs.CF.GetEstado_XLT);
    {$ENDIF}
    HistoCF[jBase + k] := cdp + globs.factPaso * HistoCF[jBase + k];
  end;
end;


procedure TSalaDeJuego.Crear_HistogramasCF(SalaMadre: TSalaDeJuego);
var
  k: integer;
begin
  if SalaMadre = nil then
  begin
    if globs.usar_CAR and globs.SortearOpt then
    begin
      setlength(globs.HistoCF1_, globs.CF.nEstrellasPorPuntoT);
      setlength(globs.HistoCF1_s, globs.CF.nEstrellasPorPuntoT);
      for k := 0 to high(globs.HistoCF1_) do
      begin
        setlength(globs.HistoCF1_[k], globs.NDiscHistoCF);
        setlength(globs.HistoCF1_s[k], globs.NDiscHistoCF);
      end;
      setlength(globs.HistoCF0, globs.CF.nEstrellasPorPuntoT);
      for k := 0 to high(globs.HistoCF0) do
        setlength(globs.HistoCF0[k], globs.NCronicasOpt * globs.NDiscHistoCF);
    end;
  end
  else
  begin
    globs.HistoCF1_ := SalaMadre.globs.HistoCF1_;
    globs.HistoCF1_s := SalaMadre.globs.HistoCF1_s;
    globs.HistoCF0 := SalaMadre.globs.HistoCF0;
  end;
end;

procedure TSalaDeJuego.Liberar_HistogramasCF(SalaMadre: TSalaDeJuego);
var
  k: integer;
begin
  if SalaMadre = nil then
  begin
    if globs.HistoCF1_ <> nil then
    begin
      for k := 0 to high(globs.HistoCF1_) do
      begin
        setlength(globs.HistoCF1_[k], 0);
        setlength(globs.HistoCF1_s[k], 0);
      end;
      setlength(globs.HistoCF1_, 0);
      setlength(globs.HistoCF1_s, 0);
    end;
    if globs.HistoCF0 <> nil then
    begin
      for k := 0 to high(globs.HistoCF0) do
        setlength(globs.HistoCF0[k], 0);
      setlength(globs.HistoCF0, 0);
    end;
  end
  else
  begin
    globs.HistoCF1_ := nil;
    globs.HistoCF1_s := nil;
    globs.HistoCF0 := nil;
  end;
end;

{$IFDEF DEBUG_HistoCF0CF1}
procedure TSalaDeJuego.Dump_HistogramasCF0CF1(caso: string; kpaso, kEstrella: integer);
var
  f: textfile;
  k: integer;

begin
  assignfile(f, 'histos_CF_estrella' + IntToStr(kEstrella) + 'paso' +
    IntToStr(kpaso) + caso + '.xlt');
  rewrite(f);
  for k := 0 to high(globs.HistoCF1_[kEstrella]) do
    writeln(f, k, #9, globs.HistoCF0[kEstrella][k], #9,
      globs.HistoCF1_[kEstrella][k], #9, globs.HistoCF1_s[kEstrella][k]);
  for k := high(globs.HistoCF1_[kEstrella]) + 1 to high(globs.HistoCF0[kEstrella]) do
    writeln(f, k, #9, globs.HistoCF0[kEstrella][k]);
  closefile(f);
end;

{$ENDIF}


procedure TSalaDeJuego.Resumir_HistogramaCF0aCF1(kEstrellaIni, kEstrellaFin: integer);
var
  kEstrella: integer;
  jBase: integer;
  CF_VE: NReal;  // Valor Esperado
  CF_VaR: NReal; // Valor a Riesgo
  CF_VpE: NReal; // Valor con Probabilidad de Excedencia
  CF_Medida: NReal;
  jPE: integer;
  jPuntoHisto: integer;
  aval: NReal;

{$IFDEF DEBUG_RESUMIR_HISTOGRAMA}
  flog: textfile;
{$ENDIF}

begin

  // aqu resumimos
  for kEstrella := kEstrellaIni to kEstrellaFin do
  begin

    {$IFDEF DEBUG_RESUMIR_HISTOGRAMA}
    if kEstrella = kEstrellaIni then
    begin
      assignfile(flog, 'carlog' + IntToStr(globs.kPaso_) + '.xlt');
      rewrite(flog);
      writeln(flog, 'globs.HistoCF0[kEstrella] antes de sort');
      printvect(flog, globs.HistoCF0[kEstrella], 200);
    end;
    {$ENDIF}

    // ordenamos el histograma largo.
    QuickSort_Decreciente(globs.HistoCF0[kEstrella]);

    {$IFDEF DEBUG_RESUMIR_HISTOGRAMA}
    if kEstrella = kEstrellaIni then
    begin
      writeln(flog, 'globs.HistoCF0[kEstrella] despues de sort');
      printvect(flog, globs.HistoCF0[kEstrella], 200);
    end;
    {$ENDIF}

    // resumimos el histograma corto.
    jbase := globs.NCronicasOpt div 2;
    CF_ve := 0;
    CF_VaR := 0;

    jPE := trunc(globs.NDiscHistoCF * globs.probLimiteRiesgo);
    if jPE > 0 then
    begin
      for jPuntoHisto := 0 to jPE - 1 do
      begin
        aval := globs.HistoCF0[kEstrella][jbase];
        CF_VaR := CF_VaR + aval;
        globs.HistoCF1_s[kEstrella][jPuntoHisto] := aval;
        jbase := jbase + globs.NCronicasOpt;
      end;
      CF_ve := CF_VaR;
      CF_VaR := CF_VaR / jPE;
      CF_VpE := aval;
    end;

    for jPuntoHisto := jPE to globs.NDiscHistoCF - 1 do
    begin
      aval := globs.HistoCF0[kEstrella][jbase];
      CF_ve := CF_ve + aval;
      globs.HistoCF1_s[kEstrella][jPuntoHisto] := aval;
      jbase := jbase + globs.NCronicasOpt;
    end;

    CF_ve := CF_ve / globs.NDiscHistoCF;

    // calculamos medidas a almacenar.

    if globs.CAR_CVaR then
      CF_Medida := CF_ve * (1 - globs.CAR) + CF_VaR * globs.CAR
    else
      CF_Medida := CF_ve * (1 - globs.CAR) + CF_VpE * globs.CAR;

    globs.CF.constelacion.set_costo_estrella(globs.kPaso_,
      kEstrella, CF_Medida);

    {$IFDEF DEBUG_RESUMIR_HISTOGRAMA}
    if kEstrella = kEstrellaIni then
    begin
      writeln(flog, 'globs.HistoCF1_s[kEstrella]');
      printvect(flog, globs.HistoCF1_s[kEstrella], 200);
      writeln(flog, 'CF_ve: ', #9, CF_ve);
      writeln(flog, 'CF_Medida: ', #9, CF_Medida);
      writeln(flog, 'CF_VaR: ', #9, CF_VaR);
      writeln(flog, 'CF_VpE: ', #9, CF_VpE);
      closefile(flog);
    end;
    {$ENDIF}

  end;
end;

{$ENDIF}

function TSalaDeJuego.CostoDelPaso_masCF_llegada_: NReal;
var
  costoDirectoDelPaso_Actores, costoDirectoDelPaso_Fuentes: NReal;
  utilidadDirectaDelPaso_Actores: NReal;

  CF_llegada: NReal;
  k: integer;

{$IFDEF DEBUG_OPTIMIZACION}
  archi_debug: string;
  f_debug: textfile;
  a_debug: TActor;
{$ENDIF}

begin
  costoDirectoDelPaso_Actores := 0;
  for k := 0 to high(Actores) do
    costoDirectoDelPaso_Actores :=
      costoDirectoDelPaso_Actores + Actores[k].costoDirectoDelPaso;

  // no me imagino fuentes con costo pero por las dudas ponemos
  costoDirectoDelPaso_Fuentes := 0;
  for k := 0 to lst_fuentes_costoDirectoDelPaso.Count - 1 do
    costoDirectoDelPaso_Fuentes :=
      costoDirectoDelPaso_Fuentes + TFuenteAleatoria(
      lst_fuentes_costoDirectoDelPaso[k]).costoDirectoDelPaso;

  utilidadDirectaDelPaso_Actores := 0.0;
  if globs.restar_UtilidadesDelCostoFuturo then
  begin
    for k := 0 to high(Actores) do
      utilidadDirectaDelPaso_Actores :=
        utilidadDirectaDelPaso_Actores + Actores[k].utilidadDirectaDelPaso;
  end;

  {$IFNDEF DEV_CF_ESTRELLA}
  ActualizarEstadoGlobal(true); // posicionamos la estrella de acuerdo al estado de los actores
  {$ELSE}
  ActualizarEstadoGlobal(false); // posicionamos la estrella de acuerdo al estado de los actores
  {$ENDIF}
  CF_llegada := globs.CF.costoContinuo(globs.kPaso_ + 1);

  {$IFDEF DEBUG_MULTI_HILO}
  writeln(fdebug_mh, 'estrella:'#9, globs.CF.ordinalEstrellaActual
    , #9'CActs:'#9, costoDirectoDelPaso_Actores, #9'CFuns: '#9,
    costoDirectoDelPaso_Fuentes, #9'CFLL'#9, CF_llegada, #9'XLL',
    globs.CF.GetEstado_XLT);
  {$ENDIF}

  {$IFDEF DEBUG_OPTIMIZACION}
  if globs.kPaso_ = 168 then
  begin
    archi_debug := getDir_Dbg + 'paso_' + IntToStr(globs.kPaso_) +
      '_e_' + IntToStr(globs.CF.ordinalEstrellaActual) + '_kCron_' +
      IntToStr(globs.kCronica) + '.txt';
    assignfile(f_debug, archi_debug);
    rewrite(f_debug);
    for k := 0 to high(Actores) do
    begin
      a_debug := Actores[k];
      Write(f_debug, a_debug.nombre, ', cdp: ', a_debug.costoDirectoDelPaso: 12: 2);
      if a_debug is TActorUninodal then
        Write(f_debug, ', P:', DAOfNRealToStr_(
          TActorUniNodal(a_debug).P, 12, 2, ';'));
      if a_debug is THidroConEmbalse then
      begin
        Write(f_debug, ', QA:', THidroConEmbalse(a_debug).QAportePropio: 12: 2);
        Write(f_debug, ', QT:', THidroConEmbalse(a_debug).QTurbinado: 12: 2);
        Write(f_debug, ', QV:', THidroConEmbalse(a_debug).QVertido: 12: 2);
        Write(f_debug, ', h:', THidroConEmbalse(a_debug).h_real: 12: 2);
      end;
      writeln(f_debug);
    end;
    closefile(f_debug);
  end;
  {$ENDIF}


  Result := costoDirectoDelPaso_Actores + costoDirectoDelPaso_Fuentes -
    utilidadDirectaDelPaso_Actores + globs.factPaso * CF_llegada;
end;




procedure TSalaDeJuego.InicializarOptimizacion_subproc01;
begin
  if not DirectoryExists(dirResultadosCorrida) then
    MkDir(dirResultadosCorrida);
  globs.invNCronicasOpt := 1 / globs.NCronicasOpt;
  globs.EstadoDeLaSala := CES_OPTIMIZANDO;
end;


function TSalaDeJuego.Preparar_CrearCF_y_regsitrar_variables_de_estado: integer;
var
  k: integer;
  dimX: integer;
begin
  Prepararse(False);
  optx_nvxs;
  dimX := ivar_xr + ivar_xd;
  if globs.CF <> nil then
    globs.CF.Free;
  if dimX > 0 then
  begin
    globs.CF := TAdminEstados.Create(ivar_xr, ivar_xd, globs.NPasos);
    //    globs.ActualizadorLPD.ActualizarFichasHasta( globs.fechaFin  );
    for k := 0 to high(actores) do
      actores[k].optx_RegistrarVariablesDeEstado(globs.CF);
    for k := 0 to high(fuentes_) do
      fuentes_[k].optx_RegistrarVariablesDeEstado(globs.CF);
  end;
  Result := dimX;
end;

function TSalaDeJuego.inicializarOptimizacion_subproc02(const salaMadre: TSalaDeJuego;
  const costoFuturo: TMatOfNReal): integer;
var
  k: integer;
  dimX: integer;
begin
  dimX := Preparar_CrearCF_y_regsitrar_variables_de_estado;
  Result := dimX;
  if dimX = 0 then
  begin
    globs.EstadoDeLaSala := CES_OPTIMIZACION_TERMINADA;
    exit; // si no hay variables de estado no optimizo nada y me voy
  end;

  Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
  Armar_lst_costoDirectoDelPaso;
  {$IFDEF MIPSimplex}
  spx := TMIPSimplex.Create_init(1, 1, 1, self.getNombreVar, self.getNombreRes);
  // solo para que est definido.
  {$ELSE}
  spx := TSimplex.Create_init(1, 1, self.getNombreVar, self.getNombreRes);
  // solo para que est definido.
  {$ENDIF}

  globs.CF.CrearElEspacioTiempo(globs.fechaIniOpt, globs.fechaFinOpt,
    globs.HorasDelPaso, costoFuturo, globs.Deterministico);

  if SalaMadre = nil then
  begin
    // Ahora creamos frames para las variables auxiliares
    setlength(globs.Auxs_r0, ivar_auxNReal);
    setlength(globs.Auxs_r1, ivar_auxNReal);
    for k := 0 to ivar_auxNReal - 1 do
    begin
      setlength(globs.Auxs_r0[k], globs.CF.constelacion.nEstrellas);
      setlength(globs.Auxs_r1[k], globs.CF.constelacion.nEstrellas);
      vclear(globs.Auxs_r0[k]);
      vclear(globs.Auxs_r1[k]);
    end;
    setlength(globs.Auxs_i0, ivar_auxInt);
    setlength(globs.Auxs_i1, ivar_auxInt);
    for k := 0 to ivar_auxInt - 1 do
    begin
      setlength(globs.Auxs_i0[k], globs.CF.constelacion.nEstrellas);
      setlength(globs.Auxs_i1[k], globs.CF.constelacion.nEstrellas);
      vclear(globs.Auxs_i0[k]);
      vclear(globs.Auxs_i1[k]);
    end;
    Globs.liberarAuxs := True;
  end
  else
  begin
    globs.Auxs_r0 := SalaMadre.globs.Auxs_r0;
    globs.Auxs_r1 := SalaMadre.globs.Auxs_r1;
    globs.Auxs_i0 := SalaMadre.globs.Auxs_i0;
    globs.Auxs_i1 := SalaMadre.globs.Auxs_i1;
    Globs.liberarAuxs := False;
  end;


  // fijamos la fecha del paso igual a la de inicio del ltimo paso
  globs.Fijar_kPaso(globs.nPasos);
  //prepararSalaParaPaso;
  globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);

  //globs.ActualizadorLPD.DumpListaToArchi('fichaslpd.txt');
  Armar_lst_EvolucionarEstado;
{$IFDEF ITERAR}
  Armar_lst_necesitoIterar;
{$ENDIF}


  if SalaMadre = nil then
  begin
{$IFDEF PERTURBADO}
    // Frame CERO EN CERO y un pendorcho
    globs.CF.constelacion.ClearUltimoFrame;
    globs.CF.posicionarseEnEstrella(2);
    globs.CF.SetCostoEstrella(globs.CF.high(costoFuturo), 1.0E7);
{$ELSE}
    if usarArchivoParaInicializarFrameInicial then
      globs.CF.InicializarFrameFinal(archivoCF_ParaEnganches.archi,
        // globs.fechaFinOpt,
        enganchesContinuos, enganchesDiscretos, enganchar_promediando_desaparecidas,
        uniformizar_promediando)
    else
      globs.CF.constelacion.ClearUltimoFrame;
{$ENDIF}

{$IFDEF ESTABILIZAR_FRAMEINICIAL}
    if (costoFuturo <> nil) and EstabilizarInicio then
      EstabilizarFrameInicial;
{$ENDIF}
  end;

{$IFDEF PDE_RIESGO}
  if globs.usar_CAR and globs.SortearOpt then
    Crear_HistogramasCF(SalaMadre);
{$ENDIF}
end;

function TSalaDeJuego.inicializarOptimizacion(const SalaMadre: TSalaDeJuego;
  const costoFuturo: TMatOfNReal): integer;
begin
  InicializarOptimizacion_subproc01;
  Result := InicializarOptimizacion_subproc02(SalaMadre, costoFuturo);
end;

{$IFDEF DUMP_TEXT_OPTRES}
procedure TSalaDeJuego.OptRes_Actores_WriteEstrella;
var
  kSalOpt: integer;
begin
  for kSalOpt := 0 to high(fsal_opt) do
  begin
    //                TActor(Self.lst_opt_PrintResultados.items[k]).PosicionarseEnEstrellita;
    //                TActor(Self.lst_opt_PrintResultados.items[k]).prepararPaso_ps;
    TActor(self.lst_opt_PrintResultados.Items[kSalOpt]).opt_PrintResultados(
      fsal_opt[kSalOpt]);
  end;
end;


procedure TSalaDeJuego.OptRes_Actores_WriteFecha;
var
  k: integer;
begin
  for k := 0 to high(fsal_opt) do
    Write(fsal_opt[k], IntToStr(globs.kPaso_) + #9 + globs.FechaInicioDelpaso.AsISOStr);
end;

procedure TSalaDeJuego.OptRes_Actores_WritelnFrame;
var
  k: integer;
begin
  for k := 0 to high(fsal_opt) do
    writeln(fsal_opt[k]);
end;

procedure TSalaDeJuego.OptRes_CF_WritelnFrame;
var
  NoFinBarridoEstrellas: boolean;
begin
  Write(fsal, IntToStr(globs.kPaso_) + #9 + globs.FechaInicioDelpaso.AsISOStr);
  globs.CF.setEstrellaCERO;
  NoFinBarridoEstrellas := True;
  while NoFinBarridoEstrellas do
  begin
    Write(fsal, #9, FloatToStrF(globs.CF.costoEstrella(globs.kPaso_),
      ffGeneral, 6, 2));
    NoFinBarridoEstrellas := globs.CF.incEstrella;
  end;
  writeln(fsal);
end;

{$ENDIF}


procedure TSalaDeJuego.OptimizacionCronizada_UnPaso_RangoDeEstrellas(
  estrellaIni, estrellaFin: integer; notificar: boolean; printActores_OptRes: boolean);

var
  kCron: integer;
  kEstrella: integer;
  CostoFuturo_cronica: NReal;

begin
  {$IFDEF PDE_RIESGO}
  if not (globs.usar_CAR) then
  {$ENDIF}
  begin
    // borro el frame pues lo voy a usar para acumular
    globs.CF.constelacion.ClearFrame_k_rango(globs.kPaso_, estrellaIni, estrellaFin);
  end;

  globs.ClearAuxs1(estrellaIni, estrellaFin);

  (* optimizacin CRONIZADA
  Para cada crnica realizamos sorteos y realizamos un barrido de los
  estados con el sorteo fijo. As vamos acumulando los costos del paso
  con cada sorteo para cada uno de los estados. Despus de haber realizado
  todos los sorteos-barridos_de_estado que queremos, realizamos un nuevo
  barrido_de_estado para promediar los valores acumulados.
  El orden en que se realiza esto es importante, pues es importante calcular con
  cada sorteo el costo para los diferentes estados. Los sorteos determinan
  las mquinas que estan disponibles, los aportes a los embalses y los
  recursos disponibles en general. Es importante que para un mismo conjunto
  de recursos disponibles se realice el barrido de los estados y luego con
  otro conjunto para salvaguardar la monotona esperable de los costos de
  una etapa respecto de las variables de estado.
  *)

  // esto ac no tendra que ser necesario a partir de que independizamos
  // las madres uniformes de sorteos.
  globs.fijarSemillaAleatoria_(globs.semilla_inicial_opt + globs.kPaso_);
  {$IFDEF DEBUG_MULTI_HILO}
  writeln(fdebug_mh, #9'RandSeed:'#9, globs.semilla_inicial_opt + globs.kPaso_);
  {$ENDIF}

  for kCron := 1 to globs.NCronicasOpt do
  begin
    globs.kCronica := kCron;
    if notificar then
      globs.procNot(globs.procNot_opt_InicioCronicaSorteos);

    SorteosDelPasoOpt(True);

    // Aqui hacemos el barrido de los estados
    // nos posicionamos en la primer estrella
    globs.CF.posicionarseEnEstrella(estrellaIni);
    for kEstrella := estrellaIni to estrellaFin do
    begin

      globs.CF.SetEstadoToEstrella; // Fijamos la estrella
      PosicionarseEnEstrellita;     // Fijamos el estado en los actores

     {$IFNDEF DEV_CF_ESTRELLA}
 //rch@201408261402 atencin!!!
 // agrego este Actualizar con Xs para que las derivadas de CF se calculen
 // en base al Xs proyectado
      ActualizarEstadoGlobal( true );
      {$ENDIF}

      Fuentes_PrepararPaso_ps;

{$IFDEF ITERAR}
      globs.cntIteracionesDelPaso := 0;
      repeat
        Inc(globs.cntIteracionesDelPaso);
{$ENDIF}

        Actores_PrepararPaso_ps;

        if notificar then
        {$IFDEF ITERAR}
          if globs.cntIteracionesDelPaso = 1 then
        {$ENDIF}
            globs.procNot(globs.procNot_opt_PrepararPaso_ps);


{$IFDEF DUMP_TEXT_OPTRES}
        if PrintActores_OptRes then
          if kCron = 1 then
{$IFDEF ITERAR}
            if globs.cntIteracionesDelPaso = 1 then
{$ENDIF}
              OptRes_Actores_WriteEstrella;
{$ENDIF}

        ResolverPaso;
{$IFDEF ITERAR}
      until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_OPT) or
        (not NecesitoIterar);
{$ENDIF}

      EvolucionarEstado;

{$IFDEF PDE_RIESGO}
      if globs.usar_CAR then
        LlenarHistograma_CostoDelPaso_masCF_llegada(
          globs.HistoCF0[globs.CF.ordinalEstrellaActual], (kCron - 1) *
          globs.NDiscHistoCF)
      else
{$ENDIF}
      begin
        CostoFuturo_cronica := CostoDelPaso_masCF_llegada_;

        globs.CF.AcumCostoEstrella(globs.kPaso_, CostoFuturo_Cronica *
          globs.invNCronicasOpt);
      end;

      Actores_AcumularAuxs1;

{$IFDEF MIPSimplex}
{$IFDEF SPXMEJORCAMINO}
      vswap(spx.mejorCaminoEsperado, spx.mejorCaminoEncontrado);
{$ENDIF}
{$ENDIF}
      globs.CF.incEstrella; // pasamos a la siguiente estrella
    end; // for de las estrellas
  end; // for de las crnicas

{$IFDEF PDE_RIESGO}
  if globs.usar_CAR then
  begin
    Resumir_HistogramaCF0aCF1(estrellaIni, estrellaFin);
    {$IFDEF DEBUG_HistoCF0CF1}
    Dump_HistogramasCF0CF1('pos', globs.kPaso_, 0);
    {$ENDIF}
  end;
{$ENDIF}
end;


procedure TSalaDeJuego.OptimizacionValorEsperado_UnPaso_RangoDeEstrellas(
  estrellaIni, estrellaFin: integer; notificar: boolean; printActores_OptRes: boolean);

var
  kEstrella: integer;
  CostoFuturo_Esperado: NReal;
begin

  globs.kCronica := 0; // ponemos a cero para que sea en valor esperado
  SorteosDelPasoOpt(False);
  // Aqui hacemos el barrido de los estados
  // nos posicionamos en la primer estrella

{$IFDEF OPT_VE_VERBOSA}
  writeln('TSalaDeJuego.OptimizacionValorEsperado_UnPaso_RangoDeEstrellas, kPaso: ',
    globs.kPaso_, ', dt: ', DateTimeToStr(now));
{$ENDIF}
  globs.CF.posicionarseEnEstrella(estrellaIni);
  for kEstrella := estrellaIni to estrellaFin do
  begin
    {$IFDEF OPT_VE_VERBOSA}
    writeln('kEstrella: ', kEstrella, ', dt: ', DateTimeToStr(now));
    {$ENDIF}

    // fijamos el estado
    globs.CF.SetEstadoToEstrella;
    PosicionarseEnEstrellita;// Fijamos el estado en los actores

    {$IFNDEF DEV_CF_ESTRELLA}
    //rch@201408261402 atencin!!!
    // agrego este Actualizar con Xs para que las derivadas de CF se calculen
    // en base al Xs proyectado
    ActualizarEstadoGlobal( true );
    {$ENDIF}

    Fuentes_PrepararPaso_ps;
  {$IFDEF ITERAR}
    globs.cntIteracionesDelPaso := 0;
    repeat
      Inc(globs.cntIteracionesDelPaso);
  {$ENDIF}
      Actores_PrepararPaso_ps;

      if notificar then
      {$IFDEF ITERAR}
        if globs.cntIteracionesDelPaso = 1 then
      {$ENDIF}
          globs.procNot(globs.procNot_opt_PrepararPaso_ps);

      ResolverPaso;
  {$IFDEF ITERAR}
    until (globs.cntIteracionesDelPaso >= globs.NMAX_ITERACIONESDELPASO_OPT) or
      (not NecesitoIterar);
  {$ENDIF}

    EvolucionarEstado;
    CostoFuturo_Esperado := CostoDelPaso_masCF_llegada_;
    globs.CF.SetCostoEstrella(globs.kPaso_, CostoFuturo_Esperado);
    Actores_SetAuxs1;

      {$IFDEF DUMP_TEXT_OPTRES}
    if PrintActores_OptRes then
      OptRes_Actores_WriteEstrella;
      {$ENDIF}

  {$IFDEF MIPSimplex}
  {$IFDEF SPXMEJORCAMINO}
    vswap(spx.mejorCaminoEsperado, spx.mejorCaminoEncontrado);
  {$ENDIF}
  {$ENDIF}
    globs.CF.incEstrella;
  end;// barrido estrellas
end;

procedure TSalaDeJuego.calcularRangoEstrellas(estrellaIni, estrellaFin: integer;
  notificar, printActoresOptRes: boolean);
begin
  globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);
  PrepararPaso_as;

  if notificar then
    globs.procNot(globs.procNot_opt_InicioCalculosDeEtapa);
  if globs.SortearOpt then // Clculo de los costos de la etapa con sorteos
  begin
    OptimizacionCronizada_UnPaso_RangoDeEstrellas(
      estrellaIni, estrellaFin, notificar, printActoresOptRes);
  end // fin de la optimizacin Cronizada
  else
  begin // optimizacin con valores esperados
    OptimizacionValorEsperado_UnPaso_RangoDeEstrellas(
      estrellaIni, estrellaFin, notificar, printActoresOptRes);
  end;

  if notificar then
    globs.procNot(globs.procNot_opt_FinCalculosDeEtapa);
end;




function TSalaDeJuego.genStrPasoCronEstrIter: string;//Optimizacion
begin
  if globs.CF <> nil then
  begin
  {$IFDEF ITERAR}
    Result := 'kpaso' + IntToStr(globs.kPaso_) + '_kCronica' +
      IntToStr(globs.kCronica) + '_kEstr' + IntToStr(globs.CF.ordinalEstrellaActual) +
      'kIter' + IntToStr(globs.cntIteracionesDelPaso);
  {$ELSE}
    Result := 'kpaso' + IntToStr(globs.kPaso_) + '_kCronica' +
      IntToStr(globs.kCronica) + '_kEstr' + IntToStr(globs.CF.ordinalEstrellaActual);
  {$ENDIF}
  end
  else
  begin
  {$IFDEF ITERAR}
    Result := 'kpaso' + IntToStr(globs.kPaso_) + '_kCronica' +
      IntToStr(globs.kCronica) + 'kIter' + IntToStr(globs.cntIteracionesDelPaso);
  {$ELSE}
    Result := 'kpaso' + IntToStr(globs.kPaso_) + '_kCronica' + IntToStr(globs.kCronica);
  {$ENDIF}
  end;
end;

function TSalaDeJuego.genStrCronPasoIter: string;//Simulacion
begin
{$IFDEF ITERAR}
  Result := 'kCronica' + IntToStr(globs.kCronica) + '_kpaso' +
    IntToStr(globs.kPaso_) + 'kIter' + IntToStr(globs.cntIteracionesDelPaso);
{$ELSE}
  Result := 'kCronica' + IntToStr(globs.kCronica) + '_kpaso' + IntToStr(globs.kPaso_);
{$ENDIF}
end;


function TSalaDeJuego.getRangoEstrellasCF(estrellaIni, estrellaFin,
  paso: integer): TDAOfNReal;

var
  res: TDAofNReal;
begin
  SetLength(res, estrellaFin - estrellaIni + 1);
  vcopyTramoDesplazando(res, 0, globs.CF.constelacion.fCosto[paso],
    estrellaIni, estrellaFin - estrellaIni + 1);
  Result := res;
end;

function TSalaDeJuego.getRangoEstrellasAux_r1(estrellaIni, estrellaFin:
  integer): TDAOfDAofNReal;
var
  n, m: integer;
  res: TDAOfDAofNReal;
  i: integer;
begin

  n := Length(globs.Auxs_r1);
  m := estrellaFin - estrellaIni + 1;
  if ((n <> 0) and (m <> 0)) then
  begin
    SetLength(res, n);
    for i := 0 to n - 1 do
    begin
      SetLength(res[i], m);
      vcopyTramoDesplazando(res[i], 0, globs.Auxs_r1[i], estrellaIni, m);
    end;
  end;
  Result := res;
end;

function TSalaDeJuego.getRangoEstrellasAux_i1(estrellaIni, estrellaFin:
  integer): TDAOfDAOfNInt;
var
  n, m: integer;
  res: TDAOfDAOfNInt;
  i: integer;
begin

  n := Length(globs.Auxs_i1);
  m := estrellaFin - estrellaIni + 1;
  if ((n <> 0) and (m <> 0)) then
  begin
    SetLength(res, n);
    for i := 0 to n - 1 do
    begin
      SetLength(res[i], m);
      vcopyTramoDesplazando(res[i], 0, globs.Auxs_i1[i], estrellaIni, m);
    end;
  end;
  Result := res;
end;

procedure TSalaDeJuego.setRangoEstrellasCF(estrellaIni: integer;
  tramoCostosFuturo: TDAOfNReal; kpaso: integer);
begin
  vcopyTramoDesplazando(globs.CF.constelacion.fCosto[kpaso],
    estrellaIni, tramoCostosFuturo, 0, Length(tramoCostosFuturo));
end;

procedure TSalaDeJuego.setRangoEstrellasAux_r1(estrellaIni: integer;
  tramoAux_r1: TDAOfDAofNReal);
var
  n: integer;
  i: integer;
begin
  n := Length(tramoAux_r1);
  if n <> 0 then
    for i := 0 to n - 1 do
      vcopyTramoDesplazando(globs.Auxs_r1[i],
        estrellaIni, tramoAux_r1[i], 0, Length(tramoAux_r1[i]));
end;

procedure TSalaDeJuego.setRangoEstrellasAux_i1(estrellaIni: integer;
  tramoAux_i1: TDAOfDAOfNInt);
var
  n: integer;
  i: integer;
begin
  n := Length(tramoAux_i1);
  if n <> 0 then
    for i := 0 to n - 1 do
      vcopyTramoDesplazando(globs.Auxs_i1[i],
        estrellaIni, tramoAux_i1[i], 0, Length(tramoAux_i1[i]));
end;

function TSalaDeJuego.irAPaso(nuevoPaso: integer): integer;
begin
  if globs.EstadoDeLaSala = CES_OPTIMIZANDO then
  begin
    if globs.kPaso_ > nuevoPaso then
    begin
      globs.Fijar_kPaso(nuevoPaso);
      globs.procNot(globs.procNot_opt_FinCalculosDeEtapa);
      Result := 1;
    end
    else if globs.kpaso_ = nuevoPaso then
      Result := 2
    else
      Result := 0;
  end
  else
    Result := 10; //cualquiera para que de resultado******

end;

function TSalaDeJuego.llenarRangoDeEstrellasYDarPaso(estrellasIni: TDAofNInt;
  costosFuturos: TDAOfDAOfNReal; kpaso: integer): integer;
var
  i: integer;
begin
  if globs.kPaso_ >= kpaso then
  begin
    for i := 0 to high(estrellasIni) do
      vcopyTramoDesplazando(globs.CF.constelacion.fCosto[kPaso],
        estrellasIni[i], costosFuturos[i], 0, Length(costosFuturos[i]));
  end;
  Result := irAPaso(kpaso - 1);
end;

procedure TSalaDeJuego.darPaso;
begin
  self.globs.kPaso_ := self.globs.kPaso_ - 1;
end;

procedure TSalaDeJuego.Optimizar(llenarConFrameFinal: boolean);
var
  NoFinBarridoEstrellas: boolean;

  procedure wrtilen(s: string);
  begin
    system.writeln(s);
  end;

begin

  inicializarOptimizacion_subproc01;
{$IFDEF DUMP_TEXT_OPTRES}
  fsalopen := False;
{$ENDIF}
  try
    try
      (****** INICIALIZAR OPTIMIZACION ************)
      if inicializarOptimizacion_subproc02(nil, nil) = 0 then
        exit; // No hay variables de estado = no hay optimizacin

{$IFDEF DUMP_TEXT_OPTRES}
      inicializarArchisOptRes(fsal, fsal_opt, fsalopen);
{$ENDIF}
      if not DirectoryExists(dirResultadosCorrida) then
        MkDir(dirResultadosCorrida);

      globs.procNot(globs.procNot_opt_InicioOptimizacion);

      if LlenarConFrameFinal then
        globs.CF.LlenarConFrameFinal
      else
        // Barrido de los pasos en reversa
        while (globs.kPaso_ > 0) and (not globs.abortarSim) do
        begin
        {$IFDEF DUMP_TEXT_OPTRES}
          OptRes_Actores_WriteFecha;
        {$ENDIF}

          //prepararSalaParaPaso;
          globs.ActualizadorLPD.ActualizarFichasHasta(globs.FechaInicioDelpaso);
          PrepararPaso_as;
          globs.procNot(globs.procNot_opt_InicioCalculosDeEtapa);

          if globs.SortearOpt then // Clculo de los costos de la etapa con sorteos
          begin
            OptimizacionCronizada_UnPaso_RangoDeEstrellas(
              0, globs.CF.nEstrellasPorPuntoT - 1, True, True);
          end // fin de la optimizacin Cronizada
          else
          begin // incio: optimizacin con valores esperados
            OptimizacionValorEsperado_UnPaso_RangoDeEstrellas(
              0, globs.CF.nEstrellasPorPuntoT - 1, True, True);
          end;
        {$IFDEF DUMP_TEXT_OPTRES}
          OptRes_CF_WritelnFrame;
          OptRes_Actores_WritelnFrame;
        {$ENDIF}
          globs.Fijar_kPaso(globs.kPaso_ - 1);
          globs.SwapAuxs;
          globs.procNot(globs.procNot_opt_FinCalculosDeEtapa);
        end; // while del paso

      FinOptimizacion;
    finally

{$IFDEF PDE_RIESGO}
      if globs.usar_CAR and globs.SortearOpt then
        Liberar_HistogramasCF(nil);
{$ENDIF}

{$IFDEF DUMP_TEXT_OPTRES}
      cerrarArchisOptRes(fsal, fsal_opt, fsalopen);
{$ENDIF}
    end;
    if not globs.abortarSim then
    begin
      globs.EstadoDeLaSala := CES_OPTIMIZACION_TERMINADA;
    end
    else
      globs.EstadoDeLaSala := CES_OPTIMIZACION_ABORTADA;
  except
    globs.EstadoDeLaSala := CES_OPTIMIZACION_ABORTADA;
    raise;
  end;
end;


{$IFDEF PSO_ENZO}
procedure TSalaDeJuego.OptimizarDeterministica;
const
  Num_particulas: integer = 10;
  Num_iteraciones: integer = 200;
  fact_perturbacion: NReal = 0.001;
  dimensiones: integer = 2;
  valmaxX: NReal = 10;
  valminX: NReal = -10;
  valmaxV: NReal = 10;
  valminV: NReal = -10;
  uw: double = 0.729;
  uc1: double = 1.49445;
  uc2: double = 1.49445;

var
  NoFinBarridoEstrellas: boolean;
  u, us: TDAOfNReal;
  c, cs: NReal;
  K: NReal;
  flg_optimizando: boolean;
  largo_u: integer;

  i, j: integer;
  uminX, umaxX, uminV, umaxV: TDAofNReal;
  mejor, ur1, ur2: NReal;
  indice_mejor: integer;
  mejor_pos: TDAofNReal;
  cumulo: array of particula;

begin
  inicializarOptimizacion_subproc01;
  if inicializarOptimizacion_subproc02(nil, nil) = 0 then
    exit; // No hay variables de estado = no hay optimizacin

  u := GLobs.CF.ControladorDeterministico.create_vect_u;
  largo_u := length(u);
  vclear(u);

  setlength(cumulo, Num_particulas + 1);
  setlength(uminX, largo_u);
  setlength(umaxX, largo_u);
  setlength(uminV, largo_u);
  setlength(umaxV, largo_u);
  setlength(mejor_pos, largo_u);

  // cargo limites inferiores y superiores
  for i := 0 to largo_u - 1 do
  begin
    uminX[i] := valminX;
    umaxX[i] := valmaxX;
    uminV[i] := valminV;
    umaxV[i] := valmaxV;
  end;

  // primera evaluacion de f(u)
  GLobs.CF.ControladorDeterministico.set_vect_u(u);
  c := Simular(0, False);
  mejor := c;
  writeln('mejor_c: ', mejor);

  K := 0.0;
  while flg_optimizando do
  begin
    // cargo el cumulo de particulas y cargo fitness
    for i := 1 to Num_particulas do
    begin
      cumulo[i] := particula.Create(uminX, umaxX, uminV, umaxV);
      vcopy(u, cumulo[i].posicion);
      GLobs.CF.ControladorDeterministico.set_vect_u(u);
      c := Simular(0, False);
      writeln('i: ', i, ', c: ', c);
      cumulo[i].fitness := c;
      cumulo[i].mejorfitness := c;
      if c < mejor then
      begin
        mejor := c;
        indice_mejor := i;
        vcopy(mejor_pos, cumulo[i].posicion);
        vcopy(cumulo[i].mejorposicion, cumulo[i].posicion);
        vcopy(u, cumulo[i].posicion);
        cumulo[i].mejorfitness := c;
      end;
    end;

    writeln('mejor_c: ', mejor);

    // evaluar
    // f(u)
    GLobs.CF.ControladorDeterministico.set_vect_u(u);
    c := Simular(0, False);
    for j := 0 to Num_iteraciones do
    begin
      for i := 1 to Num_particulas do
      begin
        randomize;
        ur1 := Call_UNI;
        ur2 := Call_UNI;
        if j < Num_iteraciones * 3 / 4 then
          cumulo[i].perturbar(fact_perturbacion, uminX, umaxX);
        cumulo[i].calcular_velocidad(uw, uc1, uc2, ur1, ur2, uminV, umaxV, mejor_pos);
        cumulo[i].calcular_posicion(uminX, umaxX);
        vcopy(u, cumulo[i].posicion);
        GLobs.CF.ControladorDeterministico.set_vect_u(u);
        c := Simular(0, False);

        writeln('j: ', j, ', i: ', i, ', c: ', c);
        cumulo[i].fitness := c;
        if c < cumulo[i].mejorfitness then
        begin
          cumulo[i].mejorfitness := c;
          vcopy(cumulo[i].mejorposicion, cumulo[i].posicion);
        end;

        if c < mejor then
        begin
          mejor := c;
          indice_mejor := i;
          vcopy(mejor_pos, cumulo[i].posicion);
          writeln('mejor_c: ', mejor);
        end;
      end;
    end;
    flg_optimizando := False;
    vcopy(u, mejor_pos);
  end;
  writeln('mejor_c: ', mejor);
  for i := 0 to largo_u - 1 do
    writeln('u_', IntToStr(i), ': ', floattostr(u[i]));

  for i := 1 to Num_particulas do
  begin
    cumulo[i].Free;
  end;

  setlength(cumulo, 0);
  setlength(uminX, 0);
  setlength(umaxX, 0);
  setlength(uminV, 0);
  setlength(umaxV, 0);
  setlength(mejor_pos, 0);
end;

{$ELSE}
procedure TSalaDeJuego.OptimizarDeterministica;
var
  NoFinBarridoEstrellas: boolean;
  u, us, Agite: TDAOfNReal;
  c, cs: NReal;
  flg_optimizando: boolean;
  cnt_fracasos_seguidos: TDAOfNInt;
  largo_u: integer;
  rnd: TMadreUniforme;
  j: integer;
  vma: NReal;
  jIter: integer;

  // retorna la posicin de mximo agite aleatoria entre los que sean
  // iguales
  function pos_max_agite: integer;
  var
    k, j: integer;
    m, ma: NReal;
  begin
    k := 0;
    m := Agite[0];
    for j := 1 to high(Agite) do
    begin
      ma := Agite[j];
      if ma > m then
      begin
        m := ma;
        k := j;
      end
      else
      if (m = ma) and (rnd.rnd > 0.5) then
        k := j;

    end;
    Result := k;
  end;

begin
  rnd := TMadreUniforme.Create(31);
  inicializarOptimizacion_subproc01;
  if inicializarOptimizacion_subproc02(nil, nil) = 0 then
    exit; // No hay variables de estado = no hay optimizacin

  u := GLobs.CF.ControladorDeterministico.create_vect_u;
  largo_u := length(u);
  setlength(us, largo_u);
  setlength(Agite, largo_u);
  setlength(cnt_fracasos_seguidos, largo_u);
  vclear(u);

  // primera evaluacion de f(u)
  GLobs.CF.ControladorDeterministico.set_vect_u(u);
  c := Simular(0, False);



  // copiamos el vector para trabajar con us
  vcopy(us, u);


  for jIter := 1 to 3 do
  begin

    for j := 0 to high(Agite) do
    begin
      Agite[j] := 1000;
      cnt_fracasos_seguidos[j] := 0;
    end;

    flg_optimizando := True;
    while flg_optimizando do
    begin
      // selecciono al asar una direccin en al que probar
      j := rnd.randomIntRange(0, high(u));
      while Agite[j] < 1e-1 do
        j := rnd.randomIntRange(0, high(u));

      //    j:= pos_max_agite;
      us[j] := u[j] + (rnd.rnd - 0.5) * Agite[j];

      GLobs.CF.ControladorDeterministico.set_vect_u(us);
      cs := Simular(0, False);
      if cs < c then
      begin
        // tuve xito cambio u y c y reseteo el contador de fracasos
        u[j] := us[j];
        c := cs;
        writeln;
        writeln('c: ', c, ' cnt_fracasos_seguidos: ', cnt_fracasos_seguidos[j],
          ', j: ', j);
        cnt_fracasos_seguidos[j] := 0;
      end
      else
      begin
        // fracaso, vuelvo a la posicin original e incremento el nmero
        // de fracasos
        us[j] := u[j];
        Inc(cnt_fracasos_seguidos[j]);
        if cnt_fracasos_seguidos[j] > 5 then
        begin
          Agite[j] := Agite[j] / 2.0;
          vma := vmax(Agite);
          Write('| ', vma);
          cnt_fracasos_seguidos[j] := 0;
          if vma < 1e-1 then
            flg_optimizando := False;
        end;
      end;
    end;

  end;
  rnd.Free;

end;

procedure TSalaDeJuego.CrearYGuardarControladorDeterministicoInicial;
begin
  inicializarOptimizacion_subproc01;
  if inicializarOptimizacion_subproc02(nil, nil) = 0 then
    exit; // No hay variables de estado = no hay optimizacin
end;

{$ENDIF}


procedure TsalaDeJuego.inicializarArchisOptRes(var fsal: TextFile;
  var fsal_opt: TDAOfTextFile; var fsalopen: boolean);
var
  archi: string;
  k: integer;
  NoFinBarridoEstrellas: boolean;
begin
  if globs.SortearOpt then
    archi := dirResultadosCorrida + 'optres_' + IntToStr(
      globs.semilla_inicial_opt) + 'x' + IntToStr(globs.NCronicasOpt) +
      '_' + EscenarioActivo.nombre + '.xlt'
  else
    archi := dirResultadosCorrida + 'optres_VE' + '_' + EscenarioActivo.nombre + '.xlt';
  assignfile(fsal, archi);
  {$I-}
  rewrite(fsal);
  {$I+}
  if ioresult <> 0 then
    raise Exception.Create('No es posible crear el archivo: ' + archi);
  fsalopen := True;


  if escribirOptActores then
  begin
    Armar_lst_opt_PrintResultados;
    // aqu ya podemos detectar cuantos hay en lst_PrintResultadosOpt
    setlength(fsal_opt, lst_opt_PrintResultados.Count);
    for k := 0 to high(fsal_opt) do
    begin
      if globs.SortearOpt then
        archi := dirResultadosCorrida + 'opt' +
          TActor(lst_opt_PrintResultados.items[k]).nombre + '_' +
          IntToStr(globs.semilla_inicial_opt) + 'x' +
          IntToStr(globs.NCronicasOpt) + '_' + EscenarioActivo.nombre + '.xlt'
      else
        archi := dirResultadosCorrida + 'opt' +
          TActor(lst_opt_PrintResultados.items[k]).nombre + '_VE' +
          '_' + EscenarioActivo.nombre + '.xlt';
      assignfile(fsal_opt[k], archi);
      rewrite(fsal_opt[k]);
    end;
  end
  else
  begin
    SetLength(fsal_opt, 0);
    Armar_lst_opt_PrintResultados;
    for k := 0 to lst_opt_PrintResultados.Count - 1 do
    begin
      if globs.SortearOpt then
        archi := dirResultadosCorrida + 'opt' +
          TActor(lst_opt_PrintResultados.items[k]).nombre + '_' +
          IntToStr(globs.semilla_inicial_opt) + 'x' +
          IntToStr(globs.NCronicasOpt) + '_' + EscenarioActivo.nombre + '.xlt'
      else
        archi := dirResultadosCorrida + 'opt' +
          TActor(lst_opt_PrintResultados.items[k]).nombre + '_VE' +
          '_' + EscenarioActivo.nombre + '.xlt';
      DeleteFile(PChar(archi));
    end;
    lst_opt_PrintResultados.Clear;
  end;

  system.Writeln(fsal, 'Versin del simulador:'#9, vSimSEESimulador);
  for k := 0 to high(fsal_opt) do
    writeln(fsal_opt[k], 'Versin del simulador:'#9, vSimSEESimulador);
  writeln(fsal, 'fActPaso: '#9, FloatToStrF(globs.fActPaso, ffGeneral, 12, 10));
  for k := 0 to high(fsal_opt) do
    writeln(fsal_opt[k], 'fActPaso:'#9, FloatToStrF(globs.fActPaso,
      ffGeneral, 12, 10));
  globs.CF.constelacion.PrintDefsToText(fsal, True);
  for k := 0 to high(fsal_opt) do
    globs.CF.constelacion.PrintDefsToText(fsal_opt[k], False);

  Write(fsal, 'paso\estado'#9'Fecha');
  for k := 1 to globs.CF.nEstrellasPorPuntoT do
    Write(fsal, #9, k);
  writeln(fsal);

  // salvamos el frame del ltimo paso de tiempo
  globs.Fijar_kPaso(globs.kPaso_ + 1);
  Write(fsal, IntToStr(globs.kpaso_) + #9 + globs.FechaInicioDelpaso.AsISOStr);
  globs.Fijar_kPaso(globs.kPaso_ - 1);
  for k := 0 to high(fsal_opt) do
    Write(fsal_opt[k], 'paso\estado'#9'Fecha');

  globs.CF.setEstrellaCERO;
  NoFinBarridoEstrellas := True;
  while NoFinBarridoEstrellas do
  begin
    globs.CF.SetEstadoToEstrella; // Fijamos la estrella
    Write(fsal, #9, FloatToStrF(globs.CF.costoEstrella(globs.kPaso_ + 1)
      , ffGeneral, 6, 2));
    for k := 0 to high(fsal_opt) do
    begin
      TActor(Self.lst_opt_PrintResultados.items[k]).PosicionarseEnEstrellita;
      TActor(Self.lst_opt_PrintResultados.items[k]).prepararPaso_ps;
      TActor(Self.lst_opt_PrintResultados.items[k]).opt_PrintResultados_Encab(
        fsal_opt[k]);
    end;
    NoFinBarridoEstrellas := globs.CF.incEstrella;
  end;// barrido estrellas
  writeln(fsal);
  for k := 0 to high(fsal_opt) do
    writeln(fsal_opt[k]);
end;

procedure TsalaDeJuego.escribirPasoOptRes(var fsal: TextFile;
  var fsal_opt: TDAOfTextFile);
var
  k: integer;
  NoFinBarridoEstrellas: boolean;
begin
  writeln(fsal, IntToStr(globs.kPaso_) + #9 + globs.FechaInicioDelpaso.AsISOStr,
    #9, TDAOfNRealToTabbedString(globs.cf.constelacion.fcosto[globs.kpaso_], 6, 2));

  if escribirOptActores then
  begin
    for k := 0 to high(fsal_opt) do
      Write(fsal_opt[k], IntToStr(globs.kPaso_) + #9 +
        globs.FechaInicioDelpaso.AsISOStr);
    vclear(globs.CF.estrella_kr);
    vclear(globs.CF.estrella_kd);
    NoFinBarridoEstrellas := True;
    while NoFinBarridoEstrellas do
    begin
      globs.CF.SetEstadoToEstrella;
      PosicionarseEnEstrellita;
      for k := 0 to high(fsal_opt) do
      begin
        TActor(Self.lst_opt_PrintResultados.items[k]).PosicionarseEnEstrellita;
        TActor(Self.lst_opt_PrintResultados.items[k]).prepararPaso_ps;
        TActor(Self.lst_opt_PrintResultados.items[k]).opt_PrintResultados(fsal_opt[k]);
      end;
      NoFinBarridoEstrellas := globs.CF.incEstrella;
    end;
    for k := 0 to high(fsal_opt) do
      writeln(fsal_opt[k]);
  end;
end;

procedure TsalaDeJuego.cerrarArchisOptRes(var fsal: TextFile;
  var fsal_opt: TDAOfTextFile; var fsalopen: boolean);
var
  k: integer;
begin
  if fsalopen then
  begin
    for k := 0 to high(fsal_opt) do
      closeFile(fsal_opt[k]);
    if fsalopen then
      closeFile(fsal);
  end;
end;

procedure TSalaDeJuego.printEncabezadoSimRes(var f: TextFile);
var
  iposteres, kactorres: integer;
begin
  system.Writeln(f, 'Versin del simulador:'#9, vSimSEESimulador);
  system.writeln(f, 'Inicio simulacin: '#9, DateTimeToIsoStr(now()));
  system.Writeln(f, 'FechaIniSim:'#9, globs.fechaIniSim.AsISOStr,
    #9'FechaFinSim:'#9, globs.fechaFinSim.AsISOStr);
  system.writeln(f, 'NCronicas:'#9, globs.NCronicasSim);
  system.writeln(f, 'NPasos:'#9, globs.nPasos);
  system.writeln(f, 'NPostes:'#9, length(globs.Durpos));
  system.Write(f, 'DurPos[h]:');
  for iposteres := 0 to high(globs.DurPos) do
    Write(f, #9, globs.DurPos[iposteres]);
  system.writeln(f);
  system.writeln(f, 'NActores:'#9, length(actores));

  TActor.printEncabezadoResumenSim(f);
  for kactorres := 0 to high(actores) do
    actores[kactorres].printResumenSim(f);
end;

procedure TSalaDeJuego.printFinalSimRes(var f: TextFile);
begin
  system.writeln(f, 'Fin simulacin:'#9, DateTimeToIsoStr(now()));
end;

{$IFDEF ESTABILIZAR_FRAMEINICIAL}
procedure TSalaDeJuego.EstabilizarFrameInicial;
const
  MAX_CANT_ITERS = 100;
var
  NoFinBarridoEstrellas: boolean;

  //cociente sera costok+1/costok
  cociente: NReal;
  maxCociente: NReal;
  CostoFuturo_Esperado, CostoDelPaso_Simplex: NReal;
  //  CF_Base: NReal;
  cntIters: integer;
  stop: boolean;
begin
  cntIters := 0;
  stop := False;
  globs.kCronica := 0;
  while (not stop) and (cntIters < MAX_CANT_ITERS) do
  begin
    maxCociente := -MaxNReal;
    //PosicionarseEnPrimerEstrella
    vclear(globs.CF.estrella_kr);
    vclear(globs.CF.estrella_kd);
    NoFinBarridoEstrellas := True;

    PrepararPaso_PreSorteo;
    SorteosDelPasoOpt(False);
    while NoFinBarridoEstrellas do
    begin
      // fijamos el estado
      globs.CF.SetEstadoToEstrella;
      barridoFijarEstadoDeActoresYFuentesToEstrellaOpt;// Fijamos el estado en los actores

      //      CF_Base:= globs.CF.costoEstrella(globs.kPaso_+1);

{$IFDEF ITERAR}
      globs.cntIteracionesDelPaso := 0;
      repeat
        Inc(globs.cntIteracionesDelPaso);
{$ENDIF}
        PrepararPaso_PostSorteo;
        CostoDelPaso_Simplex := ResolverPaso;
{$IFDEF ITERAR}
      until (globs.cntIteracionesDelPaso >= NMAX_ITERACIONESDELPASO) or
        (not NecesitoIterar);
{$ENDIF}
      EvolucionarEstado;

      CostoFuturo_Esperado := CostoDelPaso_masCF_llegada;

      globs.CF.SetCostoEstrella(globs.kPaso_, CostoFuturo_Esperado);
      Actores_SetAuxs1;
      globs.SwapAuxs;
{$IFDEF MIPSimplex}
{$IFDEF SPXMEJORCAMINO}
      vswap(spx.mejorCaminoEsperado, spx.mejorCaminoEncontrado);
{$ENDIF}
{$ENDIF}
      NoFinBarridoEstrellas := globs.CF.incEstrella;

      if CF_Base <> 0 then
        cociente := CostoFuturo_Esperado / CF_Base
      else
        cociente := MaxNReal;

      if cociente > maxCociente then
        maxCociente := cociente;
    end;// barrido estrellas

    vswap(globs.CF.constelacion.fCosto[globs.kPaso_],
      globs.CF.constelacion.fCosto[globs.kPaso_ + 1]);
    if (maxCociente < 1.05) and (maxCociente > 0.95) then
      stop := True;
    Inc(cntIters);
  end;
  if not stop then
    globs.Alerta(Self.Nombre + ': Estabilizar frame inicial no convergio');
end;

{$ENDIF}

procedure AlInicio;
begin
  registrarClaseDeCosa(TSalaDeJuego.ClassName, TSalaDeJuego);
end;

procedure AlFinal;
begin
end;

end.
